// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "fig_hline.h"

#include "selection_move.h"

#include "drawing/drawable.h"

#include "foundation/macros.h"

namespace Diagram {

    FigHLine::FigHLine(Object * owner) : Fig(owner) {
    }

    FigHLine::~FigHLine() {
    }

    void
    FigHLine::paint(Drawing::Drawable * drawable) const {
	ASSERT(!is_filled());

	drawable->set_color(get_line_color());
	drawable->draw_line(Drawing::Point(mBounds.get_x(), mBounds.get_y()),
			    Drawing::Point(mBounds.get_xw() - 1, mBounds.get_y()));
    }

    Selection *
    FigHLine::create_selection() {
	return new SelectionMove(this);
    }

    void
    FigHLine::resize(const Drawing::Vector & size) {
	ERROR("Don't resize FigHLines");
    }

    void
    FigHLine::set_width(int w) {
	mBounds.set_w(w);
	mBounds.set_h(1);
    }

} // namespace Diagram
