// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "fig_poly_line.h"

#include "drawing/drawable.h"

namespace Diagram {

    FigPolyLine::FigPolyLine() : FigPoly() {
    }

    FigPolyLine::~FigPolyLine() {
    }

    void
    FigPolyLine::paint(Drawing::Drawable * drawable) const {
	if(is_filled()) {
	    drawable->set_color(get_fill_color());
	    drawable->draw_polygon(mPoints, true);
	}
	else {
	    drawable->set_color(get_line_color());
	    drawable->set_line_style(get_line_style());
	    drawable->draw_lines(mPoints);
	}
    }

} // namespace Diagram
