// This code is a modified port of GEF (Graphical Editing Framework)
// http://gef.tigris.org/
// GEF is copyrighted by the Regents of the University of California

// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DIAGRAM_LAYER_DIAGRAM_H
#define DIAGRAM_LAYER_DIAGRAM_H

#include "layer.h"

namespace Diagram {

    class LayerDiagram : public Layer {
    public:
	LayerDiagram();
	~LayerDiagram();

	Fig * get_presentation_for(Object * object);

	void add(Fig * fig);
	void remove(Fig * fig);
	void clear();

	Fig * hit(const Drawing::Rectangle & rect);
	Fig * hit_not(const Drawing::Rectangle & rect, Fig * disregard);

	const list<Fig *> & get_figs();

	void send_to_back(Fig * fig);
	void send_backward(Fig * fig);
	void send_behind(Fig * f1, Fig * f2);
	void bring_forward(Fig * fig);
	void bring_to_front(Fig * fig);
	void bring_in_front_of(Fig * f1, Fig * f2);

	void paint(Drawing::Drawable * drawable) const;

    private:
	list<Fig *> mFigs;
    };

} // namespace Diagram

#endif // DIAGRAM_LAYER_DIAGRAM_H
