// This code is a modified port of GEF (Graphical Editing Framework)
// http://gef.tigris.org/
// GEF is copyrighted by the Regents of the University of California

// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DIAGRAM_LAYER_PERSPECTIVE_H
#define DIAGRAM_LAYER_PERSPECTIVE_H

#include "layer_diagram.h"

#include "graph/listener.h"

namespace Graph {

    class Model;

} // namespace Graph

namespace Diagram {

    class Renderer;

    class LayerPerspective : public LayerDiagram, public Graph::Listener {
    public:
	LayerPerspective(Graph::Model * graph_model, Renderer * renderer);
	~LayerPerspective();

	void set_graph_model(Graph::Model * graph_model);
	Graph::Model * get_graph_model() { return mModel; }

	void set_renderer(Renderer * renderer);
	Renderer * get_renderer() { return mRenderer; }

	void node_added(const Graph::Event * graph_event);
	void node_changed(const Graph::Event * graph_event);
	void node_removed(const Graph::Event * graph_event);

	void edge_added(const Graph::Event * graph_event);
	void edge_changed(const Graph::Event * graph_event);
	void edge_removed(const Graph::Event * graph_event);

    protected:
	Graph::Model * mModel;
	Renderer * mRenderer;

    private:
    };

} // namespace Diagram

#endif // DIAGRAM_LAYER_PERSPECTIVE_H
