// This code is a modified port of GEF (Graphical Editing Framework)
// http://gef.tigris.org/
// GEF is copyrighted by the Regents of the University of California

// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DIAGRAM_MODE_CREATE_H
#define DIAGRAM_MODE_CREATE_H

#include "mode.h"

#include "drawing/point.h"

namespace Toolkit {

    class MouseEvent;

} // namespace Toolkit

namespace Diagram {

    class Fig;

    class ModeCreate : public Mode {
    public:
	ModeCreate();

	bool mouse_pressed(const Toolkit::MouseEvent * mouse_event);
	bool mouse_dragged(const Toolkit::MouseEvent * mouse_event);
	bool mouse_released(const Toolkit::MouseEvent * mouse_event);

	virtual Fig * create_new_item(const Toolkit::MouseEvent * mouse_event,
				      const Drawing::Point & point) = 0;

	void paint(Drawing::Drawable * drawable) const;

	void cancel();

    protected:
	~ModeCreate();

	Fig * mNewItem;

    private:
	void update_new_item(const Toolkit::MouseEvent * mouse_event);

	Drawing::Point mAnchor;
	static Drawing::Vector mDefaultSize;
    };

} // namespace Diagram

#endif // DIAGRAM_MODE_CREATE_H
