// This code is a modified port of GEF (Graphical Editing Framework)
// http://gef.tigris.org/
// GEF is copyrighted by the Regents of the University of California

// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DIAGRAM_MODE_CREATE_FIG_H
#define DIAGRAM_MODE_CREATE_FIG_H

#include "mode_create.h"

#include "toolkit/mouse_event.h"

namespace Diagram {

    template<class T>
    class ModeCreateFig : public ModeCreate {
    public:
	ModeCreateFig();

	Fig * create_new_item(const Toolkit::MouseEvent * mouse_event,
			      const Drawing::Point & point);
	string get_instructions() const;

    protected:
	~ModeCreateFig();
    };

    template<class T>
    ModeCreateFig<T>::ModeCreateFig() : ModeCreate() {
    }

    template<class T>
    ModeCreateFig<T>::~ModeCreateFig() {
    }

    template<class T>
    Fig *
    ModeCreateFig<T>::create_new_item(const Toolkit::MouseEvent * mouse_event,
				      const Drawing::Point & point) {
	T * t = new T();
        t->relocate(point);
        t->resize(Drawing::Vector(1, 1));
	return t;
    }

    template<class T>
    string
    ModeCreateFig<T>::get_instructions() const {
	return "Drag to create item";
    }

} // namespace Diagram

#endif // DIAGRAM_MODE_CREATE_FIG_H
