// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DIAGRAM_MODE_CREATE_FIG_POLY_H
#define DIAGRAM_MODE_CREATE_FIG_POLY_H

#include "mode_create.h"

#include "handle.h"

#include "fig_poly.h"

namespace Diagram {

    class ModeCreateFigPoly : public ModeCreate {
    public:
	ModeCreateFigPoly();

	string get_instructions() const;

	bool mouse_pressed(const Toolkit::MouseEvent * mouse_event);
	bool mouse_released(const Toolkit::MouseEvent * mouse_event);
	bool mouse_dragged(const Toolkit::MouseEvent * mouse_event);
	bool mouse_moved(const Toolkit::MouseEvent * mouse_event);

    protected:
	~ModeCreateFigPoly();

	virtual bool can_start(const Toolkit::MouseEvent * mouse_event);
	virtual bool can_finish(const Toolkit::MouseEvent * mouse_event);

	bool near_last(const Drawing::Point & point) const;

	Drawing::Point mLast;
	Handle mHandle;

    private:
    };

} // namespace Diagram

#endif // DIAGRAM_MODE_CREATE_FIG_POLY_H
