// This code is a modified port of GEF (Graphical Editing Framework)
// http://gef.tigris.org/
// GEF is copyrighted by the Regents of the University of California

// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "mode_create_fig_poly_line.h"

#include "toolkit/mouse_event.h"

#include "fig_poly_line.h"

namespace Diagram {

    ModeCreateFigPolyLine::ModeCreateFigPolyLine() : ModeCreateFigPoly() {
    }

    ModeCreateFigPolyLine::~ModeCreateFigPolyLine() {
    }

    Fig *
    ModeCreateFigPolyLine::create_new_item(const Toolkit::MouseEvent * mouse_event,
					   const Drawing::Point & point) {
	FigPoly * fig_poly = new FigPolyLine();
	fig_poly->add_point(point);
	fig_poly->add_point(point);

	mLast = point;

	return fig_poly;
    }

} // namespace Diagram
