// This code is a modified port of GEF (Graphical Editing Framework)
// http://gef.tigris.org/
// GEF is copyrighted by the Regents of the University of California

// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "mode_pan.h"

#include "foundation/macros.h"
#include "foundation/command_callback.h"
#include "toolkit/factory.h"
#include "toolkit/menu.h"
#include "toolkit/mouse_event.h"

namespace Diagram {

    ModePan::ModePan() : Mode() {
    }

    ModePan::~ModePan() {
    }

    string
    ModePan::get_instructions() const {
	return "Select an action from the menu";
    }

    bool
    ModePan::mouse_pressed(const Toolkit::MouseEvent * mouse_event) {
	if(mouse_event->get_button() == 2) {
	    start(mouse_event);

	    // remember the point

	    return true;
	}
	else {
	    return false;
	}
    }

    bool
    ModePan::mouse_dragged(const Toolkit::MouseEvent * mouse_event) {
	if(mouse_event->is_button2_down()) {
	    NYI();

	    // here we would scroll the canvas according to the
	    // deltas in the pointer motion

	    return true;
	}
	else {
	    return false;
	}
    }

    bool
    ModePan::mouse_released(const Toolkit::MouseEvent * mouse_event) {
	if(mouse_event->get_button() == 2) {
	    finish(mouse_event);

	    return true;
	}
	else {
	    return false;
	}
    }

} // namespace Diagram
