// This code is a modified port of GEF (Graphical Editing Framework)
// http://gef.tigris.org/
// GEF is copyrighted by the Regents of the University of California

// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DIAGRAM_MODE_SELECT_H
#define DIAGRAM_MODE_SELECT_H

#include "mode.h"

#include "drawing/point.h"
#include "drawing/rectangle.h"

#include <string>
using namespace std;

namespace Diagram {

    class Fig;

    class ModeSelect : public Mode {
    public:
	ModeSelect();

	string get_instructions() const;

	bool mouse_pressed(const Toolkit::MouseEvent * mouse_event);
	bool mouse_dragged(const Toolkit::MouseEvent * mouse_event);
	bool mouse_released(const Toolkit::MouseEvent * mouse_event);

	void paint(Drawing::Drawable * drawable) const;

    protected:
	~ModeSelect();

	void update_selection();

    private:
	Drawing::Point mAnchor;

	static const int HIT_SIZE;
    };

} // namespace Diagram

#endif // DIAGRAM_MODE_SELECT_H
