// Dachshund
// Copyright (C) 2002 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DIAGRAM_PALETTE_MANAGER_H
#define DIAGRAM_PALETTE_MANAGER_H

#include "foundation/object.h"

#include "mode_change_listener.h"

#include <set>
using namespace std;

namespace Toolkit {

    class Palette;

} // namespace Palette

namespace Diagram {

    class Editor;

    class PaletteManager : public Object, public ModeChangeListener {
    public:
	PaletteManager(Editor * editor, Toolkit::Palette * palette);
	~PaletteManager();

	void mode_changed(const ModeChangeEvent * mode_change_event);

    private:
	Editor * mEditor;
	Toolkit::Palette * mPalette;
    };

} // namespace Diagram

#endif // DIAGRAM_PALETTE_MANAGER_H
