// This code is a modified port of GEF (Graphical Editing Framework)
// http://gef.tigris.org/
// GEF is copyrighted by the Regents of the University of California

// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DIAGRAM_SELECTION_EDGE_H
#define DIAGRAM_SELECTION_EDGE_H

#include "selection_poly.h"

#include "fig_edge.h"

namespace Diagram {

    class FigEdge;
    class FigNode;

    class SelectionEdge : public SelectionPoly {
    public:
	explicit SelectionEdge(FigEdge * fig_edge);
	~SelectionEdge();

	void drag_handle(const Drawing::Point & m, const Drawing::Point & an, Handle & handle);

	void cleanup();

    protected:

    private:
	FigNode * mCurrentNode;
	FigEdge::Part mPart;
    };

} // namespace Diagram

#endif // DIAGRAM_SELECTION_EDGE_H
