// This code is a modified port of GEF (Graphical Editing Framework)
// http://gef.tigris.org/
// GEF is copyrighted by the Regents of the University of California

// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "selection_noop.h"

#include "drawing/drawable.h"

#include "foundation/macros.h"

#include "handle.h"

namespace Diagram {

    SelectionNoop::SelectionNoop(Fig * fig) : Selection(fig) {
        update_bounds_to_content();
    }

    SelectionNoop::~SelectionNoop() {
    }

    void
    SelectionNoop::drag_handle(const Drawing::Point & m, const Drawing::Point & an,
			       Handle & handle) {
        ASSERT_NOT_REACHED();   // we don't have any handles
    }

    void
    SelectionNoop::hit_handle(const Drawing::Rectangle & rect, Handle & handle) const {
        handle.set_index(-1);
        handle.set_instructions("");
    }

    void
    SelectionNoop::paint(Drawing::Drawable * drawable) const {
	drawable->set_color(get_fill_color());
	drawable->draw_rectangle(mBounds, false);
    }

} // namespace Diagram
