// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DRAWING_FACTORY_H
#define DRAWING_FACTORY_H

#include "foundation/object.h"

#include <string>
using namespace std;

namespace Drawing {

    class Image;
    class Text;

    class Factory : public Object {
    public:
	static void instance(Factory * instance);
	static Factory * instance();
	static void shutdown();

	virtual Image * create_image(const string & file_name) const = 0;
	virtual Text * create_text() const = 0;

    protected:
	Factory();
	~Factory();

    private:
	static Factory * mInstance;
    };

} // namespace Drawing

#endif // DRAWING_FACTORY_H
