// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DRAWING_LINE_H
#define DRAWING_LINE_H

#include "point.h"
#include "vector.h"

#include <iosfwd>
using namespace std;

namespace Drawing {

    class Line {
    public:
	Line(const Point & p1, const Point & p2);
	Line(const Point & p, const Vector & v);

	const Point & get_point() const { return mPoint; }
	const Vector & get_vector() const { return mVector; }

	double get_distance_to(const Point & point) const;
	bool get_intercept(const Line & line, Point & point) const;

    private:
	Point mPoint;
	Vector mVector;
    };

    ostream & operator << (ostream & ost, const Line & l);

} // namespace Drawing

#endif // DRAWING_LINE_H
