// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DRAWING_POINT_H
#define DRAWING_POINT_H

#include <iosfwd>
using namespace std;

namespace Drawing {

    class Vector;

    class Point {
    public:
	Point();
	Point(int x, int y);

	void set(int x, int y) { mX = x; mY = y; }

	int get_x() const { return mX; }
	int get_y() const { return mY; }

	void set_x(int x) { mX = x; }
	void set_y(int y) { mY = y; }

	Point & operator += (const Vector & v);
	Point & operator -= (const Vector & v);

	void translate(const Vector & v) { operator += (v); }

    private:
	int mX, mY;
    };

    bool operator == (const Point & p1, const Point & p2);
    bool operator != (const Point & p1, const Point & p2);

    Point operator + (const Point & p, const Vector & v);
    Point operator - (const Point & p, const Vector & v);

    ostream & operator << (ostream & ost, const Point & point);
    istream & operator >> (istream & ist, Point & point);

} // namespace Drawing

#endif // DRAWING_POINT_H
