// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DRAWING_TEXT_H
#define DRAWING_TEXT_H

#include "foundation/object.h"

#include <string>
using namespace std;

namespace Drawing {

    class Text : public Object {
    public:
	Text();

	enum WrapMode {
	    WM_WORD,
	    WM_CHAR
	};

	enum Alignment {
	    A_LEFT,
	    A_RIGHT,
	    A_CENTER
	};

	virtual void set_text(const string & text) = 0;
	virtual void set_wrap_mode(WrapMode wrap_mode) = 0;
	virtual void set_alignment(Alignment alignment) = 0;
	virtual void set_font(const string & font_name) = 0;
	virtual int set_width(int width) = 0;		// returns the height

    protected:
	~Text();

    private:
    };

} // namespace Drawing

#endif // DRAWING_TEXT_H
