// Dachshund,
// Copyright (C) 2002 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "foundation/macros.h"

#include "common/uuid.h"
using namespace Common;

#include <sstream>
using namespace std;

int
main() {
    UUID uuid;

    // generate a uuid

    uuid.generate();

    cout << uuid << endl;
    ASSERT(cout.good());

    ostringstream ost;

    ost << uuid;
    ASSERT(ost.good());

    // clear the uuid

    uuid.clear();

    cout << uuid << endl;;
    ASSERT(cout.good());

    // now read it back

    istringstream ist(ost.str());

    ist >> uuid;
    ASSERT(ist.good());

    // write it and it should be the same

    cout << uuid << endl;
    ASSERT(cout.good());

    return 0;
}
