// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef FOUNDATION_COMPOSITE_COMMAND_H
#define FOUNDATION_COMPOSITE_COMMAND_H

#include "command.h"

#include <vector>
using namespace std;

class CompositeCommand : public Command {
public:
    CompositeCommand();
    ~CompositeCommand();

    void execute();
    void unexecute();

    bool is_empty() const;
    bool is_closed() const { return mClosed; }
    void add(Command * command);
    void close() { mClosed = true; }

private:
    bool mClosed;
    vector<Command *> mCommands;
};

#endif // FOUNDATION_COMPOSITE_COMMAND_H
