// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef FOUNDATION_EXCEPTION_H
#define FOUNDATION_EXCEPTION_H

#include <string>
#include <iosfwd>
using namespace std;

class Exception {
public:
    explicit Exception(const string & name, const string & details = "");
    ~Exception();

    const string & get_name() const { return mName; }
    const string & get_details() const { return mDetails; }

private:
    const string mName;
    const string mDetails;
};

ostream & operator << (ostream & ost, const Exception & exception);

#endif // FOUNDATION_EXCEPTION_H
