// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef GENERATOR_ROOT_PACKAGE_H
#define GENERATOR_ROOT_PACKAGE_H

#include "package.h"

namespace Common {

    class CppStream;

} // namespace Common

namespace MOF {

    class DataType;

} // namespace MOF

namespace Generator {

    class RootPackage : public Package {
    public:
	RootPackage(MOF::Package * package, const string & model_name);

	void generate(const string & output_dir, const string & include_dir, int depth);

    protected:
	~RootPackage();

	void load_details();

	void generate_makefile(Common::DiffStream & mam);
	void generate_cvsignore(Common::DiffStream & ign);

	void generate_context(Common::CppStream & hpp, Common::CppStream & cpp);

	//
	//
	//

	struct DataTypeDetails {
	    MOF::DataType * data_type;
	    string name;
	    string path;
	    string qualified_name;
	    string qualified_path;
	};

	vector<ClassDetails> mAllClassDetails;
	vector<DataTypeDetails> mAllDataTypeDetails;

	set<string> mAllSources;
	set<string> mAllHeaders;
    };

} // namespace Generator

#endif // GENERATOR_ROOT_PACKAGE_H
