// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef GENERATOR_WRITER_H
#define GENERATOR_WRITER_H

#include "io.h"

#include <string>
using namespace std;

namespace Common {

    class CppStream;

} // namespace Common

namespace Generator {

    class Writer : public IO {
    public:
	Writer(MOF::Package * root_package, const string & model_name);

	void generate(const string & output_dir, const string & include_dir);

    protected:
	~Writer();

	void load_details();

	void generate_header(Common::CppStream & hpp);
	void generate_source(Common::CppStream & cpp);

	struct WriterDetails {
	    string qualified_path;
	};

	WriterDetails mWriterDetails;

    private:
    };

} // namespace Generator

#endif // GENERATOR_WRITER_H
