// This code is a modified port of GEF (Graphical Editing Framework)
// http://gef.tigris.org/
// GEF is copyrighted by the Regents of the University of California

// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef GRAPH_LISTENER_H
#define GRAPH_LISTENER_H

// interface class only

namespace Graph {

    class Event;

    class Listener {
    public:
	virtual void node_added(const Event * event) = 0;
	virtual void node_changed(const Event * event) = 0;
	virtual void node_removed(const Event * event) = 0;

	virtual void edge_added(const Event * event) = 0;
	virtual void edge_changed(const Event * event) = 0;
	virtual void edge_removed(const Event * event) = 0;
    };

} // namespace Graph

#endif // GRAPH_LISTENER_H
