// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef GTK_IMAGE_H
#define GTK_IMAGE_H

#include "drawing/image.h"

#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtkwidget.h>

#include <string>
#include <map>
using namespace std;

namespace GTK {

    class Image : public Drawing::Image {
    public:
	explicit Image(const string & filename);
	~Image();

	int get_w() const;
	int get_h() const;

	GdkPixbuf * get_pixbuf() { return mPixbuf; }
	void scale(GtkIconSize size);

	static void set_widget(GtkWidget * widget);

    protected:
	void load_stock_icon(const string & icon_name);
	void load_icon_from_file(const string & file_name);
	void load_default_icon();

    private:
	GdkPixbuf * mPixbuf;

	static GtkWidget * mWidget;
	static map<string, string> mTranslationMap;
    };

} // namespace GTK

#endif // GTK_IMAGE_H
