// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "statusbar.h"

#include <libgnomeui/gnome-appbar.h>

#include "foundation/macros.h"

namespace GTK {

    Statusbar::Statusbar() : Toolkit::Statusbar(), Widget() {
	mBaseWidget = gnome_appbar_new(TRUE, TRUE, GNOME_PREFERENCES_NEVER);

	post_init();
    }

    Statusbar::~Statusbar() {
    }

    //

    void
    Statusbar::push(const string & message_text) {
	gnome_appbar_push(GNOME_APPBAR(mBaseWidget), message_text.c_str());
    }

    void
    Statusbar::pop() {
	gnome_appbar_pop(GNOME_APPBAR(mBaseWidget));
    }

    void
    Statusbar::clear() {
	gnome_appbar_clear_stack(GNOME_APPBAR(mBaseWidget));
    }

    void
    Statusbar::set_progress(double percentage) {
	gnome_appbar_set_progress_percentage(GNOME_APPBAR(mBaseWidget), percentage);
    }

} // namespace GTK
