// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef GTK_TOOLBAR_H
#define GTK_TOOLBAR_H

#include "toolkit/toolbar.h"
#include "widget.h"

namespace GTK {

    class Toolbar : public Toolkit::Toolbar, public Widget {
    public:
	Toolbar();
	~Toolbar();

	void add_element(Command * command, Drawing::Image * image, bool sensitive = true);
	void add_separator();
	void set_sensitive(Command * command, bool sensitive);

    protected:
	GtkWidget * find(const Command * command);

    private:
	static void static_toolbar_callback(GtkWidget * widget, Toolbar * palette);
	void toolbar_callback(GtkWidget * widget);

	static void static_unref(gpointer data);
    };

} // namespace GTK

#endif // GTK_TOOLBAR_H
