// Dachshund
// Copyright (C) 2002 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef GENERATOR_H
#define GENERATOR_H

#include <vector>
#include <string>

#include "uml/foundation/core/model_element.h"
#include "uml/foundation/core/class.h"

#include "model_code_generator.h"
#include "modules.h"

using namespace std;
using namespace UML;

//
// Dachshund UML Code Generator class, where it all starts 
//

namespace DMCG {

	class Generator {

#ifdef MCG_REQUIRED
		private:
			MCG_Language mLanguage;
			MCG_Operating_System mOperatingSystem;

			ModelElement * mChosenElement;
			Module * mChosenModule;
				
			vector<PackageModule *> mAllPackageModules;

			void add_package_module (PackageModule * new_package) { mAllPackageModules.push_back(new_package); }

			Package *establish_packages (Package *);
			Package *establish_root_package (ModelElement *);
			void establish_package_hierarchy (void);

			int generate_package (PackageModule *);
			int generate_class (ClassModule *);
#endif

		public:
			Generator();

			bool code_generation_on (void);

			int generate_code (Package *);
			int generate_code (UML::Class *);
//			int generate_code (Component *); NOT YET SPECIFIED
	};


}	// namespace DMCG

#endif // GENERATOR_H
