// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "aggregation_kind.h"

namespace MOF {

    const string AggregationKind::TYPE = "AggregationKind";

    const string AggregationKind::TABLE[] = {
	"none",
	"composite",
	"aggregate"
    };

    const int AggregationKind::SIZE = sizeof(TABLE) / sizeof(TABLE[0]);

    AggregationKind::AggregationKind() : REF::Enum() {
    }

    AggregationKind::~AggregationKind() {
    }

    const string &
    AggregationKind::ref_get_type() const {
	return TYPE;
    }

    const string *
    AggregationKind::get_values() const {
	return TABLE;
    }

    int
    AggregationKind::get_size() const {
	return SIZE;
    }

} // namespace MOF

