// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "boolean.h"

#include "reflective/exceptions.h"

namespace MOF {

    const string Boolean::TYPE = "Boolean";

    Boolean::Boolean() : REF::Attribute(),
        mValue(false) {
    }

    Boolean::~Boolean() {
    }

    void
    Boolean::ref_set_value(const string & value) {
	if(value == "true" || value == "TRUE") {
	    mValue = true;
	}
	else if(value == "false" || value == "FALSE") {
	    mValue = false;
	}
	else {
	    throw REF::BadValue("Boolean: " + value);
	}
    }

    void
    Boolean::ref_get_value(string & value) const {
	value += mValue ? "true" : "false";
    }

    const string &
    Boolean::ref_get_type() const {
	return TYPE;
    }

} // namespace MOF
