// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "direction_kind.h"

namespace MOF {

    const string DirectionKind::TYPE = "DirectionKind";

    const string DirectionKind::TABLE[] = {
	"in",
	"out",
	"inout",
	"return"
    };

    const int DirectionKind::SIZE = sizeof(TABLE) / sizeof(TABLE[0]);

    DirectionKind::DirectionKind() : REF::Enum() {
    }

    DirectionKind::~DirectionKind() {
    }

    const string &
    DirectionKind::ref_get_type() const {
	return TYPE;
    }

    const string *
    DirectionKind::get_values() const {
	return TABLE;
    }

    int
    DirectionKind::get_size() const {
	return SIZE;
    }

} // namespace MOF

