// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef MOF_IMPORT_H
#define MOF_IMPORT_H

#include "model_element.h"

#include "visibility_kind.h"
#include "boolean.h"

namespace MOF {

    using namespace Common;

    class Namespace;

    class Model;

    //

    class Import : public ModelElement {
    public:
	Import();
	~Import();

	const VisibilityKind * get_visibility() const { return mVisibility; }
	void set_visibility(const VisibilityKind * visibility);

	const Boolean * is_clustered() const { return mClustered; }
	void set_clustered(const Boolean * clustered);

	Namespace * get_imported() { return mImported; }
	void set_imported(Namespace * imported);

    protected:
	// internal

	// reflective

	void ref_delete_impl(set<string> & visited);

	bool ref_is_a_type_of_impl(set<string> & visited, const string & class_name) const;
	const string & ref_get_type() const;

	void ref_implant_impl(set<string> & visited) throw();
	void ref_uproot_impl(set<string> & visited) throw();

    private:
	VisibilityKind * mVisibility;
	Boolean * mClustered;
	Namespace * mImported;

	static const string TYPE;
    };

} // namespace MOF

#endif // MOF_IMPORT_H
