// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef MOF_PARAMETER_H
#define MOF_PARAMETER_H

#include "typed_element.h"

#include "direction_kind.h"
#include "multiplicity_type.h"

namespace MOF {

    class Model;
    class Parameter;

    //

    class Parameter : public TypedElement {
    public:
	Parameter();
	~Parameter();

	const DirectionKind * get_direction() const { return mDirection; }
	void set_direction(const DirectionKind * direction);

	const MultiplicityType * get_multiplicity() const { return mMultiplicity; }
	void set_multiplicity(const MultiplicityType * multiplicity);

    protected:
	// reflective

	bool ref_is_a_type_of_impl(set<string> & visited, const string & class_name) const;
	const string & ref_get_type() const;

	void ref_implant_impl(set<string> & visited) throw();
	void ref_uproot_impl(set<string> & visited) throw();

    private:
	DirectionKind * mDirection;
	MultiplicityType * mMultiplicity;

	static const string TYPE;
    };

} // namespace MOF

#endif // MOF_PARAMETER_H
