// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef PYTHON_REFLECTIVE_CLASS_H
#define PYTHON_REFLECTIVE_CLASS_H

#include <Python.h>

class Object;

namespace REF {
  class Class;
}

namespace Python {
  // C Representation of Python reference to a Reflective::Class

  struct ClassReference {
    // This python object is used to hold a reference to a model element.
    // The reference count is incremented on construction.
    PyObject_HEAD
    REF::Class * mClass;

    REF::Class * get() { return mClass; }
  };


  // Forward declaration of the type descriptor
  extern PyTypeObject reflectiveClassType;


  // Declaration of the module initialisation function
  extern PyObject * class_reference_new(REF::Class * root);
  extern PyObject * class_reference_new(PyObject * self, PyObject * args);
}

#endif
