// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef PYTHON_REFLECTIVE_CONTEXT_H
#define PYTHON_REFLECTIVE_CONTEXT_H

#include <Python.h>

class Object;
namespace REF {
  class Context;
}

namespace Python {
  // C Representation of Python reference to a model elements
  struct ContextReference {
    // This python object is used to hold a reference to a context.
    // The reference count is incremented on construction.
    PyObject_HEAD
    REF::Context * mContext;

    REF::Context * get() { return mContext; }
  };


  // Forward declaration of the type descriptor
  extern PyTypeObject reflectiveContextType;


  // Declaration of the module initialisation function
  extern PyObject * context_reference_new(REF::Context * root);
  extern PyObject * context_reference_new(PyObject * self, PyObject * args);
}

#endif
