// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "foundation/macros.h"

#include "python/reflective/class.h"
#include "python/reflective/context.h"
#include "python/reflective/changes.h"
#include "python/reflective/change_listener.h"
#include "python/reflective/module.h"

namespace Python {

    void reflective_initialise() {
        static struct PyMethodDef module_methods[] = {
            { "Class",   class_reference_new,   METH_VARARGS },
            { "Context", context_reference_new, METH_VARARGS },

            { "set_change_listener", set_change_listener, METH_VARARGS },

            { NULL, NULL }
        };

        MESSAGE("Initialise Python reflective interface...");
        Py_InitModule("Reflective", module_methods);
    }

} // namespace Python
