// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef PYTHON_TOOLKIT_DOCUMENT_H
#define PYTHON_TOOLKIT_DOCUMENT_H

class Object;

namespace Toolkit {
  class Widget;
  class Document;
  class Tag;
}

#include <Python.h>

namespace Python {

  struct DocumentReference {
    // Python reference to Toolkit::Document
    PyObject_HEAD
    Toolkit::Document * mDocument;

    Toolkit::Document *	get() { return mDocument; }
  };


  // Forward declaration of the type descriptor
  extern PyTypeObject toolkitDocumentType;


  // Declaration of the module initialisation function
  PyObject * document_reference_new(Toolkit::Document * document);
  PyObject * document_reference_new(PyObject * self, PyObject * args);
}

#endif
