// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef PYTHON_TOOLKIT_TAG_H
#define PYTHON_TOOLKIT_TAG_H

class Object;

namespace Toolkit {

  class Widget;
  class Tag;
}

#include <Python.h>

namespace Python {

  struct TagReference {
    // Python reference to Toolkit::Tag
    PyObject_HEAD
    Toolkit::Tag * mTag;

    Toolkit::Tag * get() { return mTag; }
  };


  // Forward declaration of the type descriptor
  extern PyTypeObject toolkitTagType;


  // Declaration of the module initialisation function
  PyObject * tag_reference_new(Toolkit::Tag * tag);
  PyObject * tag_reference_new_tag(PyObject * self, PyObject * args);
  PyObject * tag_reference_new_block(PyObject * self, PyObject * args);
  PyObject * tag_reference_new_field(PyObject * self, PyObject * args);
}

#endif
