// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef PYTHON_TOOLKIT_TREE_H
#define PYTHON_TOOLKIT_TREE_H

namespace Toolkit {

  class Widget;
  class Tree;
}

#include <Python.h>

namespace Python {

  struct TreeReference {
    // Python reference to Toolkit::Tree
    PyObject_HEAD
    Toolkit::Tree * mTree;

    Toolkit::Tree * get() { return mTree; }
  };


  // Forward declaration of the type descriptor
  extern PyTypeObject toolkitTreeType;


  // Declaration of the module initialisation function
  PyObject * tree_reference_new(Toolkit::Tree * tree);
}

#endif
