// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef REFLECTIVE_DEBUG_CHANGE_LISTENER_H
#define REFLECTIVE_DEBUG_CHANGE_LISTENER_H

#include "foundation/object.h"
#include "foundation/change_listener.h"

#include <iosfwd>
using namespace std;

namespace REF {

    class DebugChangeListener : public Object, public ChangeListener {
    public:
	explicit DebugChangeListener(ostream & ost);
	~DebugChangeListener();

	void changes_occurred(const list<ChangeEvent *> & changes) throw();

    protected:
	virtual void process_change(ChangeEvent * change_event);
	ostream & mOs;
    };

} // namespace REF

#endif // REFLECTIVE_DEBUG_CHANGE_LISTENER_H
