// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef REFLECTIVE_ENUM_H
#define REFLECTIVE_ENUM_H

#include "attribute.h"

#include <string>
using namespace std;

namespace REF {

    class Enum : public Attribute {
    public:
	Enum();
	~Enum();

	void set_value(const string & value) { ref_set_value(value); }
	const string & get_value() const { return get_values()[mValue]; }

	void ref_set_value(const string & value);
	void ref_get_value(string & value) const;

	//

	int get_int_value() const { return mValue; }
	void set_int_value(int value);

	virtual const string * get_values() const = 0;
	virtual int get_size() const = 0;

    private:
	int mValue;
    };

} // namespace REF

#endif // REFLECTIVE_ENUM_H
