// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef REFLECTIVE_ITERATOR_H
#define REFLECTIVE_ITERATOR_H

#include "foundation/object.h"

namespace REF {

    class Class;

    class Iterator : public Object {
    public:
	Iterator();

	virtual Class * get() = 0;
	virtual void increment() = 0;
	virtual void rewind() = 0;
	virtual bool is_valid() const = 0;
	virtual int get_index() const = 0;

    protected:
	~Iterator();
    };

} // namespace REF

#endif // REFLECTIVE_ITERATOR_H
