// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef TOOLKIT_KEY_EVENT_H
#define TOOLKIT_KEY_EVENT_H

#include "input_event.h"

namespace Toolkit {

    enum KeyEventType {
	KET_PRESSED,
	KET_RELEASED,
	KET_LAST
    };

    class KeyEvent : public InputEvent {
    public:
	KeyEvent(KeyEventType type,
                 unsigned int key,
                 Widget * widget,
                 int mask,
                 int timestamp);
	~KeyEvent();

	KeyEventType get_type() const { return mType; }
	unsigned int get_key() const { return mKey; }

    private:
	KeyEventType mType;
	unsigned int mKey;
    };

} // namespace Toolkit

#endif // TOOLKIT_KEY_EVENT_H
