// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "mark.h"

#include "foundation/macros.h"

#include "toolkit/tag.h"

using namespace std;

namespace Toolkit {

  Mark::Mark(const char * name) 
    : Object(), mName(name), mIsBlockMark(0), mAssocBlock(0), mAssocLevel(0), mAssocObject(0) {
    // nix
  }

  Mark::~Mark() {
    set_associated_block(0);
    set_associated_object(0);
  }

  void
  Mark::set_associated_block(Tag * block) {
    if (mAssocBlock)
      mAssocBlock->unref();
    mAssocBlock = block;
    if (mAssocBlock)
      mAssocBlock->ref();
  }
  
  void
  Mark::set_associated_level(int level) {
    mAssocLevel = level;
  }
  
  void
  Mark::set_associated_object(Object * object) {
    if (mAssocObject)
      mAssocObject->unref();
    mAssocObject = object;
    if (mAssocObject)
      mAssocObject->ref();
  }

} // namespace Toolkit
