// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef TOOLKIT_WIDGET_H
#define TOOLKIT_WIDGET_H

#include "foundation/object.h"

namespace Toolkit {

    class Widget : public virtual Object {
    public:
	Widget();
	~Widget();

	virtual void show() = 0;
	virtual void hide() = 0;

	// The following functions allow objects to be attached to
	// widgets that will be unref'ed when the widget is destroyed
	virtual void attach_object(Object * object) = 0;
	virtual Object * get_object() = 0;
    };

} // namespace Toolkit

#endif // TOOLKIT_WIDGET_H
