// Dachshund,
// Copyright (C) 2002 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UML_EXT_CLASS_DIAGRAM_MODEL_H
#define UML_EXT_CLASS_DIAGRAM_MODEL_H

#include "graph/model.h"
#include "foundation/change_listener.h"

namespace UML {

    class Diagram;

} // namespace UML

namespace UMLExt {

    class ClassDiagramModel : public Graph::Model, protected ChangeListener {
    public:
	explicit ClassDiagramModel(UML::Diagram * diagram);
	~ClassDiagramModel();

	void add_node(Object * node, Object * parent = 0) throw(Graph::Exception);
	void remove_node(Object * node) throw(Graph::Exception);

	void add_edge(Object * edge, Object * node1, Object * node2) throw(Graph::Exception);
	void remove_edge(Object * edge) throw(Graph::Exception);

    protected:
	void changes_occurred(const list<ChangeEvent *> & changes) throw();

	virtual void process_change(ChangeEvent * change_event);

    private:
	UML::Diagram * mDiagram;
    };

} // namespace UMLExt

#endif // UML_EXT_CLASS_DIAGRAM_MODEL_H
