// Dachshund,
// Copyright (C) 2002 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "fig_association.h"

#include "fig_class.h"
#include "fig_gimlet.h"

#include "foundation/macros.h"

namespace UMLExt {

    FigAssociation::FigAssociation(UML::AssociationPresentation * ap,
				   FigClass * fc1,
				   FigClass * fc2) : FigEdge(ap, fc1, fc2) {
	mSourceGimlet->set_kind(GK_DIAMOND);
	mSourceGimlet->set_filled(true);

	mDestinationGimlet->set_kind(GK_ARROW);
	mDestinationGimlet->set_filled(false);
    }

    FigAssociation::~FigAssociation() {
    }

    void
    FigAssociation::update_to_owner() {
        FigEdge::update_to_owner();
    }

} // namespace UMLExt
