// Dachshund,
// Copyright (C) 2002 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UML_EXT_FIG_CLASS_H
#define UML_EXT_FIG_CLASS_H

#include "fig_node.h"

#include "uml/diagram/class_presentation.h"

#include "diagram/fig_text.h"
#include "diagram/fig_rect.h"
#include "diagram/fig_hline.h"

namespace UMLExt {

    class FigClass : public FigNode {
    public:
	explicit FigClass(UML::ClassPresentation * cp);
	~FigClass();

	void update_to_owner();

    protected:
	void layout();

    private:
	Diagram::FigRect * mBaseFig;
	Diagram::FigRect * mOutlineFig;
	Diagram::FigText * mNameFig;
	Diagram::FigHLine * mSeparator1Fig;
	Diagram::FigHLine * mSeparator2Fig;

	int mNameHeight;
	int mOperationsHeight;
	int mAttributesHeight;
    };

} // namespace UML

#endif // UML_EXT_FIG_CLASS_H
