// Dachshund,
// Copyright (C) 2002 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "fig_dependency.h"

#include "fig_node.h"
#include "fig_gimlet.h"

#include "foundation/macros.h"

namespace UMLExt {

    FigDependency::FigDependency(UML::DependencyPresentation * dp,
				 FigNode * n1,
				 FigNode * n2) : FigEdge(dp, n1, n2) {
	mDestinationGimlet->set_kind(GK_ARROW);
	mDestinationGimlet->set_filled(false);
        set_line_style(Drawing::LS_DASHED);
    }

    FigDependency::~FigDependency() {
    }

    void
    FigDependency::update_to_owner() {
        FigEdge::update_to_owner();
    }

} // namespace UMLExt
