// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UMLEXT_MODE_CREATE_NODE_H
#define UMLEXT_MODE_CREATE_NODE_H

#include "diagram/mode_create_fig_node.h"

#include "uml/foundation/data_types/name.h"

#include <sstream>
using namespace std;

namespace UMLExt {

    template<class T>
    class ModeCreateNode : public Diagram::ModeCreateFigNode {
    public:
	ModeCreateNode();
	~ModeCreateNode();

	Object * create_new_node(const Drawing::Point & point);
	string get_instructions() const;

    private:
    };

    template<class T>
    ModeCreateNode<T>::ModeCreateNode() : ModeCreateFigNode() {
    }

    template<class T>
    ModeCreateNode<T>::~ModeCreateNode() {
    }

    template<class T>
    Object *
    ModeCreateNode<T>::create_new_node(const Drawing::Point & point) {
	T * t = new T();

	ostringstream ost;

	ost << Drawing::Rectangle(point - Drawing::Vector(24, 24),
				  point + Drawing::Vector(24, 24));

	UML::Name * str = new UML::Name();
	str->ref_set_value(ost.str());
	t->set_geometry(str);
	str->unref();

	return t;
    }

    template<class T>
    string
    ModeCreateNode<T>::get_instructions() const {
	return "Click to create node";
    }

} // namespace UMLExt

#endif // MODE_CREATE_NODE_H
