// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "association_presentation.h"

#include "class_presentation.h"

#include "uml.h"

#include "reflective/changes.h"
#include "reflective/set_iterator.h"
#include "reflective/list_iterator.h"
#include "reflective/pointer_iterator.h"
#include "reflective/exceptions.h"

#include "foundation/macros.h"
#include "foundation/commands.h"
#include "foundation/utility.h"
#include "foundation/exception.h"
#include "foundation/algorithm.h"
#include "foundation/functional.h"

#include <vector>
#include <functional>
#include <algorithm>
using namespace std;

namespace UML {
    
    const string AssociationPresentation::TYPE = "AssociationPresentation";
    
    AssociationPresentation::AssociationPresentation() {
	mSource = 0;
	mDestination = 0;
	
	TRACE(9, "Constructed: " << static_cast<Object *>(this));
    }
    
    AssociationPresentation::AssociationPresentation(const AssociationPresentation & association_presentation) {
	ASSERT_NOT_REACHED();
    }
    
    AssociationPresentation::~AssociationPresentation() {
	TRACE(9, "Destroyed: " << static_cast<Object *>(this));
	
    }
    
    void // MMM
    AssociationPresentation::internal_set_source(ClassPresentation * source) {
	ChangeEvent * change = change_role_changed(this, "source",
						   source, mSource, false);
	log_change(change);
	
	change->unref();
	
	if(mSource) {
	    mSource->unref();
	}
	
	mSource = source;
	
	if(mSource) {
	    mSource->ref();
	}
    }
    
    void // LLL
    AssociationPresentation::set_source(ClassPresentation * source) {
	if(mSource != source) {
	    // neither end is an aggregate, so we must have the same context
	    // as each other
	    
	    if(source) {
		ASSERT(!source->ref_get_context() ||
		       source->ref_get_context() == ref_get_context());
	    }
	    
	    begin_transaction();
	    
	    Command * command = command_flip_argument(this,
						      &AssociationPresentation::set_source,
						      source, mSource);
	    log_command(command);
	    command->unref();
	    
	    ChangeEvent * change = change_role_changed(this,
						       "source", source,
						       mSource, false);
	    log_change(change);
	    change->unref();
	    
	    if(mSource) {
		mSource->internal_remove_association_source(this);
		mSource->unref();
	    }
	    
	    mSource = source;
	    
	    if(mSource) {
		mSource->internal_add_association_source(this);
		mSource->ref();
	    }
	    
	    end_transaction();
	}
    }
    
    void // MMM
    AssociationPresentation::internal_set_destination(ClassPresentation * destination) {
	ChangeEvent * change = change_role_changed(this, "destination",
						   destination, mDestination, false);
	log_change(change);
	
	change->unref();
	
	if(mDestination) {
	    mDestination->unref();
	}
	
	mDestination = destination;
	
	if(mDestination) {
	    mDestination->ref();
	}
    }
    
    void // LLL
    AssociationPresentation::set_destination(ClassPresentation * destination) {
	if(mDestination != destination) {
	    // neither end is an aggregate, so we must have the same context
	    // as each other
	    
	    if(destination) {
		ASSERT(!destination->ref_get_context() ||
		       destination->ref_get_context() == ref_get_context());
	    }
	    
	    begin_transaction();
	    
	    Command * command = command_flip_argument(this,
						      &AssociationPresentation::set_destination,
						      destination, mDestination);
	    log_command(command);
	    command->unref();
	    
	    ChangeEvent * change = change_role_changed(this,
						       "destination", destination,
						       mDestination, false);
	    log_change(change);
	    change->unref();
	    
	    if(mDestination) {
		mDestination->internal_remove_association_destination(this);
		mDestination->unref();
	    }
	    
	    mDestination = destination;
	    
	    if(mDestination) {
		mDestination->internal_add_association_destination(this);
		mDestination->ref();
	    }
	    
	    end_transaction();
	}
    }
    
    void
    AssociationPresentation::ref_set_context_impl(set<string> & visited,
						  REF::Context * context) {
	if(visited.insert(TYPE).second) {
	    EdgeElement::ref_set_context_impl(visited, context);
	}
    }
    
    void
    AssociationPresentation::ref_implant_impl(set<string> & visited) throw() {
	if(visited.insert(TYPE).second) {
	    REF::Context * context = ref_get_context();
	    
	    ASSERT(context);
	    
	    UML * model = known_cast<UML *>(context);
	    
	    model->internal_add_association_presentation(this);
	    
	    EdgeElement::ref_implant_impl(visited);
	}
    }
    
    void
    AssociationPresentation::ref_uproot_impl(set<string> & visited) throw() {
	if(visited.insert(TYPE).second) {
	    EdgeElement::ref_uproot_impl(visited);
	    
	    REF::Context * context = ref_get_context();
	    
	    ASSERT(context);
	    
	    UML * model = known_cast<UML *>(context);
	    
	    model->internal_add_association_presentation(this);
	}
    }
    
    bool
    AssociationPresentation::ref_add_role_impl(set<string> & visited,
					       const string & role_name,
					       REF::Class * role,
					       REF::Class * position) {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_add_role_impl(visited, role_name, role, position)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationPresentation::ref_remove_role_impl(set<string> & visited,
						  const string & role_name,
						  REF::Class * role) {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_remove_role_impl(visited, role_name, role)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationPresentation::ref_get_role_impl(set<string> & visited,
					       REF::Class * & role,
					       const string & role_name) {
	if(visited.insert(TYPE).second) {
	    if(role_name == "source") {
		role = get_source();
		return true;
	    }
	    
	    if(role_name == "destination") {
		role = get_destination();
		return true;
	    }
	    
	    if(EdgeElement::ref_get_role_impl(visited, role, role_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationPresentation::ref_set_role_impl(set<string> & visited,
					       const string & role_name,
					       REF::Class * role) {
	if(visited.insert(TYPE).second) {
	    if(role_name == "source") {
		ClassPresentation * source = dynamic_cast<ClassPresentation *>(role);
		
		if(!source) {
		    WARNING("Wrong type for role: " + role->ref_get_type() +
			    ", in class: " + ref_get_type());
		    throw REF::BadType("Wrong type for role: " + role->ref_get_type());
		}
		
		set_source(source);
		return true;
	    }
	    
	    if(role_name == "destination") {
		ClassPresentation * destination = dynamic_cast<ClassPresentation *>(role);
		
		if(!destination) {
		    WARNING("Wrong type for role: " + role->ref_get_type() +
			    ", in class: " + ref_get_type());
		    throw REF::BadType("Wrong type for role: " + role->ref_get_type());
		}
		
		set_destination(destination);
		return true;
	    }
	    
	    if(EdgeElement::ref_set_role_impl(visited, role_name, role)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationPresentation::ref_create_class_impl(set<string> & visited,
						   REF::Class * & role,
						   const string & role_name) const {
	if(visited.insert(TYPE).second) {
	    if(role_name == "source") {
		role = new ClassPresentation();
		return true;
	    }
	    
	    if(role_name == "destination") {
		role = new ClassPresentation();
		return true;
	    }
	    
	    if(EdgeElement::ref_create_class_impl(visited, role, role_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationPresentation::ref_get_role_iterator_impl(set<string> & visited,
							REF::Iterator * & iterator,
							const string & role_name) {
	if(visited.insert(TYPE).second) {
	    if(role_name == "source") {
		iterator = REF::iterator<ClassPresentation>(get_source());
		return true;
	    }
	    
	    if(role_name == "destination") {
		iterator = REF::iterator<ClassPresentation>(get_destination());
		return true;
	    }
	    
	    if(EdgeElement::ref_get_role_iterator_impl(visited, iterator, role_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationPresentation::ref_get_attribute_impl(set<string> & visited,
						    const REF::Attribute * & attribute,
						    const string & attribute_name) const {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_get_attribute_impl(visited, attribute, attribute_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationPresentation::ref_set_attribute_impl(set<string> & visited,
						    const string & attribute_name,
						    const REF::Attribute * attribute) {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_set_attribute_impl(visited, attribute_name, attribute)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationPresentation::ref_get_attribute_set_impl(set<string> & visited,
							const vector<const REF::Attribute *> * & attribute_set,
							const string & attribute_name) const {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_get_attribute_set_impl(visited, attribute_set, attribute_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationPresentation::ref_set_attribute_set_impl(set<string> & visited,
							const string & attribute_name,
							const vector<const REF::Attribute *> * attribute_set) {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_set_attribute_set_impl(visited, attribute_name, attribute_set)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationPresentation::ref_create_attribute_impl(set<string> & visited,
						       REF::Attribute * & attribute,
						       const string & attribute_name) const {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_create_attribute_impl(visited, attribute, attribute_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationPresentation::ref_is_a_type_of_impl(set<string> & visited,
						   const string & class_name) const {
	if(visited.insert(TYPE).second) {
	    if(class_name == "AssociationPresentation") {
		return true;
	    }
	    
	    if(EdgeElement::ref_is_a_type_of_impl(visited, class_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    const string &
    AssociationPresentation::ref_get_type() const {
	return TYPE;
    }
    
    void
    AssociationPresentation::ref_delete_impl(set<string> & visited) {
	if(visited.insert(TYPE).second) {
	    ClassPresentation * source = 0;
	    set_source(source);
	    
	    ClassPresentation * destination = 0;
	    set_destination(destination);
	    
	    EdgeElement::ref_delete_impl(visited);
	}
    }
    
} // namespace UML
