// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UML_DIAGRAM_CLASS_PRESENTATION_H
#define UML_DIAGRAM_CLASS_PRESENTATION_H

#include "node_element.h"

#include <list>
using namespace std;

namespace UML {
    
    class AssociationPresentation;
    class GeneralizationPresentation;
    
    class ClassPresentation : public NodeElement {
    public:
	//
	// constructor/destructor
	//
	
	ClassPresentation();
	~ClassPresentation();
	
	//
	// access to roles and role containers
	//
	
	const list<AssociationPresentation *> & get_association_source() const { return mAssociation_source; }
	void set_association_source(const list<AssociationPresentation *> & association_source);
	void add_association_source(AssociationPresentation * association_source, int index = -1);
	void remove_association_source(AssociationPresentation * association_source);
	
	void internal_add_association_source(AssociationPresentation * association_source);
	void internal_remove_association_source(AssociationPresentation * association_source);
	
	const list<AssociationPresentation *> & get_association_destination() const { return mAssociation_destination; }
	void set_association_destination(const list<AssociationPresentation *> & association_destination);
	void add_association_destination(AssociationPresentation * association_destination, int index = -1);
	void remove_association_destination(AssociationPresentation * association_destination);
	
	void internal_add_association_destination(AssociationPresentation * association_destination);
	void internal_remove_association_destination(AssociationPresentation * association_destination);
	
	const list<GeneralizationPresentation *> & get_generalization() const { return mGeneralization; }
	void set_generalization(const list<GeneralizationPresentation *> & generalization);
	void add_generalization(GeneralizationPresentation * generalization, int index = -1);
	void remove_generalization(GeneralizationPresentation * generalization);
	
	void internal_add_generalization(GeneralizationPresentation * generalization);
	void internal_remove_generalization(GeneralizationPresentation * generalization);
	
	const list<GeneralizationPresentation *> & get_specialization() const { return mSpecialization; }
	void set_specialization(const list<GeneralizationPresentation *> & specialization);
	void add_specialization(GeneralizationPresentation * specialization, int index = -1);
	void remove_specialization(GeneralizationPresentation * specialization);
	
	void internal_add_specialization(GeneralizationPresentation * specialization);
	void internal_remove_specialization(GeneralizationPresentation * specialization);
	
	//
	// access to attributes
	//
	
	const string & ref_get_type() const;
	
    protected:
	//
	// reflective interface
	//
	
	void ref_set_context_impl(set<string> & visited, REF::Context * context);
	void ref_implant_impl(set<string> & visited) throw();
	void ref_uproot_impl(set<string> & visited) throw();
	
	//
	
	bool ref_is_a_type_of_impl(set<string> & visited,
				   const string & class_name) const;
	
	void ref_delete_impl(set<string> & visited);
	
	//
	
	bool ref_add_role_impl(set<string> & visited,
			       const string & role_name,
			       REF::Class * role,
			       REF::Class * position);
	
	bool ref_remove_role_impl(set<string> & visited,
				  const string & role_name,
				  REF::Class * role);
	
	bool ref_get_role_iterator_impl(set<string> & visited,
					REF::Iterator * & iterator,
					const string & role_name);
	
	bool ref_get_role_impl(set<string> & visited,
			       REF::Class * & role,
			       const string & role_name);
	
	bool ref_set_role_impl(set<string> & visited,
			       const string & role_name,
			       REF::Class * role);
	
	bool ref_create_class_impl(set<string> & visited,
				   REF::Class * & role,
				   const string & role_name) const;
	
	//
	
	bool ref_get_attribute_impl(set<string> & visited,
				    const REF::Attribute * & attribute,
				    const string & attribute_name) const;
	
	bool ref_set_attribute_impl(set<string> & visited,
				    const string & attribute_name,
				    const REF::Attribute * attribute);
	
	bool ref_get_attribute_set_impl(set<string> & visited,
					const vector<const REF::Attribute *> * & attribute_set,
					const string & attribute_name) const;
	
	bool ref_set_attribute_set_impl(set<string> & visited,
					const string & attribute_name,
					const vector<const REF::Attribute *> * attribute_set);
	
	bool ref_create_attribute_impl(set<string> & visited,
				       REF::Attribute * & attribute,
				       const string & attribute_name) const;
	
    private:
	//
	// copy constructor (copying is forbidden)
	//
	
	ClassPresentation(const ClassPresentation & class_presentation);
	
	//
	// roles storage
	//
	
	list<AssociationPresentation *> mAssociation_source;
	list<AssociationPresentation *> mAssociation_destination;
	list<GeneralizationPresentation *> mGeneralization;
	list<GeneralizationPresentation *> mSpecialization;
	
	//
	// our type
	//
	
	static const string TYPE;
    };
    
} // namespace UML

#endif // UML_DIAGRAM_CLASS_PRESENTATION_H
