// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UML_FOUNDATION_CORE_CLASSIFIER_H
#define UML_FOUNDATION_CORE_CLASSIFIER_H

#include "generalizable_element.h"
#include "namespace.h"

#include <list>
using namespace std;

namespace UML {
    
    class AssociationEnd;
    class Feature;
    class Parameter;
    class StructuralFeature;
    
    class Classifier : public Namespace, public GeneralizableElement {
    public:
	//
	// constructor/destructor
	//
	
	Classifier();
	~Classifier();
	
	//
	// access to roles and role containers
	//
	
	const list<Feature *> & get_feature() const { return mFeature; }
	void set_feature(const list<Feature *> & feature);
	void add_feature(Feature * feature, int index = -1);
	void remove_feature(Feature * feature);
	
	void internal_add_feature(Feature * feature);
	void internal_remove_feature(Feature * feature);
	
	const list<StructuralFeature *> & get_typed_feature() const { return mTypedFeature; }
	void set_typed_feature(const list<StructuralFeature *> & typed_feature);
	void add_typed_feature(StructuralFeature * typed_feature, int index = -1);
	void remove_typed_feature(StructuralFeature * typed_feature);
	
	const list<Parameter *> & get_typed_parameter() const { return mTypedParameter; }
	void set_typed_parameter(const list<Parameter *> & typed_parameter);
	void add_typed_parameter(Parameter * typed_parameter, int index = -1);
	void remove_typed_parameter(Parameter * typed_parameter);
	
	const list<AssociationEnd *> & get_association() const { return mAssociation; }
	void set_association(const list<AssociationEnd *> & association);
	void add_association(AssociationEnd * association, int index = -1);
	void remove_association(AssociationEnd * association);
	
	void internal_add_association(AssociationEnd * association);
	void internal_remove_association(AssociationEnd * association);
	
	//
	// access to attributes
	//
	
	const string & ref_get_type() const;
	
    protected:
	//
	// reflective interface
	//
	
	void ref_set_context_impl(set<string> & visited, REF::Context * context);
	void ref_implant_impl(set<string> & visited) throw();
	void ref_uproot_impl(set<string> & visited) throw();
	
	//
	
	bool ref_is_a_type_of_impl(set<string> & visited,
				   const string & class_name) const;
	
	void ref_delete_impl(set<string> & visited);
	
	//
	
	bool ref_add_role_impl(set<string> & visited,
			       const string & role_name,
			       REF::Class * role,
			       REF::Class * position);
	
	bool ref_remove_role_impl(set<string> & visited,
				  const string & role_name,
				  REF::Class * role);
	
	bool ref_get_role_iterator_impl(set<string> & visited,
					REF::Iterator * & iterator,
					const string & role_name);
	
	bool ref_get_role_impl(set<string> & visited,
			       REF::Class * & role,
			       const string & role_name);
	
	bool ref_set_role_impl(set<string> & visited,
			       const string & role_name,
			       REF::Class * role);
	
	bool ref_create_class_impl(set<string> & visited,
				   REF::Class * & role,
				   const string & role_name) const;
	
	//
	
	bool ref_get_attribute_impl(set<string> & visited,
				    const REF::Attribute * & attribute,
				    const string & attribute_name) const;
	
	bool ref_set_attribute_impl(set<string> & visited,
				    const string & attribute_name,
				    const REF::Attribute * attribute);
	
	bool ref_get_attribute_set_impl(set<string> & visited,
					const vector<const REF::Attribute *> * & attribute_set,
					const string & attribute_name) const;
	
	bool ref_set_attribute_set_impl(set<string> & visited,
					const string & attribute_name,
					const vector<const REF::Attribute *> * attribute_set);
	
	bool ref_create_attribute_impl(set<string> & visited,
				       REF::Attribute * & attribute,
				       const string & attribute_name) const;
	
    private:
	//
	// copy constructor (copying is forbidden)
	//
	
	Classifier(const Classifier & classifier);
	
	//
	// roles storage
	//
	
	list<Feature *> mFeature;
	list<StructuralFeature *> mTypedFeature;
	list<Parameter *> mTypedParameter;
	list<AssociationEnd *> mAssociation;
	
	//
	// our type
	//
	
	static const string TYPE;
    };
    
} // namespace UML

#endif // UML_FOUNDATION_CORE_CLASSIFIER_H
