// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UML_FOUNDATION_CORE_MODEL_ELEMENT_H
#define UML_FOUNDATION_CORE_MODEL_ELEMENT_H

#include "element.h"

#include <list>
using namespace std;

namespace UML {
    
    class Boolean;
    class Comment;
    class Constraint;
    class Dependency;
    class Name;
    class Namespace;
    class PresentationElement;
    class Stereotype;
    class TaggedValue;
    
    class ModelElement : public Element {
    public:
	//
	// constructor/destructor
	//
	
	ModelElement();
	~ModelElement();
	
	//
	// access to roles and role containers
	//
	
	const list<Constraint *> & get_constraint() const { return mConstraint; }
	void set_constraint(const list<Constraint *> & constraint);
	void add_constraint(Constraint * constraint, int index = -1);
	void remove_constraint(Constraint * constraint);
	
	void internal_add_constraint(Constraint * constraint);
	void internal_remove_constraint(Constraint * constraint);
	
	Namespace * get_namespace() const { return mNamespace; }
	void set_namespace(Namespace * namespace_);
	
	void internal_set_namespace(Namespace * namespace_);
	
	const list<Dependency *> & get_supplier_dependency() const { return mSupplierDependency; }
	void set_supplier_dependency(const list<Dependency *> & supplier_dependency);
	void add_supplier_dependency(Dependency * supplier_dependency, int index = -1);
	void remove_supplier_dependency(Dependency * supplier_dependency);
	
	void internal_add_supplier_dependency(Dependency * supplier_dependency);
	void internal_remove_supplier_dependency(Dependency * supplier_dependency);
	
	const list<Dependency *> & get_client_dependency() const { return mClientDependency; }
	void set_client_dependency(const list<Dependency *> & client_dependency);
	void add_client_dependency(Dependency * client_dependency, int index = -1);
	void remove_client_dependency(Dependency * client_dependency);
	
	void internal_add_client_dependency(Dependency * client_dependency);
	void internal_remove_client_dependency(Dependency * client_dependency);
	
	const list<Stereotype *> & get_stereotype() const { return mStereotype; }
	void set_stereotype(const list<Stereotype *> & stereotype);
	void add_stereotype(Stereotype * stereotype, int index = -1);
	void remove_stereotype(Stereotype * stereotype);
	
	void internal_add_stereotype(Stereotype * stereotype);
	void internal_remove_stereotype(Stereotype * stereotype);
	
	const list<TaggedValue *> & get_tagged_value() const { return mTaggedValue; }
	void set_tagged_value(const list<TaggedValue *> & tagged_value);
	void add_tagged_value(TaggedValue * tagged_value, int index = -1);
	void remove_tagged_value(TaggedValue * tagged_value);
	
	void internal_add_tagged_value(TaggedValue * tagged_value);
	void internal_remove_tagged_value(TaggedValue * tagged_value);
	
	const list<TaggedValue *> & get_reference_tag() const { return mReferenceTag; }
	void set_reference_tag(const list<TaggedValue *> & reference_tag);
	void add_reference_tag(TaggedValue * reference_tag, int index = -1);
	void remove_reference_tag(TaggedValue * reference_tag);
	
	void internal_add_reference_tag(TaggedValue * reference_tag);
	void internal_remove_reference_tag(TaggedValue * reference_tag);
	
	const list<Comment *> & get_comment() const { return mComment; }
	void set_comment(const list<Comment *> & comment);
	void add_comment(Comment * comment, int index = -1);
	void remove_comment(Comment * comment);
	
	void internal_add_comment(Comment * comment);
	void internal_remove_comment(Comment * comment);
	
	const list<PresentationElement *> & get_presentation() const { return mPresentation; }
	void set_presentation(const list<PresentationElement *> & presentation);
	void add_presentation(PresentationElement * presentation, int index = -1);
	void remove_presentation(PresentationElement * presentation);
	
	void internal_add_presentation(PresentationElement * presentation);
	void internal_remove_presentation(PresentationElement * presentation);
	
	//
	// access to attributes
	//
	
	const Name * get_name() const { return mName; }
	void set_name(const Name * name);
	
	const Boolean * get_is_specification() const { return mIsSpecification; }
	void set_is_specification(const Boolean * is_specification);
	
	const string & ref_get_type() const;
	
    protected:
	//
	// reflective interface
	//
	
	void ref_set_context_impl(set<string> & visited, REF::Context * context);
	void ref_implant_impl(set<string> & visited) throw();
	void ref_uproot_impl(set<string> & visited) throw();
	
	//
	
	bool ref_is_a_type_of_impl(set<string> & visited,
				   const string & class_name) const;
	
	void ref_delete_impl(set<string> & visited);
	
	//
	
	bool ref_add_role_impl(set<string> & visited,
			       const string & role_name,
			       REF::Class * role,
			       REF::Class * position);
	
	bool ref_remove_role_impl(set<string> & visited,
				  const string & role_name,
				  REF::Class * role);
	
	bool ref_get_role_iterator_impl(set<string> & visited,
					REF::Iterator * & iterator,
					const string & role_name);
	
	bool ref_get_role_impl(set<string> & visited,
			       REF::Class * & role,
			       const string & role_name);
	
	bool ref_set_role_impl(set<string> & visited,
			       const string & role_name,
			       REF::Class * role);
	
	bool ref_create_class_impl(set<string> & visited,
				   REF::Class * & role,
				   const string & role_name) const;
	
	//
	
	bool ref_get_attribute_impl(set<string> & visited,
				    const REF::Attribute * & attribute,
				    const string & attribute_name) const;
	
	bool ref_set_attribute_impl(set<string> & visited,
				    const string & attribute_name,
				    const REF::Attribute * attribute);
	
	bool ref_get_attribute_set_impl(set<string> & visited,
					const vector<const REF::Attribute *> * & attribute_set,
					const string & attribute_name) const;
	
	bool ref_set_attribute_set_impl(set<string> & visited,
					const string & attribute_name,
					const vector<const REF::Attribute *> * attribute_set);
	
	bool ref_create_attribute_impl(set<string> & visited,
				       REF::Attribute * & attribute,
				       const string & attribute_name) const;
	
    private:
	//
	// copy constructor (copying is forbidden)
	//
	
	ModelElement(const ModelElement & model_element);
	
	//
	// roles storage
	//
	
	list<Constraint *> mConstraint;
	Namespace * mNamespace;
	list<Dependency *> mSupplierDependency;
	list<Dependency *> mClientDependency;
	list<Stereotype *> mStereotype;
	list<TaggedValue *> mTaggedValue;
	list<TaggedValue *> mReferenceTag;
	list<Comment *> mComment;
	list<PresentationElement *> mPresentation;
	
	//
	// attributes storage
	//
	
	Name * mName;
	Boolean * mIsSpecification;
	
	//
	// our type
	//
	
	static const string TYPE;
    };
    
} // namespace UML

#endif // UML_FOUNDATION_CORE_MODEL_ELEMENT_H
