// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UML_FOUNDATION_EXTENSION_MECHANISMS_TAGGED_VALUE_H
#define UML_FOUNDATION_EXTENSION_MECHANISMS_TAGGED_VALUE_H

#include "uml/foundation/core/model_element.h"

#include <list>
using namespace std;

namespace UML {
    
    class ModelElement;
    class Name;
    class TagDefinition;
    
    class TaggedValue : public ModelElement {
    public:
	//
	// constructor/destructor
	//
	
	TaggedValue();
	~TaggedValue();
	
	//
	// access to roles and role containers
	//
	
	ModelElement * get_owner() const { return mOwner; }
	void set_owner(ModelElement * owner);
	
	void internal_set_owner(ModelElement * owner);
	
	const list<ModelElement *> & get_reference_value() const { return mReferenceValue; }
	void set_reference_value(const list<ModelElement *> & reference_value);
	void add_reference_value(ModelElement * reference_value, int index = -1);
	void remove_reference_value(ModelElement * reference_value);
	
	void internal_add_reference_value(ModelElement * reference_value);
	void internal_remove_reference_value(ModelElement * reference_value);
	
	TagDefinition * get_type() const { return mType; }
	void set_type(TagDefinition * type);
	
	void internal_set_type(TagDefinition * type);
	
	//
	// access to attributes
	//
	
	const Name * get_data_value() const { return mDataValue; }
	void set_data_value(const Name * data_value);
	
	const string & ref_get_type() const;
	
    protected:
	//
	// reflective interface
	//
	
	void ref_set_context_impl(set<string> & visited, REF::Context * context);
	void ref_implant_impl(set<string> & visited) throw();
	void ref_uproot_impl(set<string> & visited) throw();
	
	//
	
	bool ref_is_a_type_of_impl(set<string> & visited,
				   const string & class_name) const;
	
	void ref_delete_impl(set<string> & visited);
	
	//
	
	bool ref_add_role_impl(set<string> & visited,
			       const string & role_name,
			       REF::Class * role,
			       REF::Class * position);
	
	bool ref_remove_role_impl(set<string> & visited,
				  const string & role_name,
				  REF::Class * role);
	
	bool ref_get_role_iterator_impl(set<string> & visited,
					REF::Iterator * & iterator,
					const string & role_name);
	
	bool ref_get_role_impl(set<string> & visited,
			       REF::Class * & role,
			       const string & role_name);
	
	bool ref_set_role_impl(set<string> & visited,
			       const string & role_name,
			       REF::Class * role);
	
	bool ref_create_class_impl(set<string> & visited,
				   REF::Class * & role,
				   const string & role_name) const;
	
	//
	
	bool ref_get_attribute_impl(set<string> & visited,
				    const REF::Attribute * & attribute,
				    const string & attribute_name) const;
	
	bool ref_set_attribute_impl(set<string> & visited,
				    const string & attribute_name,
				    const REF::Attribute * attribute);
	
	bool ref_get_attribute_set_impl(set<string> & visited,
					const vector<const REF::Attribute *> * & attribute_set,
					const string & attribute_name) const;
	
	bool ref_set_attribute_set_impl(set<string> & visited,
					const string & attribute_name,
					const vector<const REF::Attribute *> * attribute_set);
	
	bool ref_create_attribute_impl(set<string> & visited,
				       REF::Attribute * & attribute,
				       const string & attribute_name) const;
	
    private:
	//
	// copy constructor (copying is forbidden)
	//
	
	TaggedValue(const TaggedValue & tagged_value);
	
	//
	// roles storage
	//
	
	ModelElement * mOwner;
	list<ModelElement *> mReferenceValue;
	TagDefinition * mType;
	
	//
	// attributes storage
	//
	
	Name * mDataValue;
	
	//
	// our type
	//
	
	static const string TYPE;
    };
    
} // namespace UML

#endif // UML_FOUNDATION_EXTENSION_MECHANISMS_TAGGED_VALUE_H
