// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "handler.h"

#include "uml/foundation/core/generalizable_element.h"
#include "uml/foundation/core/constraint.h"
#include "uml/foundation/core/classifier.h"
#include "uml/foundation/core/structural_feature.h"
#include "uml/foundation/core/behavioral_feature.h"
#include "uml/foundation/core/element.h"
#include "uml/foundation/core/attribute.h"
#include "uml/foundation/core/operation.h"
#include "uml/foundation/core/method.h"
#include "uml/foundation/core/model_element.h"
#include "uml/foundation/core/feature.h"
#include "uml/foundation/core/namespace.h"
#include "uml/foundation/core/parameter.h"
#include "uml/foundation/core/interface.h"
#include "uml/foundation/core/data_type.h"
#include "uml/foundation/core/node.h"
#include "uml/foundation/core/comment.h"
#include "uml/foundation/core/relationship.h"
#include "uml/foundation/core/dependency.h"
#include "uml/foundation/core/binding.h"
#include "uml/foundation/core/abstraction.h"
#include "uml/foundation/core/usage.h"
#include "uml/foundation/core/permission.h"
#include "uml/foundation/core/generalization.h"
#include "uml/foundation/core/class.h"
#include "uml/foundation/core/association_class.h"
#include "uml/foundation/core/association.h"
#include "uml/foundation/core/association_end.h"
#include "uml/foundation/extension_mechanisms/stereotype.h"
#include "uml/foundation/extension_mechanisms/tagged_value.h"
#include "uml/foundation/extension_mechanisms/tag_definition.h"
#include "uml/model_management/package.h"
#include "uml/model_management/model.h"
#include "uml/diagram/diagram.h"
#include "uml/diagram/graph_element.h"
#include "uml/diagram/presentation_element.h"
#include "uml/diagram/edge_element.h"
#include "uml/diagram/node_element.h"
#include "uml/diagram/class_presentation.h"
#include "uml/diagram/package_presentation.h"
#include "uml/diagram/comment_presentation.h"
#include "uml/diagram/association_presentation.h"
#include "uml/diagram/generalization_presentation.h"
#include "uml/diagram/dependency_presentation.h"

#include "uml/foundation/data_types/integer.h"
#include "uml/foundation/data_types/name.h"
#include "uml/foundation/data_types/boolean.h"
#include "uml/foundation/data_types/aggregation_kind.h"
#include "uml/foundation/data_types/call_concurrency_kind.h"
#include "uml/foundation/data_types/changeable_kind.h"
#include "uml/foundation/data_types/ordering_kind.h"
#include "uml/foundation/data_types/parameter_direction_kind.h"
#include "uml/foundation/data_types/scope_kind.h"
#include "uml/foundation/data_types/visibility_kind.h"
#include "uml/foundation/data_types/diagram_kind.h"
#include "uml/foundation/data_types/multiplicity_type.h"
#include "xml/sax_parser.h"

#include "common/dumb_handler.h"

#include "foundation/iterator.h"
#include "foundation/utility.h"
#include "foundation/macros.h"


#include <iterator>
#include <functional>
#include <algorithm>
#include <sstream>
using namespace std;

namespace UML {
    
    Handler::Handler() : XML::SAXHandler() {
	mHandlerMap["UML:Constraint"] =
	make_pair(&Handler::uml__constraint__start,
		  &Handler::uml__constraint__end);
	
	mHandlerMap["UML:Attribute"] =
	make_pair(&Handler::uml__attribute__start,
		  &Handler::uml__attribute__end);
	
	mHandlerMap["UML:Operation"] =
	make_pair(&Handler::uml__operation__start,
		  &Handler::uml__operation__end);
	
	mHandlerMap["UML:Method"] =
	make_pair(&Handler::uml__method__start,
		  &Handler::uml__method__end);
	
	mHandlerMap["UML:Parameter"] =
	make_pair(&Handler::uml__parameter__start,
		  &Handler::uml__parameter__end);
	
	mHandlerMap["UML:Interface"] =
	make_pair(&Handler::uml__interface__start,
		  &Handler::uml__interface__end);
	
	mHandlerMap["UML:DataType"] =
	make_pair(&Handler::uml__data_type__start,
		  &Handler::uml__data_type__end);
	
	mHandlerMap["UML:Node"] =
	make_pair(&Handler::uml__node__start,
		  &Handler::uml__node__end);
	
	mHandlerMap["UML:Comment"] =
	make_pair(&Handler::uml__comment__start,
		  &Handler::uml__comment__end);
	
	mHandlerMap["UML:Dependency"] =
	make_pair(&Handler::uml__dependency__start,
		  &Handler::uml__dependency__end);
	
	mHandlerMap["UML:Binding"] =
	make_pair(&Handler::uml__binding__start,
		  &Handler::uml__binding__end);
	
	mHandlerMap["UML:Abstraction"] =
	make_pair(&Handler::uml__abstraction__start,
		  &Handler::uml__abstraction__end);
	
	mHandlerMap["UML:Usage"] =
	make_pair(&Handler::uml__usage__start,
		  &Handler::uml__usage__end);
	
	mHandlerMap["UML:Permission"] =
	make_pair(&Handler::uml__permission__start,
		  &Handler::uml__permission__end);
	
	mHandlerMap["UML:Generalization"] =
	make_pair(&Handler::uml__generalization__start,
		  &Handler::uml__generalization__end);
	
	mHandlerMap["UML:Class"] =
	make_pair(&Handler::uml__class__start,
		  &Handler::uml__class__end);
	
	mHandlerMap["UML:AssociationClass"] =
	make_pair(&Handler::uml__association_class__start,
		  &Handler::uml__association_class__end);
	
	mHandlerMap["UML:Association"] =
	make_pair(&Handler::uml__association__start,
		  &Handler::uml__association__end);
	
	mHandlerMap["UML:AssociationEnd"] =
	make_pair(&Handler::uml__association_end__start,
		  &Handler::uml__association_end__end);
	
	mHandlerMap["UML:Stereotype"] =
	make_pair(&Handler::uml__stereotype__start,
		  &Handler::uml__stereotype__end);
	
	mHandlerMap["UML:TaggedValue"] =
	make_pair(&Handler::uml__tagged_value__start,
		  &Handler::uml__tagged_value__end);
	
	mHandlerMap["UML:TagDefinition"] =
	make_pair(&Handler::uml__tag_definition__start,
		  &Handler::uml__tag_definition__end);
	
	mHandlerMap["UML:Package"] =
	make_pair(&Handler::uml__package__start,
		  &Handler::uml__package__end);
	
	mHandlerMap["UML:Model"] =
	make_pair(&Handler::uml__model__start,
		  &Handler::uml__model__end);
	
	mHandlerMap["UML:Diagram"] =
	make_pair(&Handler::uml__diagram__start,
		  &Handler::uml__diagram__end);
	
	mHandlerMap["UML:ClassPresentation"] =
	make_pair(&Handler::uml__class_presentation__start,
		  &Handler::uml__class_presentation__end);
	
	mHandlerMap["UML:PackagePresentation"] =
	make_pair(&Handler::uml__package_presentation__start,
		  &Handler::uml__package_presentation__end);
	
	mHandlerMap["UML:CommentPresentation"] =
	make_pair(&Handler::uml__comment_presentation__start,
		  &Handler::uml__comment_presentation__end);
	
	mHandlerMap["UML:AssociationPresentation"] =
	make_pair(&Handler::uml__association_presentation__start,
		  &Handler::uml__association_presentation__end);
	
	mHandlerMap["UML:GeneralizationPresentation"] =
	make_pair(&Handler::uml__generalization_presentation__start,
		  &Handler::uml__generalization_presentation__end);
	
	mHandlerMap["UML:DependencyPresentation"] =
	make_pair(&Handler::uml__dependency_presentation__start,
		  &Handler::uml__dependency_presentation__end);
	
	mHandlerMap["UML:GeneralizableElement.generalization"] =
	make_pair(&Handler::uml__generalizable_element__generalization__start,
		  &Handler::uml__generalizable_element__generalization__end);
	
	mHandlerMap["UML:GeneralizableElement.specialization"] =
	make_pair(&Handler::uml__generalizable_element__specialization__start,
		  &Handler::uml__generalizable_element__specialization__end);
	
	mHandlerMap["UML:GeneralizableElement.isRoot"] =
	make_pair(&Handler::uml__generalizable_element__is_root__start,
		  &Handler::uml__generalizable_element__is_root__end);
	
	mHandlerMap["UML:GeneralizableElement.isLeaf"] =
	make_pair(&Handler::uml__generalizable_element__is_leaf__start,
		  &Handler::uml__generalizable_element__is_leaf__end);
	
	mHandlerMap["UML:GeneralizableElement.isAbstract"] =
	make_pair(&Handler::uml__generalizable_element__is_abstract__start,
		  &Handler::uml__generalizable_element__is_abstract__end);
	
	mHandlerMap["UML:Constraint.constrainedElement"] =
	make_pair(&Handler::uml__constraint__constrained_element__start,
		  &Handler::uml__constraint__constrained_element__end);
	
	mHandlerMap["UML:Constraint.constrainedStereotype"] =
	make_pair(&Handler::uml__constraint__constrained_stereotype__start,
		  &Handler::uml__constraint__constrained_stereotype__end);
	
	mHandlerMap["UML:Classifier.feature"] =
	make_pair(&Handler::uml__classifier__feature__start,
		  &Handler::uml__classifier__feature__end);
	
	mHandlerMap["UML:Classifier.typedFeature"] =
	make_pair(&Handler::uml__classifier__typed_feature__start,
		  &Handler::uml__classifier__typed_feature__end);
	
	mHandlerMap["UML:Classifier.typedParameter"] =
	make_pair(&Handler::uml__classifier__typed_parameter__start,
		  &Handler::uml__classifier__typed_parameter__end);
	
	mHandlerMap["UML:Classifier.association"] =
	make_pair(&Handler::uml__classifier__association__start,
		  &Handler::uml__classifier__association__end);
	
	mHandlerMap["UML:BehavioralFeature.parameter"] =
	make_pair(&Handler::uml__behavioral_feature__parameter__start,
		  &Handler::uml__behavioral_feature__parameter__end);
	
	mHandlerMap["UML:BehavioralFeature.isQuery"] =
	make_pair(&Handler::uml__behavioral_feature__is_query__start,
		  &Handler::uml__behavioral_feature__is_query__end);
	
	mHandlerMap["UML:Attribute.associationEnd"] =
	make_pair(&Handler::uml__attribute__association_end__start,
		  &Handler::uml__attribute__association_end__end);
	
	mHandlerMap["UML:Operation.method"] =
	make_pair(&Handler::uml__operation__method__start,
		  &Handler::uml__operation__method__end);
	
	mHandlerMap["UML:Method.specification"] =
	make_pair(&Handler::uml__method__specification__start,
		  &Handler::uml__method__specification__end);
	
	mHandlerMap["UML:ModelElement.constraint"] =
	make_pair(&Handler::uml__model_element__constraint__start,
		  &Handler::uml__model_element__constraint__end);
	
	mHandlerMap["UML:ModelElement.namespace"] =
	make_pair(&Handler::uml__model_element__namespace__start,
		  &Handler::uml__model_element__namespace__end);
	
	mHandlerMap["UML:ModelElement.supplierDependency"] =
	make_pair(&Handler::uml__model_element__supplier_dependency__start,
		  &Handler::uml__model_element__supplier_dependency__end);
	
	mHandlerMap["UML:ModelElement.clientDependency"] =
	make_pair(&Handler::uml__model_element__client_dependency__start,
		  &Handler::uml__model_element__client_dependency__end);
	
	mHandlerMap["UML:ModelElement.stereotype"] =
	make_pair(&Handler::uml__model_element__stereotype__start,
		  &Handler::uml__model_element__stereotype__end);
	
	mHandlerMap["UML:ModelElement.taggedValue"] =
	make_pair(&Handler::uml__model_element__tagged_value__start,
		  &Handler::uml__model_element__tagged_value__end);
	
	mHandlerMap["UML:ModelElement.referenceTag"] =
	make_pair(&Handler::uml__model_element__reference_tag__start,
		  &Handler::uml__model_element__reference_tag__end);
	
	mHandlerMap["UML:ModelElement.comment"] =
	make_pair(&Handler::uml__model_element__comment__start,
		  &Handler::uml__model_element__comment__end);
	
	mHandlerMap["UML:ModelElement.presentation"] =
	make_pair(&Handler::uml__model_element__presentation__start,
		  &Handler::uml__model_element__presentation__end);
	
	mHandlerMap["UML:ModelElement.name"] =
	make_pair(&Handler::uml__model_element__name__start,
		  &Handler::uml__model_element__name__end);
	
	mHandlerMap["UML:ModelElement.isSpecification"] =
	make_pair(&Handler::uml__model_element__is_specification__start,
		  &Handler::uml__model_element__is_specification__end);
	
	mHandlerMap["UML:Feature.owner"] =
	make_pair(&Handler::uml__feature__owner__start,
		  &Handler::uml__feature__owner__end);
	
	mHandlerMap["UML:Namespace.ownedElement"] =
	make_pair(&Handler::uml__namespace__owned_element__start,
		  &Handler::uml__namespace__owned_element__end);
	
	mHandlerMap["UML:Parameter.behavioralFeature"] =
	make_pair(&Handler::uml__parameter__behavioral_feature__start,
		  &Handler::uml__parameter__behavioral_feature__end);
	
	mHandlerMap["UML:Comment.annotatedElement"] =
	make_pair(&Handler::uml__comment__annotated_element__start,
		  &Handler::uml__comment__annotated_element__end);
	
	mHandlerMap["UML:Comment.body"] =
	make_pair(&Handler::uml__comment__body__start,
		  &Handler::uml__comment__body__end);
	
	mHandlerMap["UML:Dependency.supplier"] =
	make_pair(&Handler::uml__dependency__supplier__start,
		  &Handler::uml__dependency__supplier__end);
	
	mHandlerMap["UML:Dependency.client"] =
	make_pair(&Handler::uml__dependency__client__start,
		  &Handler::uml__dependency__client__end);
	
	mHandlerMap["UML:Generalization.child"] =
	make_pair(&Handler::uml__generalization__child__start,
		  &Handler::uml__generalization__child__end);
	
	mHandlerMap["UML:Generalization.parent"] =
	make_pair(&Handler::uml__generalization__parent__start,
		  &Handler::uml__generalization__parent__end);
	
	mHandlerMap["UML:Generalization.discriminator"] =
	make_pair(&Handler::uml__generalization__discriminator__start,
		  &Handler::uml__generalization__discriminator__end);
	
	mHandlerMap["UML:Association.connection"] =
	make_pair(&Handler::uml__association__connection__start,
		  &Handler::uml__association__connection__end);
	
	mHandlerMap["UML:AssociationEnd.connector"] =
	make_pair(&Handler::uml__association_end__connector__start,
		  &Handler::uml__association_end__connector__end);
	
	mHandlerMap["UML:AssociationEnd.type"] =
	make_pair(&Handler::uml__association_end__type__start,
		  &Handler::uml__association_end__type__end);
	
	mHandlerMap["UML:AssociationEnd.qualifier"] =
	make_pair(&Handler::uml__association_end__qualifier__start,
		  &Handler::uml__association_end__qualifier__end);
	
	mHandlerMap["UML:Stereotype.extendedElement"] =
	make_pair(&Handler::uml__stereotype__extended_element__start,
		  &Handler::uml__stereotype__extended_element__end);
	
	mHandlerMap["UML:Stereotype.stereotypeConstraint"] =
	make_pair(&Handler::uml__stereotype__stereotype_constraint__start,
		  &Handler::uml__stereotype__stereotype_constraint__end);
	
	mHandlerMap["UML:Stereotype.definedTag"] =
	make_pair(&Handler::uml__stereotype__defined_tag__start,
		  &Handler::uml__stereotype__defined_tag__end);
	
	mHandlerMap["UML:TaggedValue.owner"] =
	make_pair(&Handler::uml__tagged_value__owner__start,
		  &Handler::uml__tagged_value__owner__end);
	
	mHandlerMap["UML:TaggedValue.referenceValue"] =
	make_pair(&Handler::uml__tagged_value__reference_value__start,
		  &Handler::uml__tagged_value__reference_value__end);
	
	mHandlerMap["UML:TaggedValue.type"] =
	make_pair(&Handler::uml__tagged_value__type__start,
		  &Handler::uml__tagged_value__type__end);
	
	mHandlerMap["UML:TaggedValue.dataValue"] =
	make_pair(&Handler::uml__tagged_value__data_value__start,
		  &Handler::uml__tagged_value__data_value__end);
	
	mHandlerMap["UML:TagDefinition.owner"] =
	make_pair(&Handler::uml__tag_definition__owner__start,
		  &Handler::uml__tag_definition__owner__end);
	
	mHandlerMap["UML:TagDefinition.typedValue"] =
	make_pair(&Handler::uml__tag_definition__typed_value__start,
		  &Handler::uml__tag_definition__typed_value__end);
	
	mHandlerMap["UML:TagDefinition.tagType"] =
	make_pair(&Handler::uml__tag_definition__tag_type__start,
		  &Handler::uml__tag_definition__tag_type__end);
	
	mHandlerMap["UML:Diagram.element"] =
	make_pair(&Handler::uml__diagram__element__start,
		  &Handler::uml__diagram__element__end);
	
	mHandlerMap["UML:Diagram.name"] =
	make_pair(&Handler::uml__diagram__name__start,
		  &Handler::uml__diagram__name__end);
	
	mHandlerMap["UML:GraphElement.diagram"] =
	make_pair(&Handler::uml__graph_element__diagram__start,
		  &Handler::uml__graph_element__diagram__end);
	
	mHandlerMap["UML:GraphElement.geometry"] =
	make_pair(&Handler::uml__graph_element__geometry__start,
		  &Handler::uml__graph_element__geometry__end);
	
	mHandlerMap["UML:PresentationElement.subject"] =
	make_pair(&Handler::uml__presentation_element__subject__start,
		  &Handler::uml__presentation_element__subject__end);
	
	mHandlerMap["UML:PresentationElement.supplierDependency"] =
	make_pair(&Handler::uml__presentation_element__supplier_dependency__start,
		  &Handler::uml__presentation_element__supplier_dependency__end);
	
	mHandlerMap["UML:PresentationElement.clientDependency"] =
	make_pair(&Handler::uml__presentation_element__client_dependency__start,
		  &Handler::uml__presentation_element__client_dependency__end);
	
	mHandlerMap["UML:ClassPresentation.association_source"] =
	make_pair(&Handler::uml__class_presentation__association_source__start,
		  &Handler::uml__class_presentation__association_source__end);
	
	mHandlerMap["UML:ClassPresentation.association_destination"] =
	make_pair(&Handler::uml__class_presentation__association_destination__start,
		  &Handler::uml__class_presentation__association_destination__end);
	
	mHandlerMap["UML:ClassPresentation.generalization"] =
	make_pair(&Handler::uml__class_presentation__generalization__start,
		  &Handler::uml__class_presentation__generalization__end);
	
	mHandlerMap["UML:ClassPresentation.specialization"] =
	make_pair(&Handler::uml__class_presentation__specialization__start,
		  &Handler::uml__class_presentation__specialization__end);
	
	mHandlerMap["UML:AssociationPresentation.source"] =
	make_pair(&Handler::uml__association_presentation__source__start,
		  &Handler::uml__association_presentation__source__end);
	
	mHandlerMap["UML:AssociationPresentation.destination"] =
	make_pair(&Handler::uml__association_presentation__destination__start,
		  &Handler::uml__association_presentation__destination__end);
	
	mHandlerMap["UML:GeneralizationPresentation.subtype"] =
	make_pair(&Handler::uml__generalization_presentation__subtype__start,
		  &Handler::uml__generalization_presentation__subtype__end);
	
	mHandlerMap["UML:GeneralizationPresentation.supertype"] =
	make_pair(&Handler::uml__generalization_presentation__supertype__start,
		  &Handler::uml__generalization_presentation__supertype__end);
	
	mHandlerMap["UML:DependencyPresentation.supplier"] =
	make_pair(&Handler::uml__dependency_presentation__supplier__start,
		  &Handler::uml__dependency_presentation__supplier__end);
	
	mHandlerMap["UML:DependencyPresentation.client"] =
	make_pair(&Handler::uml__dependency_presentation__client__start,
		  &Handler::uml__dependency_presentation__client__end);
	
    }
    
    Handler::~Handler() {
    }
    
    void
    Handler::warning(XML::SAXParser * parser, const string & msg) {
	WARNING("Unhandled warning: " << msg);
    }
    
    void
    Handler::error(XML::SAXParser * parser, const string & msg) {
	WARNING("Unhandled error: " << msg);
    }
    
    void
    Handler::fatal(XML::SAXParser * parser, const string & msg) {
	WARNING("Unhandled fatal: " << msg);
    }
    
    void
    Handler::comment(XML::SAXParser * parser, const string & comment) {
    }
    
    void
    Handler::start_document(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
    }
    
    void
    Handler::end_document(XML::SAXParser * parser) {
	if(parser->get_pass() == 2) {
	    for(hash_map<string, Object *>::iterator iter = mElementMap.begin();
		iter != mElementMap.end();
		++iter) {
		iter->second->unref();
	    }
	    
	    mElementMap.clear();
	}
    }
    
    void
    Handler::start_element(XML::SAXParser * parser, const string & name,
			   const XML::Properties & properties) {
	TRACE(5, "Start: " << name);
	
	mCharacters.resize(0);
	
	hash_map<string, HandlerPair>::iterator iter = mHandlerMap.find(name);
	
	if(iter == mHandlerMap.end()) {
	    if(mUnhandledElements.insert(name).second) {
		WARNING("Unhandled element: " << name);
	    }
	    
	    // push a dumb handler so that we don't try to parse
	    // the contents of the tag
	    
	    XML::SAXHandler * handler = new Common::DumbHandler();
	    parser->use(handler);
	    handler->unref();
	}
	else {
	    HandlerPair handler_pair = iter->second;
	    (this->*handler_pair.first)(parser, properties);
	}
    }
    
    void
    Handler::end_element(XML::SAXParser * parser, const string & name) {
	hash_map<string, HandlerPair>::iterator iter = mHandlerMap.find(name);
	
	if(iter == mHandlerMap.end()) {
	}
	else {
	    HandlerPair handler_pair = iter->second;
	    (this->*handler_pair.second)(parser);
	}
	
	TRACE(5, "End: " << name);
    }
    
    void
    Handler::characters(XML::SAXParser * parser, const string & data) {
	mCharacters += data;
    }
    
    void
    Handler::reference(XML::SAXParser * parser, const string & name) {
	WARNING("Unhandled Reference: " << name);
    }
    
    void
    Handler::cdata_block(XML::SAXParser * parser, const string & data) {
	WARNING("Unhandled CDATA: " << data);
    }
    
    void
    Handler::store(const string & id, Object * object) {
	if(!mElementMap.insert(make_pair(id, object)).second) {
	    ERROR("Duplicate id: " << id);
	}
    }
    
    Object *
    Handler::lookup(const string & id) {
	hash_map<string, Object *>::iterator iter = mElementMap.find(id);
	
	if(iter == mElementMap.end()) {
	    ERROR("Couldn't locate element with id: " << id);
	    throw;	// FIXME
	}
	else {
	    return iter->second;
	}
    }
    
    void
    Handler::uml__constraint__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Constraint());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * constraint;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		constraint = lookup(idref);
		constraint->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		constraint = lookup(id);
		constraint->ref();
	    }
	    else {
		constraint = new Constraint();
	    }
	    
	    ASSERT(constraint);
	    
	    parser->top().push_back(constraint);
	}
    }
    
    void
    Handler::uml__constraint__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__attribute__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Attribute());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * attribute;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		attribute = lookup(idref);
		attribute->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		attribute = lookup(id);
		attribute->ref();
	    }
	    else {
		attribute = new Attribute();
	    }
	    
	    ASSERT(attribute);
	    
	    parser->top().push_back(attribute);
	}
    }
    
    void
    Handler::uml__attribute__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__operation__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Operation());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * operation;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		operation = lookup(idref);
		operation->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		operation = lookup(id);
		operation->ref();
	    }
	    else {
		operation = new Operation();
	    }
	    
	    ASSERT(operation);
	    
	    parser->top().push_back(operation);
	}
    }
    
    void
    Handler::uml__operation__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__method__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Method());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * method;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		method = lookup(idref);
		method->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		method = lookup(id);
		method->ref();
	    }
	    else {
		method = new Method();
	    }
	    
	    ASSERT(method);
	    
	    parser->top().push_back(method);
	}
    }
    
    void
    Handler::uml__method__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__parameter__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Parameter());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * parameter;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		parameter = lookup(idref);
		parameter->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		parameter = lookup(id);
		parameter->ref();
	    }
	    else {
		parameter = new Parameter();
	    }
	    
	    ASSERT(parameter);
	    
	    parser->top().push_back(parameter);
	}
    }
    
    void
    Handler::uml__parameter__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__interface__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Interface());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * interface;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		interface = lookup(idref);
		interface->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		interface = lookup(id);
		interface->ref();
	    }
	    else {
		interface = new Interface();
	    }
	    
	    ASSERT(interface);
	    
	    parser->top().push_back(interface);
	}
    }
    
    void
    Handler::uml__interface__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__data_type__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new DataType());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * data_type;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		data_type = lookup(idref);
		data_type->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		data_type = lookup(id);
		data_type->ref();
	    }
	    else {
		data_type = new DataType();
	    }
	    
	    ASSERT(data_type);
	    
	    parser->top().push_back(data_type);
	}
    }
    
    void
    Handler::uml__data_type__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__node__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Node());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * node;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		node = lookup(idref);
		node->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		node = lookup(id);
		node->ref();
	    }
	    else {
		node = new Node();
	    }
	    
	    ASSERT(node);
	    
	    parser->top().push_back(node);
	}
    }
    
    void
    Handler::uml__node__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__comment__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Comment());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * comment;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		comment = lookup(idref);
		comment->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		comment = lookup(id);
		comment->ref();
	    }
	    else {
		comment = new Comment();
	    }
	    
	    ASSERT(comment);
	    
	    parser->top().push_back(comment);
	}
    }
    
    void
    Handler::uml__comment__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__dependency__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Dependency());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * dependency;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		dependency = lookup(idref);
		dependency->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		dependency = lookup(id);
		dependency->ref();
	    }
	    else {
		dependency = new Dependency();
	    }
	    
	    ASSERT(dependency);
	    
	    parser->top().push_back(dependency);
	}
    }
    
    void
    Handler::uml__dependency__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__binding__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Binding());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * binding;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		binding = lookup(idref);
		binding->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		binding = lookup(id);
		binding->ref();
	    }
	    else {
		binding = new Binding();
	    }
	    
	    ASSERT(binding);
	    
	    parser->top().push_back(binding);
	}
    }
    
    void
    Handler::uml__binding__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__abstraction__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Abstraction());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * abstraction;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		abstraction = lookup(idref);
		abstraction->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		abstraction = lookup(id);
		abstraction->ref();
	    }
	    else {
		abstraction = new Abstraction();
	    }
	    
	    ASSERT(abstraction);
	    
	    parser->top().push_back(abstraction);
	}
    }
    
    void
    Handler::uml__abstraction__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__usage__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Usage());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * usage;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		usage = lookup(idref);
		usage->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		usage = lookup(id);
		usage->ref();
	    }
	    else {
		usage = new Usage();
	    }
	    
	    ASSERT(usage);
	    
	    parser->top().push_back(usage);
	}
    }
    
    void
    Handler::uml__usage__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__permission__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Permission());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * permission;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		permission = lookup(idref);
		permission->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		permission = lookup(id);
		permission->ref();
	    }
	    else {
		permission = new Permission();
	    }
	    
	    ASSERT(permission);
	    
	    parser->top().push_back(permission);
	}
    }
    
    void
    Handler::uml__permission__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__generalization__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Generalization());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * generalization;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		generalization = lookup(idref);
		generalization->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		generalization = lookup(id);
		generalization->ref();
	    }
	    else {
		generalization = new Generalization();
	    }
	    
	    ASSERT(generalization);
	    
	    parser->top().push_back(generalization);
	}
    }
    
    void
    Handler::uml__generalization__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__class__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Class());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * class_;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		class_ = lookup(idref);
		class_->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		class_ = lookup(id);
		class_->ref();
	    }
	    else {
		class_ = new Class();
	    }
	    
	    ASSERT(class_);
	    
	    parser->top().push_back(class_);
	}
    }
    
    void
    Handler::uml__class__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__association_class__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new AssociationClass());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * association_class;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		association_class = lookup(idref);
		association_class->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		association_class = lookup(id);
		association_class->ref();
	    }
	    else {
		association_class = new AssociationClass();
	    }
	    
	    ASSERT(association_class);
	    
	    parser->top().push_back(association_class);
	}
    }
    
    void
    Handler::uml__association_class__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__association__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Association());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * association;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		association = lookup(idref);
		association->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		association = lookup(id);
		association->ref();
	    }
	    else {
		association = new Association();
	    }
	    
	    ASSERT(association);
	    
	    parser->top().push_back(association);
	}
    }
    
    void
    Handler::uml__association__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__association_end__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new AssociationEnd());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * association_end;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		association_end = lookup(idref);
		association_end->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		association_end = lookup(id);
		association_end->ref();
	    }
	    else {
		association_end = new AssociationEnd();
	    }
	    
	    ASSERT(association_end);
	    
	    parser->top().push_back(association_end);
	}
    }
    
    void
    Handler::uml__association_end__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__stereotype__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Stereotype());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * stereotype;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		stereotype = lookup(idref);
		stereotype->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		stereotype = lookup(id);
		stereotype->ref();
	    }
	    else {
		stereotype = new Stereotype();
	    }
	    
	    ASSERT(stereotype);
	    
	    parser->top().push_back(stereotype);
	}
    }
    
    void
    Handler::uml__stereotype__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__tagged_value__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new TaggedValue());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * tagged_value;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		tagged_value = lookup(idref);
		tagged_value->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		tagged_value = lookup(id);
		tagged_value->ref();
	    }
	    else {
		tagged_value = new TaggedValue();
	    }
	    
	    ASSERT(tagged_value);
	    
	    parser->top().push_back(tagged_value);
	}
    }
    
    void
    Handler::uml__tagged_value__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__tag_definition__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new TagDefinition());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * tag_definition;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		tag_definition = lookup(idref);
		tag_definition->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		tag_definition = lookup(id);
		tag_definition->ref();
	    }
	    else {
		tag_definition = new TagDefinition();
	    }
	    
	    ASSERT(tag_definition);
	    
	    parser->top().push_back(tag_definition);
	}
    }
    
    void
    Handler::uml__tag_definition__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__package__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Package());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * package;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		package = lookup(idref);
		package->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		package = lookup(id);
		package->ref();
	    }
	    else {
		package = new Package();
	    }
	    
	    ASSERT(package);
	    
	    parser->top().push_back(package);
	}
    }
    
    void
    Handler::uml__package__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__model__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Model());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * model;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		model = lookup(idref);
		model->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		model = lookup(id);
		model->ref();
	    }
	    else {
		model = new Model();
	    }
	    
	    ASSERT(model);
	    
	    parser->top().push_back(model);
	}
    }
    
    void
    Handler::uml__model__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__diagram__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new Diagram());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * diagram;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		diagram = lookup(idref);
		diagram->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		diagram = lookup(id);
		diagram->ref();
	    }
	    else {
		diagram = new Diagram();
	    }
	    
	    ASSERT(diagram);
	    
	    parser->top().push_back(diagram);
	}
    }
    
    void
    Handler::uml__diagram__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__class_presentation__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new ClassPresentation());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * class_presentation;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		class_presentation = lookup(idref);
		class_presentation->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		class_presentation = lookup(id);
		class_presentation->ref();
	    }
	    else {
		class_presentation = new ClassPresentation();
	    }
	    
	    ASSERT(class_presentation);
	    
	    parser->top().push_back(class_presentation);
	}
    }
    
    void
    Handler::uml__class_presentation__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__package_presentation__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new PackagePresentation());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * package_presentation;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		package_presentation = lookup(idref);
		package_presentation->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		package_presentation = lookup(id);
		package_presentation->ref();
	    }
	    else {
		package_presentation = new PackagePresentation();
	    }
	    
	    ASSERT(package_presentation);
	    
	    parser->top().push_back(package_presentation);
	}
    }
    
    void
    Handler::uml__package_presentation__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__comment_presentation__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new CommentPresentation());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * comment_presentation;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		comment_presentation = lookup(idref);
		comment_presentation->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		comment_presentation = lookup(id);
		comment_presentation->ref();
	    }
	    else {
		comment_presentation = new CommentPresentation();
	    }
	    
	    ASSERT(comment_presentation);
	    
	    parser->top().push_back(comment_presentation);
	}
    }
    
    void
    Handler::uml__comment_presentation__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__association_presentation__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new AssociationPresentation());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * association_presentation;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		association_presentation = lookup(idref);
		association_presentation->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		association_presentation = lookup(id);
		association_presentation->ref();
	    }
	    else {
		association_presentation = new AssociationPresentation();
	    }
	    
	    ASSERT(association_presentation);
	    
	    parser->top().push_back(association_presentation);
	}
    }
    
    void
    Handler::uml__association_presentation__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__generalization_presentation__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new GeneralizationPresentation());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * generalization_presentation;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		generalization_presentation = lookup(idref);
		generalization_presentation->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		generalization_presentation = lookup(id);
		generalization_presentation->ref();
	    }
	    else {
		generalization_presentation = new GeneralizationPresentation();
	    }
	    
	    ASSERT(generalization_presentation);
	    
	    parser->top().push_back(generalization_presentation);
	}
    }
    
    void
    Handler::uml__generalization_presentation__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__dependency_presentation__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	    string id;
	    
	    if(properties.get_implied_property("xmi.id", id)) {
		store(id, new DependencyPresentation());
	    }
	}
	else {
	    string idref;
	    string id;
	    
	    Object * dependency_presentation;
	    
	    if(properties.get_implied_property("xmi.idref", idref)) {
		dependency_presentation = lookup(idref);
		dependency_presentation->ref();
	    }
	    else if(properties.get_implied_property("xmi.id", id)) {
		dependency_presentation = lookup(id);
		dependency_presentation->ref();
	    }
	    else {
		dependency_presentation = new DependencyPresentation();
	    }
	    
	    ASSERT(dependency_presentation);
	    
	    parser->top().push_back(dependency_presentation);
	}
    }
    
    void
    Handler::uml__dependency_presentation__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__generalizable_element__generalization__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__generalizable_element__generalization__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Generalization *> generalization;
	    
	    transform(objects.begin(), objects.end(), back_inserter(generalization), Caster<Object, Generalization>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    GeneralizableElement * generalizable_element = known_cast<GeneralizableElement *>(parser->top().back());
	    
	    generalizable_element->set_generalization(generalization);
	    
	}
    }
    
    void
    Handler::uml__generalizable_element__specialization__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__generalizable_element__specialization__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Generalization *> specialization;
	    
	    transform(objects.begin(), objects.end(), back_inserter(specialization), Caster<Object, Generalization>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    GeneralizableElement * generalizable_element = known_cast<GeneralizableElement *>(parser->top().back());
	    
	    generalizable_element->set_specialization(specialization);
	    
	}
    }
    
    void
    Handler::uml__generalizable_element__is_root__start(XML::SAXParser * parser, const XML::Properties & properties) {
    }
    
    void
    Handler::uml__generalizable_element__is_root__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__generalizable_element__is_leaf__start(XML::SAXParser * parser, const XML::Properties & properties) {
    }
    
    void
    Handler::uml__generalizable_element__is_leaf__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__generalizable_element__is_abstract__start(XML::SAXParser * parser, const XML::Properties & properties) {
    }
    
    void
    Handler::uml__generalizable_element__is_abstract__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__constraint__constrained_element__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__constraint__constrained_element__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<ModelElement *> constrained_element;
	    
	    transform(objects.begin(), objects.end(), back_inserter(constrained_element), Caster<Object, ModelElement>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Constraint * constraint = known_cast<Constraint *>(parser->top().back());
	    
	    constraint->set_constrained_element(constrained_element);
	    
	}
    }
    
    void
    Handler::uml__constraint__constrained_stereotype__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__constraint__constrained_stereotype__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    Stereotype * constrained_stereotype = known_cast<Stereotype *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Constraint * constraint = known_cast<Constraint *>(parser->top().back());
	    
	    constraint->set_constrained_stereotype(constrained_stereotype);
	    
	    constrained_stereotype->unref();
	}
    }
    
    void
    Handler::uml__classifier__feature__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__classifier__feature__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Feature *> feature;
	    
	    transform(objects.begin(), objects.end(), back_inserter(feature), Caster<Object, Feature>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Classifier * classifier = known_cast<Classifier *>(parser->top().back());
	    
	    classifier->set_feature(feature);
	    
	}
    }
    
    void
    Handler::uml__classifier__typed_feature__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__classifier__typed_feature__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<StructuralFeature *> typed_feature;
	    
	    transform(objects.begin(), objects.end(), back_inserter(typed_feature), Caster<Object, StructuralFeature>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Classifier * classifier = known_cast<Classifier *>(parser->top().back());
	    
	    classifier->set_typed_feature(typed_feature);
	    
	}
    }
    
    void
    Handler::uml__classifier__typed_parameter__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__classifier__typed_parameter__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Parameter *> typed_parameter;
	    
	    transform(objects.begin(), objects.end(), back_inserter(typed_parameter), Caster<Object, Parameter>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Classifier * classifier = known_cast<Classifier *>(parser->top().back());
	    
	    classifier->set_typed_parameter(typed_parameter);
	    
	}
    }
    
    void
    Handler::uml__classifier__association__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__classifier__association__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<AssociationEnd *> association;
	    
	    transform(objects.begin(), objects.end(), back_inserter(association), Caster<Object, AssociationEnd>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Classifier * classifier = known_cast<Classifier *>(parser->top().back());
	    
	    classifier->set_association(association);
	    
	}
    }
    
    void
    Handler::uml__behavioral_feature__parameter__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__behavioral_feature__parameter__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Parameter *> parameter;
	    
	    transform(objects.begin(), objects.end(), back_inserter(parameter), Caster<Object, Parameter>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    BehavioralFeature * behavioral_feature = known_cast<BehavioralFeature *>(parser->top().back());
	    
	    behavioral_feature->set_parameter(parameter);
	    
	}
    }
    
    void
    Handler::uml__behavioral_feature__is_query__start(XML::SAXParser * parser, const XML::Properties & properties) {
    }
    
    void
    Handler::uml__behavioral_feature__is_query__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__attribute__association_end__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__attribute__association_end__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    AssociationEnd * association_end = known_cast<AssociationEnd *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Attribute * attribute = known_cast<Attribute *>(parser->top().back());
	    
	    attribute->set_association_end(association_end);
	    
	    association_end->unref();
	}
    }
    
    void
    Handler::uml__operation__method__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__operation__method__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Method *> method;
	    
	    transform(objects.begin(), objects.end(), back_inserter(method), Caster<Object, Method>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Operation * operation = known_cast<Operation *>(parser->top().back());
	    
	    operation->set_method(method);
	    
	}
    }
    
    void
    Handler::uml__method__specification__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__method__specification__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Operation *> specification;
	    
	    transform(objects.begin(), objects.end(), back_inserter(specification), Caster<Object, Operation>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Method * method = known_cast<Method *>(parser->top().back());
	    
	    method->set_specification(specification);
	    
	}
    }
    
    void
    Handler::uml__model_element__constraint__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__model_element__constraint__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Constraint *> constraint;
	    
	    transform(objects.begin(), objects.end(), back_inserter(constraint), Caster<Object, Constraint>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    ModelElement * model_element = known_cast<ModelElement *>(parser->top().back());
	    
	    model_element->set_constraint(constraint);
	    
	}
    }
    
    void
    Handler::uml__model_element__namespace__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__model_element__namespace__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    Namespace * namespace_ = known_cast<Namespace *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    ModelElement * model_element = known_cast<ModelElement *>(parser->top().back());
	    
	    model_element->set_namespace(namespace_);
	    
	    namespace_->unref();
	}
    }
    
    void
    Handler::uml__model_element__supplier_dependency__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__model_element__supplier_dependency__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Dependency *> supplier_dependency;
	    
	    transform(objects.begin(), objects.end(), back_inserter(supplier_dependency), Caster<Object, Dependency>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    ModelElement * model_element = known_cast<ModelElement *>(parser->top().back());
	    
	    model_element->set_supplier_dependency(supplier_dependency);
	    
	}
    }
    
    void
    Handler::uml__model_element__client_dependency__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__model_element__client_dependency__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Dependency *> client_dependency;
	    
	    transform(objects.begin(), objects.end(), back_inserter(client_dependency), Caster<Object, Dependency>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    ModelElement * model_element = known_cast<ModelElement *>(parser->top().back());
	    
	    model_element->set_client_dependency(client_dependency);
	    
	}
    }
    
    void
    Handler::uml__model_element__stereotype__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__model_element__stereotype__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Stereotype *> stereotype;
	    
	    transform(objects.begin(), objects.end(), back_inserter(stereotype), Caster<Object, Stereotype>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    ModelElement * model_element = known_cast<ModelElement *>(parser->top().back());
	    
	    model_element->set_stereotype(stereotype);
	    
	}
    }
    
    void
    Handler::uml__model_element__tagged_value__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__model_element__tagged_value__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<TaggedValue *> tagged_value;
	    
	    transform(objects.begin(), objects.end(), back_inserter(tagged_value), Caster<Object, TaggedValue>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    ModelElement * model_element = known_cast<ModelElement *>(parser->top().back());
	    
	    model_element->set_tagged_value(tagged_value);
	    
	}
    }
    
    void
    Handler::uml__model_element__reference_tag__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__model_element__reference_tag__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<TaggedValue *> reference_tag;
	    
	    transform(objects.begin(), objects.end(), back_inserter(reference_tag), Caster<Object, TaggedValue>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    ModelElement * model_element = known_cast<ModelElement *>(parser->top().back());
	    
	    model_element->set_reference_tag(reference_tag);
	    
	}
    }
    
    void
    Handler::uml__model_element__comment__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__model_element__comment__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Comment *> comment;
	    
	    transform(objects.begin(), objects.end(), back_inserter(comment), Caster<Object, Comment>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    ModelElement * model_element = known_cast<ModelElement *>(parser->top().back());
	    
	    model_element->set_comment(comment);
	    
	}
    }
    
    void
    Handler::uml__model_element__presentation__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__model_element__presentation__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<PresentationElement *> presentation;
	    
	    transform(objects.begin(), objects.end(), back_inserter(presentation), Caster<Object, PresentationElement>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    ModelElement * model_element = known_cast<ModelElement *>(parser->top().back());
	    
	    model_element->set_presentation(presentation);
	    
	}
    }
    
    void
    Handler::uml__model_element__name__start(XML::SAXParser * parser, const XML::Properties & properties) {
    }
    
    void
    Handler::uml__model_element__name__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__model_element__is_specification__start(XML::SAXParser * parser, const XML::Properties & properties) {
    }
    
    void
    Handler::uml__model_element__is_specification__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__feature__owner__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__feature__owner__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    Classifier * owner = known_cast<Classifier *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Feature * feature = known_cast<Feature *>(parser->top().back());
	    
	    feature->set_owner(owner);
	    
	    owner->unref();
	}
    }
    
    void
    Handler::uml__namespace__owned_element__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__namespace__owned_element__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<ModelElement *> owned_element;
	    
	    transform(objects.begin(), objects.end(), back_inserter(owned_element), Caster<Object, ModelElement>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Namespace * namespace_ = known_cast<Namespace *>(parser->top().back());
	    
	    namespace_->set_owned_element(owned_element);
	    
	}
    }
    
    void
    Handler::uml__parameter__behavioral_feature__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__parameter__behavioral_feature__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    BehavioralFeature * behavioral_feature = known_cast<BehavioralFeature *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Parameter * parameter = known_cast<Parameter *>(parser->top().back());
	    
	    parameter->set_behavioral_feature(behavioral_feature);
	    
	    behavioral_feature->unref();
	}
    }
    
    void
    Handler::uml__comment__annotated_element__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__comment__annotated_element__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<ModelElement *> annotated_element;
	    
	    transform(objects.begin(), objects.end(), back_inserter(annotated_element), Caster<Object, ModelElement>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Comment * comment = known_cast<Comment *>(parser->top().back());
	    
	    comment->set_annotated_element(annotated_element);
	    
	}
    }
    
    void
    Handler::uml__comment__body__start(XML::SAXParser * parser, const XML::Properties & properties) {
    }
    
    void
    Handler::uml__comment__body__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__dependency__supplier__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__dependency__supplier__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<ModelElement *> supplier;
	    
	    transform(objects.begin(), objects.end(), back_inserter(supplier), Caster<Object, ModelElement>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Dependency * dependency = known_cast<Dependency *>(parser->top().back());
	    
	    dependency->set_supplier(supplier);
	    
	}
    }
    
    void
    Handler::uml__dependency__client__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__dependency__client__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<ModelElement *> client;
	    
	    transform(objects.begin(), objects.end(), back_inserter(client), Caster<Object, ModelElement>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Dependency * dependency = known_cast<Dependency *>(parser->top().back());
	    
	    dependency->set_client(client);
	    
	}
    }
    
    void
    Handler::uml__generalization__child__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__generalization__child__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    GeneralizableElement * child = known_cast<GeneralizableElement *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Generalization * generalization = known_cast<Generalization *>(parser->top().back());
	    
	    generalization->set_child(child);
	    
	    child->unref();
	}
    }
    
    void
    Handler::uml__generalization__parent__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__generalization__parent__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    GeneralizableElement * parent = known_cast<GeneralizableElement *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Generalization * generalization = known_cast<Generalization *>(parser->top().back());
	    
	    generalization->set_parent(parent);
	    
	    parent->unref();
	}
    }
    
    void
    Handler::uml__generalization__discriminator__start(XML::SAXParser * parser, const XML::Properties & properties) {
    }
    
    void
    Handler::uml__generalization__discriminator__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__association__connection__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__association__connection__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<AssociationEnd *> connection;
	    
	    transform(objects.begin(), objects.end(), back_inserter(connection), Caster<Object, AssociationEnd>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Association * association = known_cast<Association *>(parser->top().back());
	    
	    association->set_connection(connection);
	    
	}
    }
    
    void
    Handler::uml__association_end__connector__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__association_end__connector__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    Association * connector = known_cast<Association *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    AssociationEnd * association_end = known_cast<AssociationEnd *>(parser->top().back());
	    
	    association_end->set_connector(connector);
	    
	    connector->unref();
	}
    }
    
    void
    Handler::uml__association_end__type__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__association_end__type__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    Classifier * type = known_cast<Classifier *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    AssociationEnd * association_end = known_cast<AssociationEnd *>(parser->top().back());
	    
	    association_end->set_type(type);
	    
	    type->unref();
	}
    }
    
    void
    Handler::uml__association_end__qualifier__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__association_end__qualifier__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Attribute *> qualifier;
	    
	    transform(objects.begin(), objects.end(), back_inserter(qualifier), Caster<Object, Attribute>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    AssociationEnd * association_end = known_cast<AssociationEnd *>(parser->top().back());
	    
	    association_end->set_qualifier(qualifier);
	    
	}
    }
    
    void
    Handler::uml__stereotype__extended_element__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__stereotype__extended_element__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<ModelElement *> extended_element;
	    
	    transform(objects.begin(), objects.end(), back_inserter(extended_element), Caster<Object, ModelElement>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Stereotype * stereotype = known_cast<Stereotype *>(parser->top().back());
	    
	    stereotype->set_extended_element(extended_element);
	    
	}
    }
    
    void
    Handler::uml__stereotype__stereotype_constraint__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__stereotype__stereotype_constraint__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<Constraint *> stereotype_constraint;
	    
	    transform(objects.begin(), objects.end(), back_inserter(stereotype_constraint), Caster<Object, Constraint>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Stereotype * stereotype = known_cast<Stereotype *>(parser->top().back());
	    
	    stereotype->set_stereotype_constraint(stereotype_constraint);
	    
	}
    }
    
    void
    Handler::uml__stereotype__defined_tag__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__stereotype__defined_tag__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<TagDefinition *> defined_tag;
	    
	    transform(objects.begin(), objects.end(), back_inserter(defined_tag), Caster<Object, TagDefinition>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Stereotype * stereotype = known_cast<Stereotype *>(parser->top().back());
	    
	    stereotype->set_defined_tag(defined_tag);
	    
	}
    }
    
    void
    Handler::uml__tagged_value__owner__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__tagged_value__owner__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    ModelElement * owner = known_cast<ModelElement *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    TaggedValue * tagged_value = known_cast<TaggedValue *>(parser->top().back());
	    
	    tagged_value->set_owner(owner);
	    
	    owner->unref();
	}
    }
    
    void
    Handler::uml__tagged_value__reference_value__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__tagged_value__reference_value__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<ModelElement *> reference_value;
	    
	    transform(objects.begin(), objects.end(), back_inserter(reference_value), Caster<Object, ModelElement>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    TaggedValue * tagged_value = known_cast<TaggedValue *>(parser->top().back());
	    
	    tagged_value->set_reference_value(reference_value);
	    
	}
    }
    
    void
    Handler::uml__tagged_value__type__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__tagged_value__type__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    TagDefinition * type = known_cast<TagDefinition *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    TaggedValue * tagged_value = known_cast<TaggedValue *>(parser->top().back());
	    
	    tagged_value->set_type(type);
	    
	    type->unref();
	}
    }
    
    void
    Handler::uml__tagged_value__data_value__start(XML::SAXParser * parser, const XML::Properties & properties) {
    }
    
    void
    Handler::uml__tagged_value__data_value__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__tag_definition__owner__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__tag_definition__owner__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    Stereotype * owner = known_cast<Stereotype *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    TagDefinition * tag_definition = known_cast<TagDefinition *>(parser->top().back());
	    
	    tag_definition->set_owner(owner);
	    
	    owner->unref();
	}
    }
    
    void
    Handler::uml__tag_definition__typed_value__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__tag_definition__typed_value__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<TaggedValue *> typed_value;
	    
	    transform(objects.begin(), objects.end(), back_inserter(typed_value), Caster<Object, TaggedValue>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    TagDefinition * tag_definition = known_cast<TagDefinition *>(parser->top().back());
	    
	    tag_definition->set_typed_value(typed_value);
	    
	}
    }
    
    void
    Handler::uml__tag_definition__tag_type__start(XML::SAXParser * parser, const XML::Properties & properties) {
    }
    
    void
    Handler::uml__tag_definition__tag_type__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__diagram__element__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__diagram__element__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<GraphElement *> element;
	    
	    transform(objects.begin(), objects.end(), back_inserter(element), Caster<Object, GraphElement>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    Diagram * diagram = known_cast<Diagram *>(parser->top().back());
	    
	    diagram->set_element(element);
	    
	}
    }
    
    void
    Handler::uml__diagram__name__start(XML::SAXParser * parser, const XML::Properties & properties) {
    }
    
    void
    Handler::uml__diagram__name__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__graph_element__diagram__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__graph_element__diagram__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    Diagram * diagram = known_cast<Diagram *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    GraphElement * graph_element = known_cast<GraphElement *>(parser->top().back());
	    
	    graph_element->set_diagram(diagram);
	    
	    diagram->unref();
	}
    }
    
    void
    Handler::uml__graph_element__geometry__start(XML::SAXParser * parser, const XML::Properties & properties) {
    }
    
    void
    Handler::uml__graph_element__geometry__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	}
    }
    
    void
    Handler::uml__presentation_element__subject__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__presentation_element__subject__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    ModelElement * subject = known_cast<ModelElement *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    PresentationElement * presentation_element = known_cast<PresentationElement *>(parser->top().back());
	    
	    presentation_element->set_subject(subject);
	    
	    subject->unref();
	}
    }
    
    void
    Handler::uml__presentation_element__supplier_dependency__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__presentation_element__supplier_dependency__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<DependencyPresentation *> supplier_dependency;
	    
	    transform(objects.begin(), objects.end(), back_inserter(supplier_dependency), Caster<Object, DependencyPresentation>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    PresentationElement * presentation_element = known_cast<PresentationElement *>(parser->top().back());
	    
	    presentation_element->set_supplier_dependency(supplier_dependency);
	    
	}
    }
    
    void
    Handler::uml__presentation_element__client_dependency__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__presentation_element__client_dependency__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<DependencyPresentation *> client_dependency;
	    
	    transform(objects.begin(), objects.end(), back_inserter(client_dependency), Caster<Object, DependencyPresentation>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    PresentationElement * presentation_element = known_cast<PresentationElement *>(parser->top().back());
	    
	    presentation_element->set_client_dependency(client_dependency);
	    
	}
    }
    
    void
    Handler::uml__class_presentation__association_source__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__class_presentation__association_source__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<AssociationPresentation *> association_source;
	    
	    transform(objects.begin(), objects.end(), back_inserter(association_source), Caster<Object, AssociationPresentation>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    ClassPresentation * class_presentation = known_cast<ClassPresentation *>(parser->top().back());
	    
	    class_presentation->set_association_source(association_source);
	    
	}
    }
    
    void
    Handler::uml__class_presentation__association_destination__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__class_presentation__association_destination__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<AssociationPresentation *> association_destination;
	    
	    transform(objects.begin(), objects.end(), back_inserter(association_destination), Caster<Object, AssociationPresentation>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    ClassPresentation * class_presentation = known_cast<ClassPresentation *>(parser->top().back());
	    
	    class_presentation->set_association_destination(association_destination);
	    
	}
    }
    
    void
    Handler::uml__class_presentation__generalization__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__class_presentation__generalization__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<GeneralizationPresentation *> generalization;
	    
	    transform(objects.begin(), objects.end(), back_inserter(generalization), Caster<Object, GeneralizationPresentation>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    ClassPresentation * class_presentation = known_cast<ClassPresentation *>(parser->top().back());
	    
	    class_presentation->set_generalization(generalization);
	    
	}
    }
    
    void
    Handler::uml__class_presentation__specialization__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__class_presentation__specialization__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    const vector<Object *> & objects = parser->top();
	    list<GeneralizationPresentation *> specialization;
	    
	    transform(objects.begin(), objects.end(), back_inserter(specialization), Caster<Object, GeneralizationPresentation>());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    ClassPresentation * class_presentation = known_cast<ClassPresentation *>(parser->top().back());
	    
	    class_presentation->set_specialization(specialization);
	    
	}
    }
    
    void
    Handler::uml__association_presentation__source__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__association_presentation__source__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    ClassPresentation * source = known_cast<ClassPresentation *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    AssociationPresentation * association_presentation = known_cast<AssociationPresentation *>(parser->top().back());
	    
	    association_presentation->set_source(source);
	    
	    source->unref();
	}
    }
    
    void
    Handler::uml__association_presentation__destination__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__association_presentation__destination__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    ClassPresentation * destination = known_cast<ClassPresentation *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    AssociationPresentation * association_presentation = known_cast<AssociationPresentation *>(parser->top().back());
	    
	    association_presentation->set_destination(destination);
	    
	    destination->unref();
	}
    }
    
    void
    Handler::uml__generalization_presentation__subtype__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__generalization_presentation__subtype__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    ClassPresentation * subtype = known_cast<ClassPresentation *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    GeneralizationPresentation * generalization_presentation = known_cast<GeneralizationPresentation *>(parser->top().back());
	    
	    generalization_presentation->set_subtype(subtype);
	    
	    subtype->unref();
	}
    }
    
    void
    Handler::uml__generalization_presentation__supertype__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__generalization_presentation__supertype__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    ClassPresentation * supertype = known_cast<ClassPresentation *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    GeneralizationPresentation * generalization_presentation = known_cast<GeneralizationPresentation *>(parser->top().back());
	    
	    generalization_presentation->set_supertype(supertype);
	    
	    supertype->unref();
	}
    }
    
    void
    Handler::uml__dependency_presentation__supplier__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__dependency_presentation__supplier__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    PresentationElement * supplier = known_cast<PresentationElement *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    DependencyPresentation * dependency_presentation = known_cast<DependencyPresentation *>(parser->top().back());
	    
	    dependency_presentation->set_supplier(supplier);
	    
	    supplier->unref();
	}
    }
    
    void
    Handler::uml__dependency_presentation__client__start(XML::SAXParser * parser, const XML::Properties & properties) {
	if(parser->get_pass() == 1) {
	}
	else {
	    parser->push();
	}
    }
    
    void
    Handler::uml__dependency_presentation__client__end(XML::SAXParser * parser) {
	if(parser->get_pass() == 1) {
	}
	else {
	    ASSERT(parser->top().size() == 1);
	    
	    PresentationElement * client = known_cast<PresentationElement *>(parser->top().back());
	    
	    parser->pop();
	    
	    ASSERT(!parser->top().empty());
	    
	    DependencyPresentation * dependency_presentation = known_cast<DependencyPresentation *>(parser->top().back());
	    
	    dependency_presentation->set_client(client);
	    
	    client->unref();
	}
    }
    
} // namespace UML
