// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UML_HANDLER_H
#define UML_HANDLER_H

#include "xml/sax_handler.h"

#include "reflective/class.h"

namespace UML {
    
    class Handler : public XML::SAXHandler {
    public:
	Handler();
	~Handler();
	
	// the sax interface
	
	void warning(XML::SAXParser * parser, const string & msg);
	void error(XML::SAXParser * parser, const string & msg);
	void fatal(XML::SAXParser * parser, const string & msg);
	
	void comment(XML::SAXParser * parser, const string & comment);
	void start_document(XML::SAXParser * parser);
	void end_document(XML::SAXParser * parser);
	void start_element(XML::SAXParser * parser, const string & name, const XML::Properties & properties);
	void end_element(XML::SAXParser * parser, const string & name);
	void characters(XML::SAXParser * parser, const string & data);
	void reference(XML::SAXParser * parser, const string & name);
	void cdata_block(XML::SAXParser * parser, const string & data);
	
    private:
	void uml__constraint__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__constraint__end(XML::SAXParser * parser);
	
	void uml__attribute__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__attribute__end(XML::SAXParser * parser);
	
	void uml__operation__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__operation__end(XML::SAXParser * parser);
	
	void uml__method__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__method__end(XML::SAXParser * parser);
	
	void uml__parameter__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__parameter__end(XML::SAXParser * parser);
	
	void uml__interface__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__interface__end(XML::SAXParser * parser);
	
	void uml__data_type__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__data_type__end(XML::SAXParser * parser);
	
	void uml__node__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__node__end(XML::SAXParser * parser);
	
	void uml__comment__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__comment__end(XML::SAXParser * parser);
	
	void uml__dependency__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__dependency__end(XML::SAXParser * parser);
	
	void uml__binding__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__binding__end(XML::SAXParser * parser);
	
	void uml__abstraction__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__abstraction__end(XML::SAXParser * parser);
	
	void uml__usage__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__usage__end(XML::SAXParser * parser);
	
	void uml__permission__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__permission__end(XML::SAXParser * parser);
	
	void uml__generalization__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__generalization__end(XML::SAXParser * parser);
	
	void uml__class__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__class__end(XML::SAXParser * parser);
	
	void uml__association_class__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__association_class__end(XML::SAXParser * parser);
	
	void uml__association__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__association__end(XML::SAXParser * parser);
	
	void uml__association_end__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__association_end__end(XML::SAXParser * parser);
	
	void uml__stereotype__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__stereotype__end(XML::SAXParser * parser);
	
	void uml__tagged_value__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__tagged_value__end(XML::SAXParser * parser);
	
	void uml__tag_definition__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__tag_definition__end(XML::SAXParser * parser);
	
	void uml__package__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__package__end(XML::SAXParser * parser);
	
	void uml__model__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__model__end(XML::SAXParser * parser);
	
	void uml__diagram__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__diagram__end(XML::SAXParser * parser);
	
	void uml__class_presentation__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__class_presentation__end(XML::SAXParser * parser);
	
	void uml__package_presentation__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__package_presentation__end(XML::SAXParser * parser);
	
	void uml__comment_presentation__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__comment_presentation__end(XML::SAXParser * parser);
	
	void uml__association_presentation__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__association_presentation__end(XML::SAXParser * parser);
	
	void uml__generalization_presentation__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__generalization_presentation__end(XML::SAXParser * parser);
	
	void uml__dependency_presentation__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__dependency_presentation__end(XML::SAXParser * parser);
	
	void uml__generalizable_element__generalization__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__generalizable_element__generalization__end(XML::SAXParser * parser);
	
	void uml__generalizable_element__specialization__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__generalizable_element__specialization__end(XML::SAXParser * parser);
	
	void uml__generalizable_element__is_root__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__generalizable_element__is_root__end(XML::SAXParser * parser);
	
	void uml__generalizable_element__is_leaf__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__generalizable_element__is_leaf__end(XML::SAXParser * parser);
	
	void uml__generalizable_element__is_abstract__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__generalizable_element__is_abstract__end(XML::SAXParser * parser);
	
	void uml__constraint__constrained_element__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__constraint__constrained_element__end(XML::SAXParser * parser);
	
	void uml__constraint__constrained_stereotype__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__constraint__constrained_stereotype__end(XML::SAXParser * parser);
	
	void uml__classifier__feature__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__classifier__feature__end(XML::SAXParser * parser);
	
	void uml__classifier__typed_feature__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__classifier__typed_feature__end(XML::SAXParser * parser);
	
	void uml__classifier__typed_parameter__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__classifier__typed_parameter__end(XML::SAXParser * parser);
	
	void uml__classifier__association__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__classifier__association__end(XML::SAXParser * parser);
	
	void uml__structural_feature__type__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__structural_feature__type__end(XML::SAXParser * parser);
	
	void uml__behavioral_feature__parameter__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__behavioral_feature__parameter__end(XML::SAXParser * parser);
	
	void uml__behavioral_feature__is_query__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__behavioral_feature__is_query__end(XML::SAXParser * parser);
	
	void uml__attribute__association_end__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__attribute__association_end__end(XML::SAXParser * parser);
	
	void uml__operation__method__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__operation__method__end(XML::SAXParser * parser);
	
	void uml__method__specification__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__method__specification__end(XML::SAXParser * parser);
	
	void uml__model_element__constraint__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__model_element__constraint__end(XML::SAXParser * parser);
	
	void uml__model_element__namespace__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__model_element__namespace__end(XML::SAXParser * parser);
	
	void uml__model_element__supplier_dependency__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__model_element__supplier_dependency__end(XML::SAXParser * parser);
	
	void uml__model_element__client_dependency__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__model_element__client_dependency__end(XML::SAXParser * parser);
	
	void uml__model_element__stereotype__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__model_element__stereotype__end(XML::SAXParser * parser);
	
	void uml__model_element__tagged_value__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__model_element__tagged_value__end(XML::SAXParser * parser);
	
	void uml__model_element__reference_tag__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__model_element__reference_tag__end(XML::SAXParser * parser);
	
	void uml__model_element__comment__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__model_element__comment__end(XML::SAXParser * parser);
	
	void uml__model_element__presentation__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__model_element__presentation__end(XML::SAXParser * parser);
	
	void uml__model_element__name__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__model_element__name__end(XML::SAXParser * parser);
	
	void uml__model_element__is_specification__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__model_element__is_specification__end(XML::SAXParser * parser);
	
	void uml__feature__owner__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__feature__owner__end(XML::SAXParser * parser);
	
	void uml__namespace__owned_element__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__namespace__owned_element__end(XML::SAXParser * parser);
	
	void uml__parameter__behavioral_feature__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__parameter__behavioral_feature__end(XML::SAXParser * parser);
	
	void uml__parameter__type__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__parameter__type__end(XML::SAXParser * parser);
	
	void uml__comment__annotated_element__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__comment__annotated_element__end(XML::SAXParser * parser);
	
	void uml__comment__body__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__comment__body__end(XML::SAXParser * parser);
	
	void uml__dependency__supplier__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__dependency__supplier__end(XML::SAXParser * parser);
	
	void uml__dependency__client__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__dependency__client__end(XML::SAXParser * parser);
	
	void uml__generalization__child__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__generalization__child__end(XML::SAXParser * parser);
	
	void uml__generalization__parent__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__generalization__parent__end(XML::SAXParser * parser);
	
	void uml__generalization__discriminator__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__generalization__discriminator__end(XML::SAXParser * parser);
	
	void uml__association__connection__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__association__connection__end(XML::SAXParser * parser);
	
	void uml__association_end__connector__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__association_end__connector__end(XML::SAXParser * parser);
	
	void uml__association_end__type__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__association_end__type__end(XML::SAXParser * parser);
	
	void uml__association_end__qualifier__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__association_end__qualifier__end(XML::SAXParser * parser);
	
	void uml__stereotype__extended_element__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__stereotype__extended_element__end(XML::SAXParser * parser);
	
	void uml__stereotype__stereotype_constraint__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__stereotype__stereotype_constraint__end(XML::SAXParser * parser);
	
	void uml__stereotype__defined_tag__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__stereotype__defined_tag__end(XML::SAXParser * parser);
	
	void uml__tagged_value__owner__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__tagged_value__owner__end(XML::SAXParser * parser);
	
	void uml__tagged_value__reference_value__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__tagged_value__reference_value__end(XML::SAXParser * parser);
	
	void uml__tagged_value__type__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__tagged_value__type__end(XML::SAXParser * parser);
	
	void uml__tagged_value__data_value__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__tagged_value__data_value__end(XML::SAXParser * parser);
	
	void uml__tag_definition__owner__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__tag_definition__owner__end(XML::SAXParser * parser);
	
	void uml__tag_definition__typed_value__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__tag_definition__typed_value__end(XML::SAXParser * parser);
	
	void uml__tag_definition__tag_type__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__tag_definition__tag_type__end(XML::SAXParser * parser);
	
	void uml__diagram__element__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__diagram__element__end(XML::SAXParser * parser);
	
	void uml__diagram__name__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__diagram__name__end(XML::SAXParser * parser);
	
	void uml__graph_element__diagram__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__graph_element__diagram__end(XML::SAXParser * parser);
	
	void uml__graph_element__geometry__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__graph_element__geometry__end(XML::SAXParser * parser);
	
	void uml__presentation_element__subject__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__presentation_element__subject__end(XML::SAXParser * parser);
	
	void uml__presentation_element__supplier_dependency__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__presentation_element__supplier_dependency__end(XML::SAXParser * parser);
	
	void uml__presentation_element__client_dependency__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__presentation_element__client_dependency__end(XML::SAXParser * parser);
	
	void uml__class_presentation__association_source__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__class_presentation__association_source__end(XML::SAXParser * parser);
	
	void uml__class_presentation__association_destination__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__class_presentation__association_destination__end(XML::SAXParser * parser);
	
	void uml__class_presentation__generalization__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__class_presentation__generalization__end(XML::SAXParser * parser);
	
	void uml__class_presentation__specialization__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__class_presentation__specialization__end(XML::SAXParser * parser);
	
	void uml__association_presentation__source__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__association_presentation__source__end(XML::SAXParser * parser);
	
	void uml__association_presentation__destination__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__association_presentation__destination__end(XML::SAXParser * parser);
	
	void uml__generalization_presentation__subtype__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__generalization_presentation__subtype__end(XML::SAXParser * parser);
	
	void uml__generalization_presentation__supertype__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__generalization_presentation__supertype__end(XML::SAXParser * parser);
	
	void uml__dependency_presentation__supplier__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__dependency_presentation__supplier__end(XML::SAXParser * parser);
	
	void uml__dependency_presentation__client__start(XML::SAXParser * parser, const XML::Properties & properties);
	void uml__dependency_presentation__client__end(XML::SAXParser * parser);
	
	//
	//
	//
	
	string mCharacters;
	
	typedef void (Handler::*StartHandler)(XML::SAXParser *, const XML::Properties &);
	typedef void (Handler::*EndHandler)(XML::SAXParser *);
	typedef pair<StartHandler, EndHandler> HandlerPair;
	
	hash_map<string, HandlerPair> mHandlerMap;
	hash_map<string, Object *> mElementMap;
	
	set<string> mUnhandledElements;
	
	void store(const string & id, Object * object);
	Object * lookup(const string & id);
    };
    
} // namespace UML

#endif // UML_HANDLER_H
