// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "uml.h"

#include "uml/foundation/core/constraint.h"
#include "uml/foundation/core/attribute.h"
#include "uml/foundation/core/operation.h"
#include "uml/foundation/core/method.h"
#include "uml/foundation/core/parameter.h"
#include "uml/foundation/core/interface.h"
#include "uml/foundation/core/data_type.h"
#include "uml/foundation/core/node.h"
#include "uml/foundation/core/comment.h"
#include "uml/foundation/core/dependency.h"
#include "uml/foundation/core/binding.h"
#include "uml/foundation/core/abstraction.h"
#include "uml/foundation/core/usage.h"
#include "uml/foundation/core/permission.h"
#include "uml/foundation/core/generalization.h"
#include "uml/foundation/core/class.h"
#include "uml/foundation/core/association_class.h"
#include "uml/foundation/core/association.h"
#include "uml/foundation/core/association_end.h"
#include "uml/foundation/extension_mechanisms/stereotype.h"
#include "uml/foundation/extension_mechanisms/tagged_value.h"
#include "uml/foundation/extension_mechanisms/tag_definition.h"
#include "uml/model_management/package.h"
#include "uml/model_management/model.h"
#include "uml/diagram/diagram.h"
#include "uml/diagram/class_presentation.h"
#include "uml/diagram/package_presentation.h"
#include "uml/diagram/comment_presentation.h"
#include "uml/diagram/association_presentation.h"
#include "uml/diagram/generalization_presentation.h"
#include "uml/diagram/dependency_presentation.h"

#include "uml/foundation/data_types/integer.h"
#include "uml/foundation/data_types/name.h"
#include "uml/foundation/data_types/boolean.h"
#include "uml/foundation/data_types/aggregation_kind.h"
#include "uml/foundation/data_types/call_concurrency_kind.h"
#include "uml/foundation/data_types/changeable_kind.h"
#include "uml/foundation/data_types/ordering_kind.h"
#include "uml/foundation/data_types/parameter_direction_kind.h"
#include "uml/foundation/data_types/scope_kind.h"
#include "uml/foundation/data_types/visibility_kind.h"
#include "uml/foundation/data_types/diagram_kind.h"
#include "uml/foundation/data_types/multiplicity_type.h"

#include "reflective/exceptions.h"

#include "foundation/macros.h"

namespace UML {
    
    UML::UML() : Context() {
    }
    
    
    UML::~UML() {
    }
    
    REF::Class *
    UML::ref_create_class(const string & class_name) {
	if(class_name == "constraint") {
	    return new Constraint();
	}
	
	if(class_name == "attribute") {
	    return new Attribute();
	}
	
	if(class_name == "operation") {
	    return new Operation();
	}
	
	if(class_name == "method") {
	    return new Method();
	}
	
	if(class_name == "parameter") {
	    return new Parameter();
	}
	
	if(class_name == "interface") {
	    return new Interface();
	}
	
	if(class_name == "data_type") {
	    return new DataType();
	}
	
	if(class_name == "node") {
	    return new Node();
	}
	
	if(class_name == "comment") {
	    return new Comment();
	}
	
	if(class_name == "dependency") {
	    return new Dependency();
	}
	
	if(class_name == "binding") {
	    return new Binding();
	}
	
	if(class_name == "abstraction") {
	    return new Abstraction();
	}
	
	if(class_name == "usage") {
	    return new Usage();
	}
	
	if(class_name == "permission") {
	    return new Permission();
	}
	
	if(class_name == "generalization") {
	    return new Generalization();
	}
	
	if(class_name == "class") {
	    return new Class();
	}
	
	if(class_name == "association_class") {
	    return new AssociationClass();
	}
	
	if(class_name == "association") {
	    return new Association();
	}
	
	if(class_name == "association_end") {
	    return new AssociationEnd();
	}
	
	if(class_name == "stereotype") {
	    return new Stereotype();
	}
	
	if(class_name == "tagged_value") {
	    return new TaggedValue();
	}
	
	if(class_name == "tag_definition") {
	    return new TagDefinition();
	}
	
	if(class_name == "package") {
	    return new Package();
	}
	
	if(class_name == "model") {
	    return new Model();
	}
	
	if(class_name == "diagram") {
	    return new Diagram();
	}
	
	if(class_name == "class_presentation") {
	    return new ClassPresentation();
	}
	
	if(class_name == "package_presentation") {
	    return new PackagePresentation();
	}
	
	if(class_name == "comment_presentation") {
	    return new CommentPresentation();
	}
	
	if(class_name == "association_presentation") {
	    return new AssociationPresentation();
	}
	
	if(class_name == "generalization_presentation") {
	    return new GeneralizationPresentation();
	}
	
	if(class_name == "dependency_presentation") {
	    return new DependencyPresentation();
	}
	
	ERROR("No such class: " + class_name);
	throw REF::BadType(class_name);
    }
    
    REF::Attribute *
    UML::ref_create_attribute(const string & attribute_name) {
	if(attribute_name == "integer") {
	    return new Integer();
	}
	
	if(attribute_name == "name") {
	    return new Name();
	}
	
	if(attribute_name == "boolean") {
	    return new Boolean();
	}
	
	if(attribute_name == "aggregation_kind") {
	    return new AggregationKind();
	}
	
	if(attribute_name == "call_concurrency_kind") {
	    return new CallConcurrencyKind();
	}
	
	if(attribute_name == "changeable_kind") {
	    return new ChangeableKind();
	}
	
	if(attribute_name == "ordering_kind") {
	    return new OrderingKind();
	}
	
	if(attribute_name == "parameter_direction_kind") {
	    return new ParameterDirectionKind();
	}
	
	if(attribute_name == "scope_kind") {
	    return new ScopeKind();
	}
	
	if(attribute_name == "visibility_kind") {
	    return new VisibilityKind();
	}
	
	if(attribute_name == "diagram_kind") {
	    return new DiagramKind();
	}
	
	if(attribute_name == "multiplicity_type") {
	    return new MultiplicityType();
	}
	
	ERROR("No such attribute: " + attribute_name);
	throw REF::BadType(attribute_name);
    }
    
    void
    UML::internal_add_generalizable_element(GeneralizableElement * element) {
	mAllOfTypeGeneralizableElement.insert(element);
    }
    
    void
    UML::internal_remove_generalizable_element(GeneralizableElement * element) {
	mAllOfTypeGeneralizableElement.erase(element);
    }
    
    void
    UML::internal_add_constraint(Constraint * element) {
	mAllOfTypeConstraint.insert(element);
    }
    
    void
    UML::internal_remove_constraint(Constraint * element) {
	mAllOfTypeConstraint.erase(element);
    }
    
    void
    UML::internal_add_classifier(Classifier * element) {
	mAllOfTypeClassifier.insert(element);
    }
    
    void
    UML::internal_remove_classifier(Classifier * element) {
	mAllOfTypeClassifier.erase(element);
    }
    
    void
    UML::internal_add_structural_feature(StructuralFeature * element) {
	mAllOfTypeStructuralFeature.insert(element);
    }
    
    void
    UML::internal_remove_structural_feature(StructuralFeature * element) {
	mAllOfTypeStructuralFeature.erase(element);
    }
    
    void
    UML::internal_add_behavioral_feature(BehavioralFeature * element) {
	mAllOfTypeBehavioralFeature.insert(element);
    }
    
    void
    UML::internal_remove_behavioral_feature(BehavioralFeature * element) {
	mAllOfTypeBehavioralFeature.erase(element);
    }
    
    void
    UML::internal_add_element(Element * element) {
	mAllOfTypeElement.insert(element);
    }
    
    void
    UML::internal_remove_element(Element * element) {
	mAllOfTypeElement.erase(element);
    }
    
    void
    UML::internal_add_attribute(Attribute * element) {
	mAllOfTypeAttribute.insert(element);
    }
    
    void
    UML::internal_remove_attribute(Attribute * element) {
	mAllOfTypeAttribute.erase(element);
    }
    
    void
    UML::internal_add_operation(Operation * element) {
	mAllOfTypeOperation.insert(element);
    }
    
    void
    UML::internal_remove_operation(Operation * element) {
	mAllOfTypeOperation.erase(element);
    }
    
    void
    UML::internal_add_method(Method * element) {
	mAllOfTypeMethod.insert(element);
    }
    
    void
    UML::internal_remove_method(Method * element) {
	mAllOfTypeMethod.erase(element);
    }
    
    void
    UML::internal_add_model_element(ModelElement * element) {
	mAllOfTypeModelElement.insert(element);
    }
    
    void
    UML::internal_remove_model_element(ModelElement * element) {
	mAllOfTypeModelElement.erase(element);
    }
    
    void
    UML::internal_add_feature(Feature * element) {
	mAllOfTypeFeature.insert(element);
    }
    
    void
    UML::internal_remove_feature(Feature * element) {
	mAllOfTypeFeature.erase(element);
    }
    
    void
    UML::internal_add_namespace(Namespace * element) {
	mAllOfTypeNamespace.insert(element);
    }
    
    void
    UML::internal_remove_namespace(Namespace * element) {
	mAllOfTypeNamespace.erase(element);
    }
    
    void
    UML::internal_add_parameter(Parameter * element) {
	mAllOfTypeParameter.insert(element);
    }
    
    void
    UML::internal_remove_parameter(Parameter * element) {
	mAllOfTypeParameter.erase(element);
    }
    
    void
    UML::internal_add_interface(Interface * element) {
	mAllOfTypeInterface.insert(element);
    }
    
    void
    UML::internal_remove_interface(Interface * element) {
	mAllOfTypeInterface.erase(element);
    }
    
    void
    UML::internal_add_data_type(DataType * element) {
	mAllOfTypeDataType.insert(element);
    }
    
    void
    UML::internal_remove_data_type(DataType * element) {
	mAllOfTypeDataType.erase(element);
    }
    
    void
    UML::internal_add_node(Node * element) {
	mAllOfTypeNode.insert(element);
    }
    
    void
    UML::internal_remove_node(Node * element) {
	mAllOfTypeNode.erase(element);
    }
    
    void
    UML::internal_add_comment(Comment * element) {
	mAllOfTypeComment.insert(element);
    }
    
    void
    UML::internal_remove_comment(Comment * element) {
	mAllOfTypeComment.erase(element);
    }
    
    void
    UML::internal_add_relationship(Relationship * element) {
	mAllOfTypeRelationship.insert(element);
    }
    
    void
    UML::internal_remove_relationship(Relationship * element) {
	mAllOfTypeRelationship.erase(element);
    }
    
    void
    UML::internal_add_dependency(Dependency * element) {
	mAllOfTypeDependency.insert(element);
    }
    
    void
    UML::internal_remove_dependency(Dependency * element) {
	mAllOfTypeDependency.erase(element);
    }
    
    void
    UML::internal_add_binding(Binding * element) {
	mAllOfTypeBinding.insert(element);
    }
    
    void
    UML::internal_remove_binding(Binding * element) {
	mAllOfTypeBinding.erase(element);
    }
    
    void
    UML::internal_add_abstraction(Abstraction * element) {
	mAllOfTypeAbstraction.insert(element);
    }
    
    void
    UML::internal_remove_abstraction(Abstraction * element) {
	mAllOfTypeAbstraction.erase(element);
    }
    
    void
    UML::internal_add_usage(Usage * element) {
	mAllOfTypeUsage.insert(element);
    }
    
    void
    UML::internal_remove_usage(Usage * element) {
	mAllOfTypeUsage.erase(element);
    }
    
    void
    UML::internal_add_permission(Permission * element) {
	mAllOfTypePermission.insert(element);
    }
    
    void
    UML::internal_remove_permission(Permission * element) {
	mAllOfTypePermission.erase(element);
    }
    
    void
    UML::internal_add_generalization(Generalization * element) {
	mAllOfTypeGeneralization.insert(element);
    }
    
    void
    UML::internal_remove_generalization(Generalization * element) {
	mAllOfTypeGeneralization.erase(element);
    }
    
    void
    UML::internal_add_class(Class * element) {
	mAllOfTypeClass.insert(element);
    }
    
    void
    UML::internal_remove_class(Class * element) {
	mAllOfTypeClass.erase(element);
    }
    
    void
    UML::internal_add_association_class(AssociationClass * element) {
	mAllOfTypeAssociationClass.insert(element);
    }
    
    void
    UML::internal_remove_association_class(AssociationClass * element) {
	mAllOfTypeAssociationClass.erase(element);
    }
    
    void
    UML::internal_add_association(Association * element) {
	mAllOfTypeAssociation.insert(element);
    }
    
    void
    UML::internal_remove_association(Association * element) {
	mAllOfTypeAssociation.erase(element);
    }
    
    void
    UML::internal_add_association_end(AssociationEnd * element) {
	mAllOfTypeAssociationEnd.insert(element);
    }
    
    void
    UML::internal_remove_association_end(AssociationEnd * element) {
	mAllOfTypeAssociationEnd.erase(element);
    }
    
    void
    UML::internal_add_stereotype(Stereotype * element) {
	mAllOfTypeStereotype.insert(element);
    }
    
    void
    UML::internal_remove_stereotype(Stereotype * element) {
	mAllOfTypeStereotype.erase(element);
    }
    
    void
    UML::internal_add_tagged_value(TaggedValue * element) {
	mAllOfTypeTaggedValue.insert(element);
    }
    
    void
    UML::internal_remove_tagged_value(TaggedValue * element) {
	mAllOfTypeTaggedValue.erase(element);
    }
    
    void
    UML::internal_add_tag_definition(TagDefinition * element) {
	mAllOfTypeTagDefinition.insert(element);
    }
    
    void
    UML::internal_remove_tag_definition(TagDefinition * element) {
	mAllOfTypeTagDefinition.erase(element);
    }
    
    void
    UML::internal_add_package(Package * element) {
	mAllOfTypePackage.insert(element);
    }
    
    void
    UML::internal_remove_package(Package * element) {
	mAllOfTypePackage.erase(element);
    }
    
    void
    UML::internal_add_model(Model * element) {
	mAllOfTypeModel.insert(element);
    }
    
    void
    UML::internal_remove_model(Model * element) {
	mAllOfTypeModel.erase(element);
    }
    
    void
    UML::internal_add_diagram(Diagram * element) {
	mAllOfTypeDiagram.insert(element);
    }
    
    void
    UML::internal_remove_diagram(Diagram * element) {
	mAllOfTypeDiagram.erase(element);
    }
    
    void
    UML::internal_add_graph_element(GraphElement * element) {
	mAllOfTypeGraphElement.insert(element);
    }
    
    void
    UML::internal_remove_graph_element(GraphElement * element) {
	mAllOfTypeGraphElement.erase(element);
    }
    
    void
    UML::internal_add_presentation_element(PresentationElement * element) {
	mAllOfTypePresentationElement.insert(element);
    }
    
    void
    UML::internal_remove_presentation_element(PresentationElement * element) {
	mAllOfTypePresentationElement.erase(element);
    }
    
    void
    UML::internal_add_edge_element(EdgeElement * element) {
	mAllOfTypeEdgeElement.insert(element);
    }
    
    void
    UML::internal_remove_edge_element(EdgeElement * element) {
	mAllOfTypeEdgeElement.erase(element);
    }
    
    void
    UML::internal_add_node_element(NodeElement * element) {
	mAllOfTypeNodeElement.insert(element);
    }
    
    void
    UML::internal_remove_node_element(NodeElement * element) {
	mAllOfTypeNodeElement.erase(element);
    }
    
    void
    UML::internal_add_class_presentation(ClassPresentation * element) {
	mAllOfTypeClassPresentation.insert(element);
    }
    
    void
    UML::internal_remove_class_presentation(ClassPresentation * element) {
	mAllOfTypeClassPresentation.erase(element);
    }
    
    void
    UML::internal_add_package_presentation(PackagePresentation * element) {
	mAllOfTypePackagePresentation.insert(element);
    }
    
    void
    UML::internal_remove_package_presentation(PackagePresentation * element) {
	mAllOfTypePackagePresentation.erase(element);
    }
    
    void
    UML::internal_add_comment_presentation(CommentPresentation * element) {
	mAllOfTypeCommentPresentation.insert(element);
    }
    
    void
    UML::internal_remove_comment_presentation(CommentPresentation * element) {
	mAllOfTypeCommentPresentation.erase(element);
    }
    
    void
    UML::internal_add_association_presentation(AssociationPresentation * element) {
	mAllOfTypeAssociationPresentation.insert(element);
    }
    
    void
    UML::internal_remove_association_presentation(AssociationPresentation * element) {
	mAllOfTypeAssociationPresentation.erase(element);
    }
    
    void
    UML::internal_add_generalization_presentation(GeneralizationPresentation * element) {
	mAllOfTypeGeneralizationPresentation.insert(element);
    }
    
    void
    UML::internal_remove_generalization_presentation(GeneralizationPresentation * element) {
	mAllOfTypeGeneralizationPresentation.erase(element);
    }
    
    void
    UML::internal_add_dependency_presentation(DependencyPresentation * element) {
	mAllOfTypeDependencyPresentation.insert(element);
    }
    
    void
    UML::internal_remove_dependency_presentation(DependencyPresentation * element) {
	mAllOfTypeDependencyPresentation.erase(element);
    }
    
} // namespace UML
