// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "writer.h"

#include "xml/stream.h"

#include "foundation/macros.h"
#include "foundation/utility.h"

#include "uml/foundation/core/generalizable_element.h"
#include "uml/foundation/core/constraint.h"
#include "uml/foundation/core/classifier.h"
#include "uml/foundation/core/structural_feature.h"
#include "uml/foundation/core/behavioral_feature.h"
#include "uml/foundation/core/element.h"
#include "uml/foundation/core/attribute.h"
#include "uml/foundation/core/operation.h"
#include "uml/foundation/core/method.h"
#include "uml/foundation/core/model_element.h"
#include "uml/foundation/core/feature.h"
#include "uml/foundation/core/namespace.h"
#include "uml/foundation/core/parameter.h"
#include "uml/foundation/core/interface.h"
#include "uml/foundation/core/data_type.h"
#include "uml/foundation/core/node.h"
#include "uml/foundation/core/comment.h"
#include "uml/foundation/core/relationship.h"
#include "uml/foundation/core/dependency.h"
#include "uml/foundation/core/binding.h"
#include "uml/foundation/core/abstraction.h"
#include "uml/foundation/core/usage.h"
#include "uml/foundation/core/permission.h"
#include "uml/foundation/core/generalization.h"
#include "uml/foundation/core/class.h"
#include "uml/foundation/core/association_class.h"
#include "uml/foundation/core/association.h"
#include "uml/foundation/core/association_end.h"
#include "uml/foundation/extension_mechanisms/stereotype.h"
#include "uml/foundation/extension_mechanisms/tagged_value.h"
#include "uml/foundation/extension_mechanisms/tag_definition.h"
#include "uml/model_management/package.h"
#include "uml/model_management/model.h"
#include "uml/diagram/diagram.h"
#include "uml/diagram/graph_element.h"
#include "uml/diagram/presentation_element.h"
#include "uml/diagram/edge_element.h"
#include "uml/diagram/node_element.h"
#include "uml/diagram/class_presentation.h"
#include "uml/diagram/package_presentation.h"
#include "uml/diagram/comment_presentation.h"
#include "uml/diagram/association_presentation.h"
#include "uml/diagram/generalization_presentation.h"
#include "uml/diagram/dependency_presentation.h"

#include "uml/foundation/data_types/integer.h"
#include "uml/foundation/data_types/name.h"
#include "uml/foundation/data_types/boolean.h"
#include "uml/foundation/data_types/aggregation_kind.h"
#include "uml/foundation/data_types/call_concurrency_kind.h"
#include "uml/foundation/data_types/changeable_kind.h"
#include "uml/foundation/data_types/ordering_kind.h"
#include "uml/foundation/data_types/parameter_direction_kind.h"
#include "uml/foundation/data_types/scope_kind.h"
#include "uml/foundation/data_types/visibility_kind.h"
#include "uml/foundation/data_types/diagram_kind.h"
#include "uml/foundation/data_types/multiplicity_type.h"

#include <iostream>
using namespace std;

namespace UML {
    
    Writer::Writer(REF::Class * root) : Object(), mRoot(root), mStream(0) {
	ASSERT(mRoot);
	mRoot->ref();
	mClassHandlerMap[&typeid(Constraint)] = &Writer::write_constraint;
	mClassHandlerMap[&typeid(Attribute)] = &Writer::write_attribute;
	mClassHandlerMap[&typeid(Operation)] = &Writer::write_operation;
	mClassHandlerMap[&typeid(Method)] = &Writer::write_method;
	mClassHandlerMap[&typeid(Parameter)] = &Writer::write_parameter;
	mClassHandlerMap[&typeid(Interface)] = &Writer::write_interface;
	mClassHandlerMap[&typeid(DataType)] = &Writer::write_data_type;
	mClassHandlerMap[&typeid(Node)] = &Writer::write_node;
	mClassHandlerMap[&typeid(Comment)] = &Writer::write_comment;
	mClassHandlerMap[&typeid(Dependency)] = &Writer::write_dependency;
	mClassHandlerMap[&typeid(Binding)] = &Writer::write_binding;
	mClassHandlerMap[&typeid(Abstraction)] = &Writer::write_abstraction;
	mClassHandlerMap[&typeid(Usage)] = &Writer::write_usage;
	mClassHandlerMap[&typeid(Permission)] = &Writer::write_permission;
	mClassHandlerMap[&typeid(Generalization)] = &Writer::write_generalization;
	mClassHandlerMap[&typeid(Class)] = &Writer::write_class;
	mClassHandlerMap[&typeid(AssociationClass)] = &Writer::write_association_class;
	mClassHandlerMap[&typeid(Association)] = &Writer::write_association;
	mClassHandlerMap[&typeid(AssociationEnd)] = &Writer::write_association_end;
	mClassHandlerMap[&typeid(Stereotype)] = &Writer::write_stereotype;
	mClassHandlerMap[&typeid(TaggedValue)] = &Writer::write_tagged_value;
	mClassHandlerMap[&typeid(TagDefinition)] = &Writer::write_tag_definition;
	mClassHandlerMap[&typeid(Package)] = &Writer::write_package;
	mClassHandlerMap[&typeid(Model)] = &Writer::write_model;
	mClassHandlerMap[&typeid(Diagram)] = &Writer::write_diagram;
	mClassHandlerMap[&typeid(ClassPresentation)] = &Writer::write_class_presentation;
	mClassHandlerMap[&typeid(PackagePresentation)] = &Writer::write_package_presentation;
	mClassHandlerMap[&typeid(CommentPresentation)] = &Writer::write_comment_presentation;
	mClassHandlerMap[&typeid(AssociationPresentation)] = &Writer::write_association_presentation;
	mClassHandlerMap[&typeid(GeneralizationPresentation)] = &Writer::write_generalization_presentation;
	mClassHandlerMap[&typeid(DependencyPresentation)] = &Writer::write_dependency_presentation;
	mDataTypeHandlerMap[&typeid(Integer)] = &Writer::write_integer;
	mDataTypeHandlerMap[&typeid(Name)] = &Writer::write_name;
	mDataTypeHandlerMap[&typeid(Boolean)] = &Writer::write_boolean;
	mDataTypeHandlerMap[&typeid(AggregationKind)] = &Writer::write_aggregation_kind;
	mDataTypeHandlerMap[&typeid(CallConcurrencyKind)] = &Writer::write_call_concurrency_kind;
	mDataTypeHandlerMap[&typeid(ChangeableKind)] = &Writer::write_changeable_kind;
	mDataTypeHandlerMap[&typeid(OrderingKind)] = &Writer::write_ordering_kind;
	mDataTypeHandlerMap[&typeid(ParameterDirectionKind)] = &Writer::write_parameter_direction_kind;
	mDataTypeHandlerMap[&typeid(ScopeKind)] = &Writer::write_scope_kind;
	mDataTypeHandlerMap[&typeid(VisibilityKind)] = &Writer::write_visibility_kind;
	mDataTypeHandlerMap[&typeid(DiagramKind)] = &Writer::write_diagram_kind;
	mDataTypeHandlerMap[&typeid(MultiplicityType)] = &Writer::write_multiplicity_type;
    }
    
    Writer::~Writer() {
	mRoot->unref();
    }
    
    void
    Writer::write(ostream & ost) {
	mStream = new XML::Stream(ost, "XMI", XML::DTDK_SYSTEM, "xmi.dtd");
	invoke_class_handler(mRoot, false);
	delete mStream;
    }
    
    void
    Writer::invoke_class_handler(REF::Class * object, bool reference) {
	map<TypeInfo, ClassHandler, Compare>::iterator iter = mClassHandlerMap.find(&typeid(*object));
	
	if(iter == mClassHandlerMap.end()) {
	    ERROR("No handler for class");
	}
	else {
	    ClassHandler handler = iter->second;
	    (this->*handler)(object, reference);
	}
    }
    
    void
    Writer::invoke_data_type_handler(const REF::Attribute * object) {
	map<TypeInfo, DataTypeHandler, Compare>::iterator iter = mDataTypeHandlerMap.find(&typeid(*object));
	
	if(iter == mDataTypeHandlerMap.end()) {
	    ERROR("No handler for attribute");
	}
	else {
	    DataTypeHandler handler = iter->second;
	    (this->*handler)(object);
	}
    }
    
    void
    Writer::write_constraint(REF::Class * object, bool reference) {
	write_constraint(known_cast<Constraint *>(object), reference);
    }
    
    void
    Writer::write_attribute(REF::Class * object, bool reference) {
	write_attribute(known_cast<Attribute *>(object), reference);
    }
    
    void
    Writer::write_operation(REF::Class * object, bool reference) {
	write_operation(known_cast<Operation *>(object), reference);
    }
    
    void
    Writer::write_method(REF::Class * object, bool reference) {
	write_method(known_cast<Method *>(object), reference);
    }
    
    void
    Writer::write_parameter(REF::Class * object, bool reference) {
	write_parameter(known_cast<Parameter *>(object), reference);
    }
    
    void
    Writer::write_interface(REF::Class * object, bool reference) {
	write_interface(known_cast<Interface *>(object), reference);
    }
    
    void
    Writer::write_data_type(REF::Class * object, bool reference) {
	write_data_type(known_cast<DataType *>(object), reference);
    }
    
    void
    Writer::write_node(REF::Class * object, bool reference) {
	write_node(known_cast<Node *>(object), reference);
    }
    
    void
    Writer::write_comment(REF::Class * object, bool reference) {
	write_comment(known_cast<Comment *>(object), reference);
    }
    
    void
    Writer::write_dependency(REF::Class * object, bool reference) {
	write_dependency(known_cast<Dependency *>(object), reference);
    }
    
    void
    Writer::write_binding(REF::Class * object, bool reference) {
	write_binding(known_cast<Binding *>(object), reference);
    }
    
    void
    Writer::write_abstraction(REF::Class * object, bool reference) {
	write_abstraction(known_cast<Abstraction *>(object), reference);
    }
    
    void
    Writer::write_usage(REF::Class * object, bool reference) {
	write_usage(known_cast<Usage *>(object), reference);
    }
    
    void
    Writer::write_permission(REF::Class * object, bool reference) {
	write_permission(known_cast<Permission *>(object), reference);
    }
    
    void
    Writer::write_generalization(REF::Class * object, bool reference) {
	write_generalization(known_cast<Generalization *>(object), reference);
    }
    
    void
    Writer::write_class(REF::Class * object, bool reference) {
	write_class(known_cast<Class *>(object), reference);
    }
    
    void
    Writer::write_association_class(REF::Class * object, bool reference) {
	write_association_class(known_cast<AssociationClass *>(object), reference);
    }
    
    void
    Writer::write_association(REF::Class * object, bool reference) {
	write_association(known_cast<Association *>(object), reference);
    }
    
    void
    Writer::write_association_end(REF::Class * object, bool reference) {
	write_association_end(known_cast<AssociationEnd *>(object), reference);
    }
    
    void
    Writer::write_stereotype(REF::Class * object, bool reference) {
	write_stereotype(known_cast<Stereotype *>(object), reference);
    }
    
    void
    Writer::write_tagged_value(REF::Class * object, bool reference) {
	write_tagged_value(known_cast<TaggedValue *>(object), reference);
    }
    
    void
    Writer::write_tag_definition(REF::Class * object, bool reference) {
	write_tag_definition(known_cast<TagDefinition *>(object), reference);
    }
    
    void
    Writer::write_package(REF::Class * object, bool reference) {
	write_package(known_cast<Package *>(object), reference);
    }
    
    void
    Writer::write_model(REF::Class * object, bool reference) {
	write_model(known_cast<Model *>(object), reference);
    }
    
    void
    Writer::write_diagram(REF::Class * object, bool reference) {
	write_diagram(known_cast<Diagram *>(object), reference);
    }
    
    void
    Writer::write_class_presentation(REF::Class * object, bool reference) {
	write_class_presentation(known_cast<ClassPresentation *>(object), reference);
    }
    
    void
    Writer::write_package_presentation(REF::Class * object, bool reference) {
	write_package_presentation(known_cast<PackagePresentation *>(object), reference);
    }
    
    void
    Writer::write_comment_presentation(REF::Class * object, bool reference) {
	write_comment_presentation(known_cast<CommentPresentation *>(object), reference);
    }
    
    void
    Writer::write_association_presentation(REF::Class * object, bool reference) {
	write_association_presentation(known_cast<AssociationPresentation *>(object), reference);
    }
    
    void
    Writer::write_generalization_presentation(REF::Class * object, bool reference) {
	write_generalization_presentation(known_cast<GeneralizationPresentation *>(object), reference);
    }
    
    void
    Writer::write_dependency_presentation(REF::Class * object, bool reference) {
	write_dependency_presentation(known_cast<DependencyPresentation *>(object), reference);
    }
    
    
    void
    Writer::write_constraint(Constraint * constraint, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Constraint");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", constraint->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", constraint->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_constraint(constraint, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_attribute(Attribute * attribute, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Attribute");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", attribute->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", attribute->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_attribute(attribute, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_operation(Operation * operation, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Operation");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", operation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", operation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_operation(operation, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_method(Method * method, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Method");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", method->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", method->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_method(method, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_parameter(Parameter * parameter, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Parameter");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", parameter->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", parameter->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_parameter(parameter, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_interface(Interface * interface, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Interface");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", interface->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", interface->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_interface(interface, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_data_type(DataType * data_type, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:DataType");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", data_type->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", data_type->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_data_type(data_type, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_node(Node * node, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Node");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", node->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", node->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_node(node, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_comment(Comment * comment, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Comment");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", comment->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", comment->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_comment(comment, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_dependency(Dependency * dependency, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Dependency");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", dependency->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", dependency->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_dependency(dependency, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_binding(Binding * binding, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Binding");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", binding->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", binding->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_binding(binding, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_abstraction(Abstraction * abstraction, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Abstraction");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", abstraction->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", abstraction->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_abstraction(abstraction, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_usage(Usage * usage, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Usage");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", usage->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", usage->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_usage(usage, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_permission(Permission * permission, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Permission");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", permission->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", permission->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_permission(permission, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_generalization(Generalization * generalization, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Generalization");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", generalization->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", generalization->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_generalization(generalization, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_class(Class * class_, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Class");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", class_->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", class_->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_class(class_, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_association_class(AssociationClass * association_class, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:AssociationClass");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", association_class->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", association_class->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_association_class(association_class, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_association(Association * association, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Association");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", association->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", association->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_association(association, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_association_end(AssociationEnd * association_end, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:AssociationEnd");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", association_end->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", association_end->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_association_end(association_end, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_stereotype(Stereotype * stereotype, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Stereotype");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", stereotype->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", stereotype->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_stereotype(stereotype, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_tagged_value(TaggedValue * tagged_value, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:TaggedValue");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", tagged_value->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", tagged_value->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_tagged_value(tagged_value, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_tag_definition(TagDefinition * tag_definition, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:TagDefinition");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", tag_definition->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", tag_definition->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_tag_definition(tag_definition, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_package(Package * package, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Package");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", package->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", package->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_package(package, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_model(Model * model, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Model");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", model->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", model->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_model(model, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_diagram(Diagram * diagram, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:Diagram");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", diagram->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", diagram->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_diagram(diagram, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_class_presentation(ClassPresentation * class_presentation, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:ClassPresentation");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", class_presentation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", class_presentation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_class_presentation(class_presentation, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_package_presentation(PackagePresentation * package_presentation, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:PackagePresentation");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", package_presentation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", package_presentation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_package_presentation(package_presentation, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_comment_presentation(CommentPresentation * comment_presentation, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:CommentPresentation");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", comment_presentation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", comment_presentation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_comment_presentation(comment_presentation, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_association_presentation(AssociationPresentation * association_presentation, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:AssociationPresentation");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", association_presentation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", association_presentation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_association_presentation(association_presentation, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_generalization_presentation(GeneralizationPresentation * generalization_presentation, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:GeneralizationPresentation");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", generalization_presentation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", generalization_presentation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_generalization_presentation(generalization_presentation, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    void
    Writer::write_dependency_presentation(DependencyPresentation * dependency_presentation, bool reference) {
	*mStream << XML::XmlBeginOpen("UML:DependencyPresentation");
	
	if(reference) {
	    *mStream << XML::XmlAttribute("xmi.idref", dependency_presentation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	}
	else {
	    *mStream << XML::XmlAttribute("xmi.id", dependency_presentation->ref_get_uuid().get_string());
	    *mStream << XML::XmlBeginClose();
	    set<string> visited;
	    write_dependency_presentation(dependency_presentation, visited);
	}
	
	*mStream << XML::XmlEnd();
    }
    
    
    void
    Writer::write_generalizable_element(GeneralizableElement * generalizable_element, set<string> & visited) {
	if(visited.insert("GeneralizableElement").second) {
	    const Boolean * is_root = generalizable_element->get_is_root();
	    
	    if(is_root) {
		*mStream << XML::XmlBeginOpen("UML:GeneralizableElement.isRoot");
		*mStream << XML::XmlBeginClose();
		
		invoke_data_type_handler(is_root);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const Boolean * is_leaf = generalizable_element->get_is_leaf();
	    
	    if(is_leaf) {
		*mStream << XML::XmlBeginOpen("UML:GeneralizableElement.isLeaf");
		*mStream << XML::XmlBeginClose();
		
		invoke_data_type_handler(is_leaf);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const Boolean * is_abstract = generalizable_element->get_is_abstract();
	    
	    if(is_abstract) {
		*mStream << XML::XmlBeginOpen("UML:GeneralizableElement.isAbstract");
		*mStream << XML::XmlBeginClose();
		
		invoke_data_type_handler(is_abstract);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    Writer::write_model_element(generalizable_element, visited);
	    const list<Generalization *> & generalization = generalizable_element->get_generalization();
	    
	    if(!generalization.empty()) {
		*mStream << XML::XmlBeginOpen("UML:GeneralizableElement.generalization");
		*mStream << XML::XmlBeginClose();
		
		for(list<Generalization *>::const_iterator iter = generalization.begin();
		    iter != generalization.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<Generalization *> & specialization = generalizable_element->get_specialization();
	    
	    if(!specialization.empty()) {
		*mStream << XML::XmlBeginOpen("UML:GeneralizableElement.specialization");
		*mStream << XML::XmlBeginClose();
		
		for(list<Generalization *>::const_iterator iter = specialization.begin();
		    iter != specialization.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_constraint(Constraint * constraint, set<string> & visited) {
	if(visited.insert("Constraint").second) {
	    Writer::write_model_element(constraint, visited);
	    const list<ModelElement *> & constrained_element = constraint->get_constrained_element();
	    
	    if(!constrained_element.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Constraint.constrainedElement");
		*mStream << XML::XmlBeginClose();
		
		for(list<ModelElement *>::const_iterator iter = constrained_element.begin();
		    iter != constrained_element.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    Stereotype * constrained_stereotype = constraint->get_constrained_stereotype();
	    
	    if(constrained_stereotype) {
		*mStream << XML::XmlBeginOpen("UML:Constraint.constrainedStereotype");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(constrained_stereotype, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_classifier(Classifier * classifier, set<string> & visited) {
	if(visited.insert("Classifier").second) {
	    Writer::write_namespace(classifier, visited);
	    Writer::write_generalizable_element(classifier, visited);
	    const list<Feature *> & feature = classifier->get_feature();
	    
	    if(!feature.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Classifier.feature");
		*mStream << XML::XmlBeginClose();
		
		for(list<Feature *>::const_iterator iter = feature.begin();
		    iter != feature.end();
		    ++iter) {
		    invoke_class_handler(*iter, false);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<StructuralFeature *> & typed_feature = classifier->get_typed_feature();
	    
	    if(!typed_feature.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Classifier.typedFeature");
		*mStream << XML::XmlBeginClose();
		
		for(list<StructuralFeature *>::const_iterator iter = typed_feature.begin();
		    iter != typed_feature.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<Parameter *> & typed_parameter = classifier->get_typed_parameter();
	    
	    if(!typed_parameter.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Classifier.typedParameter");
		*mStream << XML::XmlBeginClose();
		
		for(list<Parameter *>::const_iterator iter = typed_parameter.begin();
		    iter != typed_parameter.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<AssociationEnd *> & association = classifier->get_association();
	    
	    if(!association.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Classifier.association");
		*mStream << XML::XmlBeginClose();
		
		for(list<AssociationEnd *>::const_iterator iter = association.begin();
		    iter != association.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_structural_feature(StructuralFeature * structural_feature, set<string> & visited) {
	if(visited.insert("StructuralFeature").second) {
	    Writer::write_feature(structural_feature, visited);
	}
    }
    
    void
    Writer::write_behavioral_feature(BehavioralFeature * behavioral_feature, set<string> & visited) {
	if(visited.insert("BehavioralFeature").second) {
	    const Boolean * is_query = behavioral_feature->get_is_query();
	    
	    if(is_query) {
		*mStream << XML::XmlBeginOpen("UML:BehavioralFeature.isQuery");
		*mStream << XML::XmlBeginClose();
		
		invoke_data_type_handler(is_query);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    Writer::write_feature(behavioral_feature, visited);
	    const list<Parameter *> & parameter = behavioral_feature->get_parameter();
	    
	    if(!parameter.empty()) {
		*mStream << XML::XmlBeginOpen("UML:BehavioralFeature.parameter");
		*mStream << XML::XmlBeginClose();
		
		for(list<Parameter *>::const_iterator iter = parameter.begin();
		    iter != parameter.end();
		    ++iter) {
		    invoke_class_handler(*iter, false);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_element(Element * element, set<string> & visited) {
	if(visited.insert("Element").second) {
	}
    }
    
    void
    Writer::write_attribute(Attribute * attribute, set<string> & visited) {
	if(visited.insert("Attribute").second) {
	    Writer::write_structural_feature(attribute, visited);
	    AssociationEnd * association_end = attribute->get_association_end();
	    
	    if(association_end) {
		*mStream << XML::XmlBeginOpen("UML:Attribute.associationEnd");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(association_end, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_operation(Operation * operation, set<string> & visited) {
	if(visited.insert("Operation").second) {
	    Writer::write_behavioral_feature(operation, visited);
	    const list<Method *> & method = operation->get_method();
	    
	    if(!method.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Operation.method");
		*mStream << XML::XmlBeginClose();
		
		for(list<Method *>::const_iterator iter = method.begin();
		    iter != method.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_method(Method * method, set<string> & visited) {
	if(visited.insert("Method").second) {
	    Writer::write_behavioral_feature(method, visited);
	    const list<Operation *> & specification = method->get_specification();
	    
	    if(!specification.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Method.specification");
		*mStream << XML::XmlBeginClose();
		
		for(list<Operation *>::const_iterator iter = specification.begin();
		    iter != specification.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_model_element(ModelElement * model_element, set<string> & visited) {
	if(visited.insert("ModelElement").second) {
	    const Name * name = model_element->get_name();
	    
	    if(name) {
		*mStream << XML::XmlBeginOpen("UML:ModelElement.name");
		*mStream << XML::XmlBeginClose();
		
		invoke_data_type_handler(name);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const Boolean * is_specification = model_element->get_is_specification();
	    
	    if(is_specification) {
		*mStream << XML::XmlBeginOpen("UML:ModelElement.isSpecification");
		*mStream << XML::XmlBeginClose();
		
		invoke_data_type_handler(is_specification);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    Writer::write_element(model_element, visited);
	    const list<Constraint *> & constraint = model_element->get_constraint();
	    
	    if(!constraint.empty()) {
		*mStream << XML::XmlBeginOpen("UML:ModelElement.constraint");
		*mStream << XML::XmlBeginClose();
		
		for(list<Constraint *>::const_iterator iter = constraint.begin();
		    iter != constraint.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    Namespace * namespace_ = model_element->get_namespace();
	    
	    if(namespace_) {
		*mStream << XML::XmlBeginOpen("UML:ModelElement.namespace");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(namespace_, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<Dependency *> & supplier_dependency = model_element->get_supplier_dependency();
	    
	    if(!supplier_dependency.empty()) {
		*mStream << XML::XmlBeginOpen("UML:ModelElement.supplierDependency");
		*mStream << XML::XmlBeginClose();
		
		for(list<Dependency *>::const_iterator iter = supplier_dependency.begin();
		    iter != supplier_dependency.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<Dependency *> & client_dependency = model_element->get_client_dependency();
	    
	    if(!client_dependency.empty()) {
		*mStream << XML::XmlBeginOpen("UML:ModelElement.clientDependency");
		*mStream << XML::XmlBeginClose();
		
		for(list<Dependency *>::const_iterator iter = client_dependency.begin();
		    iter != client_dependency.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<Stereotype *> & stereotype = model_element->get_stereotype();
	    
	    if(!stereotype.empty()) {
		*mStream << XML::XmlBeginOpen("UML:ModelElement.stereotype");
		*mStream << XML::XmlBeginClose();
		
		for(list<Stereotype *>::const_iterator iter = stereotype.begin();
		    iter != stereotype.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<TaggedValue *> & tagged_value = model_element->get_tagged_value();
	    
	    if(!tagged_value.empty()) {
		*mStream << XML::XmlBeginOpen("UML:ModelElement.taggedValue");
		*mStream << XML::XmlBeginClose();
		
		for(list<TaggedValue *>::const_iterator iter = tagged_value.begin();
		    iter != tagged_value.end();
		    ++iter) {
		    invoke_class_handler(*iter, false);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<TaggedValue *> & reference_tag = model_element->get_reference_tag();
	    
	    if(!reference_tag.empty()) {
		*mStream << XML::XmlBeginOpen("UML:ModelElement.referenceTag");
		*mStream << XML::XmlBeginClose();
		
		for(list<TaggedValue *>::const_iterator iter = reference_tag.begin();
		    iter != reference_tag.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<Comment *> & comment = model_element->get_comment();
	    
	    if(!comment.empty()) {
		*mStream << XML::XmlBeginOpen("UML:ModelElement.comment");
		*mStream << XML::XmlBeginClose();
		
		for(list<Comment *>::const_iterator iter = comment.begin();
		    iter != comment.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<PresentationElement *> & presentation = model_element->get_presentation();
	    
	    if(!presentation.empty()) {
		*mStream << XML::XmlBeginOpen("UML:ModelElement.presentation");
		*mStream << XML::XmlBeginClose();
		
		for(list<PresentationElement *>::const_iterator iter = presentation.begin();
		    iter != presentation.end();
		    ++iter) {
		    invoke_class_handler(*iter, false);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_feature(Feature * feature, set<string> & visited) {
	if(visited.insert("Feature").second) {
	    Writer::write_model_element(feature, visited);
	    Classifier * owner = feature->get_owner();
	    
	    if(owner) {
		*mStream << XML::XmlBeginOpen("UML:Feature.owner");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(owner, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_namespace(Namespace * namespace_, set<string> & visited) {
	if(visited.insert("Namespace").second) {
	    Writer::write_model_element(namespace_, visited);
	    const list<ModelElement *> & owned_element = namespace_->get_owned_element();
	    
	    if(!owned_element.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Namespace.ownedElement");
		*mStream << XML::XmlBeginClose();
		
		for(list<ModelElement *>::const_iterator iter = owned_element.begin();
		    iter != owned_element.end();
		    ++iter) {
		    invoke_class_handler(*iter, false);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_parameter(Parameter * parameter, set<string> & visited) {
	if(visited.insert("Parameter").second) {
	    Writer::write_model_element(parameter, visited);
	    BehavioralFeature * behavioral_feature = parameter->get_behavioral_feature();
	    
	    if(behavioral_feature) {
		*mStream << XML::XmlBeginOpen("UML:Parameter.behavioralFeature");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(behavioral_feature, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_interface(Interface * interface, set<string> & visited) {
	if(visited.insert("Interface").second) {
	    Writer::write_classifier(interface, visited);
	}
    }
    
    void
    Writer::write_data_type(DataType * data_type, set<string> & visited) {
	if(visited.insert("DataType").second) {
	    Writer::write_classifier(data_type, visited);
	}
    }
    
    void
    Writer::write_node(Node * node, set<string> & visited) {
	if(visited.insert("Node").second) {
	    Writer::write_classifier(node, visited);
	}
    }
    
    void
    Writer::write_comment(Comment * comment, set<string> & visited) {
	if(visited.insert("Comment").second) {
	    const Name * body = comment->get_body();
	    
	    if(body) {
		*mStream << XML::XmlBeginOpen("UML:Comment.body");
		*mStream << XML::XmlBeginClose();
		
		invoke_data_type_handler(body);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    Writer::write_model_element(comment, visited);
	    const list<ModelElement *> & annotated_element = comment->get_annotated_element();
	    
	    if(!annotated_element.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Comment.annotatedElement");
		*mStream << XML::XmlBeginClose();
		
		for(list<ModelElement *>::const_iterator iter = annotated_element.begin();
		    iter != annotated_element.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_relationship(Relationship * relationship, set<string> & visited) {
	if(visited.insert("Relationship").second) {
	    Writer::write_model_element(relationship, visited);
	}
    }
    
    void
    Writer::write_dependency(Dependency * dependency, set<string> & visited) {
	if(visited.insert("Dependency").second) {
	    Writer::write_relationship(dependency, visited);
	    const list<ModelElement *> & supplier = dependency->get_supplier();
	    
	    if(!supplier.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Dependency.supplier");
		*mStream << XML::XmlBeginClose();
		
		for(list<ModelElement *>::const_iterator iter = supplier.begin();
		    iter != supplier.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<ModelElement *> & client = dependency->get_client();
	    
	    if(!client.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Dependency.client");
		*mStream << XML::XmlBeginClose();
		
		for(list<ModelElement *>::const_iterator iter = client.begin();
		    iter != client.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_binding(Binding * binding, set<string> & visited) {
	if(visited.insert("Binding").second) {
	    Writer::write_dependency(binding, visited);
	}
    }
    
    void
    Writer::write_abstraction(Abstraction * abstraction, set<string> & visited) {
	if(visited.insert("Abstraction").second) {
	    Writer::write_dependency(abstraction, visited);
	}
    }
    
    void
    Writer::write_usage(Usage * usage, set<string> & visited) {
	if(visited.insert("Usage").second) {
	    Writer::write_dependency(usage, visited);
	}
    }
    
    void
    Writer::write_permission(Permission * permission, set<string> & visited) {
	if(visited.insert("Permission").second) {
	    Writer::write_dependency(permission, visited);
	}
    }
    
    void
    Writer::write_generalization(Generalization * generalization, set<string> & visited) {
	if(visited.insert("Generalization").second) {
	    const Name * discriminator = generalization->get_discriminator();
	    
	    if(discriminator) {
		*mStream << XML::XmlBeginOpen("UML:Generalization.discriminator");
		*mStream << XML::XmlBeginClose();
		
		invoke_data_type_handler(discriminator);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    Writer::write_relationship(generalization, visited);
	    GeneralizableElement * child = generalization->get_child();
	    
	    if(child) {
		*mStream << XML::XmlBeginOpen("UML:Generalization.child");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(child, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    GeneralizableElement * parent = generalization->get_parent();
	    
	    if(parent) {
		*mStream << XML::XmlBeginOpen("UML:Generalization.parent");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(parent, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_class(Class * class_, set<string> & visited) {
	if(visited.insert("Class").second) {
	    Writer::write_classifier(class_, visited);
	}
    }
    
    void
    Writer::write_association_class(AssociationClass * association_class, set<string> & visited) {
	if(visited.insert("AssociationClass").second) {
	    Writer::write_association(association_class, visited);
	    Writer::write_class(association_class, visited);
	}
    }
    
    void
    Writer::write_association(Association * association, set<string> & visited) {
	if(visited.insert("Association").second) {
	    Writer::write_generalizable_element(association, visited);
	    Writer::write_relationship(association, visited);
	    const list<AssociationEnd *> & connection = association->get_connection();
	    
	    if(!connection.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Association.connection");
		*mStream << XML::XmlBeginClose();
		
		for(list<AssociationEnd *>::const_iterator iter = connection.begin();
		    iter != connection.end();
		    ++iter) {
		    invoke_class_handler(*iter, false);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_association_end(AssociationEnd * association_end, set<string> & visited) {
	if(visited.insert("AssociationEnd").second) {
	    Writer::write_model_element(association_end, visited);
	    Association * connector = association_end->get_connector();
	    
	    if(connector) {
		*mStream << XML::XmlBeginOpen("UML:AssociationEnd.connector");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(connector, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    Classifier * type = association_end->get_type();
	    
	    if(type) {
		*mStream << XML::XmlBeginOpen("UML:AssociationEnd.type");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(type, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<Attribute *> & qualifier = association_end->get_qualifier();
	    
	    if(!qualifier.empty()) {
		*mStream << XML::XmlBeginOpen("UML:AssociationEnd.qualifier");
		*mStream << XML::XmlBeginClose();
		
		for(list<Attribute *>::const_iterator iter = qualifier.begin();
		    iter != qualifier.end();
		    ++iter) {
		    invoke_class_handler(*iter, false);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_stereotype(Stereotype * stereotype, set<string> & visited) {
	if(visited.insert("Stereotype").second) {
	    Writer::write_generalizable_element(stereotype, visited);
	    const list<ModelElement *> & extended_element = stereotype->get_extended_element();
	    
	    if(!extended_element.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Stereotype.extendedElement");
		*mStream << XML::XmlBeginClose();
		
		for(list<ModelElement *>::const_iterator iter = extended_element.begin();
		    iter != extended_element.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<Constraint *> & stereotype_constraint = stereotype->get_stereotype_constraint();
	    
	    if(!stereotype_constraint.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Stereotype.stereotypeConstraint");
		*mStream << XML::XmlBeginClose();
		
		for(list<Constraint *>::const_iterator iter = stereotype_constraint.begin();
		    iter != stereotype_constraint.end();
		    ++iter) {
		    invoke_class_handler(*iter, false);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<TagDefinition *> & defined_tag = stereotype->get_defined_tag();
	    
	    if(!defined_tag.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Stereotype.definedTag");
		*mStream << XML::XmlBeginClose();
		
		for(list<TagDefinition *>::const_iterator iter = defined_tag.begin();
		    iter != defined_tag.end();
		    ++iter) {
		    invoke_class_handler(*iter, false);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_tagged_value(TaggedValue * tagged_value, set<string> & visited) {
	if(visited.insert("TaggedValue").second) {
	    const Name * data_value = tagged_value->get_data_value();
	    
	    if(data_value) {
		*mStream << XML::XmlBeginOpen("UML:TaggedValue.dataValue");
		*mStream << XML::XmlBeginClose();
		
		invoke_data_type_handler(data_value);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    Writer::write_model_element(tagged_value, visited);
	    ModelElement * owner = tagged_value->get_owner();
	    
	    if(owner) {
		*mStream << XML::XmlBeginOpen("UML:TaggedValue.owner");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(owner, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<ModelElement *> & reference_value = tagged_value->get_reference_value();
	    
	    if(!reference_value.empty()) {
		*mStream << XML::XmlBeginOpen("UML:TaggedValue.referenceValue");
		*mStream << XML::XmlBeginClose();
		
		for(list<ModelElement *>::const_iterator iter = reference_value.begin();
		    iter != reference_value.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    TagDefinition * type = tagged_value->get_type();
	    
	    if(type) {
		*mStream << XML::XmlBeginOpen("UML:TaggedValue.type");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(type, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_tag_definition(TagDefinition * tag_definition, set<string> & visited) {
	if(visited.insert("TagDefinition").second) {
	    const Name * tag_type = tag_definition->get_tag_type();
	    
	    if(tag_type) {
		*mStream << XML::XmlBeginOpen("UML:TagDefinition.tagType");
		*mStream << XML::XmlBeginClose();
		
		invoke_data_type_handler(tag_type);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    Writer::write_generalizable_element(tag_definition, visited);
	    Stereotype * owner = tag_definition->get_owner();
	    
	    if(owner) {
		*mStream << XML::XmlBeginOpen("UML:TagDefinition.owner");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(owner, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<TaggedValue *> & typed_value = tag_definition->get_typed_value();
	    
	    if(!typed_value.empty()) {
		*mStream << XML::XmlBeginOpen("UML:TagDefinition.typedValue");
		*mStream << XML::XmlBeginClose();
		
		for(list<TaggedValue *>::const_iterator iter = typed_value.begin();
		    iter != typed_value.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_package(Package * package, set<string> & visited) {
	if(visited.insert("Package").second) {
	    Writer::write_namespace(package, visited);
	    Writer::write_generalizable_element(package, visited);
	}
    }
    
    void
    Writer::write_model(Model * model, set<string> & visited) {
	if(visited.insert("Model").second) {
	    Writer::write_package(model, visited);
	}
    }
    
    void
    Writer::write_diagram(Diagram * diagram, set<string> & visited) {
	if(visited.insert("Diagram").second) {
	    const Name * name = diagram->get_name();
	    
	    if(name) {
		*mStream << XML::XmlBeginOpen("UML:Diagram.name");
		*mStream << XML::XmlBeginClose();
		
		invoke_data_type_handler(name);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    Writer::write_model_element(diagram, visited);
	    const list<GraphElement *> & element = diagram->get_element();
	    
	    if(!element.empty()) {
		*mStream << XML::XmlBeginOpen("UML:Diagram.element");
		*mStream << XML::XmlBeginClose();
		
		for(list<GraphElement *>::const_iterator iter = element.begin();
		    iter != element.end();
		    ++iter) {
		    invoke_class_handler(*iter, false);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_graph_element(GraphElement * graph_element, set<string> & visited) {
	if(visited.insert("GraphElement").second) {
	    const Name * geometry = graph_element->get_geometry();
	    
	    if(geometry) {
		*mStream << XML::XmlBeginOpen("UML:GraphElement.geometry");
		*mStream << XML::XmlBeginClose();
		
		invoke_data_type_handler(geometry);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    Writer::write_element(graph_element, visited);
	    Diagram * diagram = graph_element->get_diagram();
	    
	    if(diagram) {
		*mStream << XML::XmlBeginOpen("UML:GraphElement.diagram");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(diagram, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_presentation_element(PresentationElement * presentation_element, set<string> & visited) {
	if(visited.insert("PresentationElement").second) {
	    Writer::write_graph_element(presentation_element, visited);
	    ModelElement * subject = presentation_element->get_subject();
	    
	    if(subject) {
		*mStream << XML::XmlBeginOpen("UML:PresentationElement.subject");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(subject, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<DependencyPresentation *> & supplier_dependency = presentation_element->get_supplier_dependency();
	    
	    if(!supplier_dependency.empty()) {
		*mStream << XML::XmlBeginOpen("UML:PresentationElement.supplierDependency");
		*mStream << XML::XmlBeginClose();
		
		for(list<DependencyPresentation *>::const_iterator iter = supplier_dependency.begin();
		    iter != supplier_dependency.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<DependencyPresentation *> & client_dependency = presentation_element->get_client_dependency();
	    
	    if(!client_dependency.empty()) {
		*mStream << XML::XmlBeginOpen("UML:PresentationElement.clientDependency");
		*mStream << XML::XmlBeginClose();
		
		for(list<DependencyPresentation *>::const_iterator iter = client_dependency.begin();
		    iter != client_dependency.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_edge_element(EdgeElement * edge_element, set<string> & visited) {
	if(visited.insert("EdgeElement").second) {
	    Writer::write_presentation_element(edge_element, visited);
	}
    }
    
    void
    Writer::write_node_element(NodeElement * node_element, set<string> & visited) {
	if(visited.insert("NodeElement").second) {
	    Writer::write_presentation_element(node_element, visited);
	}
    }
    
    void
    Writer::write_class_presentation(ClassPresentation * class_presentation, set<string> & visited) {
	if(visited.insert("ClassPresentation").second) {
	    Writer::write_node_element(class_presentation, visited);
	    const list<AssociationPresentation *> & association_source = class_presentation->get_association_source();
	    
	    if(!association_source.empty()) {
		*mStream << XML::XmlBeginOpen("UML:ClassPresentation.association_source");
		*mStream << XML::XmlBeginClose();
		
		for(list<AssociationPresentation *>::const_iterator iter = association_source.begin();
		    iter != association_source.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<AssociationPresentation *> & association_destination = class_presentation->get_association_destination();
	    
	    if(!association_destination.empty()) {
		*mStream << XML::XmlBeginOpen("UML:ClassPresentation.association_destination");
		*mStream << XML::XmlBeginClose();
		
		for(list<AssociationPresentation *>::const_iterator iter = association_destination.begin();
		    iter != association_destination.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<GeneralizationPresentation *> & generalization = class_presentation->get_generalization();
	    
	    if(!generalization.empty()) {
		*mStream << XML::XmlBeginOpen("UML:ClassPresentation.generalization");
		*mStream << XML::XmlBeginClose();
		
		for(list<GeneralizationPresentation *>::const_iterator iter = generalization.begin();
		    iter != generalization.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    const list<GeneralizationPresentation *> & specialization = class_presentation->get_specialization();
	    
	    if(!specialization.empty()) {
		*mStream << XML::XmlBeginOpen("UML:ClassPresentation.specialization");
		*mStream << XML::XmlBeginClose();
		
		for(list<GeneralizationPresentation *>::const_iterator iter = specialization.begin();
		    iter != specialization.end();
		    ++iter) {
		    invoke_class_handler(*iter, true);
		}
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_package_presentation(PackagePresentation * package_presentation, set<string> & visited) {
	if(visited.insert("PackagePresentation").second) {
	    Writer::write_node_element(package_presentation, visited);
	}
    }
    
    void
    Writer::write_comment_presentation(CommentPresentation * comment_presentation, set<string> & visited) {
	if(visited.insert("CommentPresentation").second) {
	    Writer::write_node_element(comment_presentation, visited);
	    Writer::write_edge_element(comment_presentation, visited);
	}
    }
    
    void
    Writer::write_association_presentation(AssociationPresentation * association_presentation, set<string> & visited) {
	if(visited.insert("AssociationPresentation").second) {
	    Writer::write_edge_element(association_presentation, visited);
	    ClassPresentation * source = association_presentation->get_source();
	    
	    if(source) {
		*mStream << XML::XmlBeginOpen("UML:AssociationPresentation.source");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(source, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    ClassPresentation * destination = association_presentation->get_destination();
	    
	    if(destination) {
		*mStream << XML::XmlBeginOpen("UML:AssociationPresentation.destination");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(destination, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_generalization_presentation(GeneralizationPresentation * generalization_presentation, set<string> & visited) {
	if(visited.insert("GeneralizationPresentation").second) {
	    Writer::write_edge_element(generalization_presentation, visited);
	    ClassPresentation * subtype = generalization_presentation->get_subtype();
	    
	    if(subtype) {
		*mStream << XML::XmlBeginOpen("UML:GeneralizationPresentation.subtype");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(subtype, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    ClassPresentation * supertype = generalization_presentation->get_supertype();
	    
	    if(supertype) {
		*mStream << XML::XmlBeginOpen("UML:GeneralizationPresentation.supertype");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(supertype, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_dependency_presentation(DependencyPresentation * dependency_presentation, set<string> & visited) {
	if(visited.insert("DependencyPresentation").second) {
	    Writer::write_edge_element(dependency_presentation, visited);
	    PresentationElement * supplier = dependency_presentation->get_supplier();
	    
	    if(supplier) {
		*mStream << XML::XmlBeginOpen("UML:DependencyPresentation.supplier");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(supplier, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	    PresentationElement * client = dependency_presentation->get_client();
	    
	    if(client) {
		*mStream << XML::XmlBeginOpen("UML:DependencyPresentation.client");
		*mStream << XML::XmlBeginClose();
		
		invoke_class_handler(client, true);
		
		*mStream << XML::XmlEnd();
		
	    }
	    
	}
    }
    
    void
    Writer::write_integer(const REF::Attribute * integer) {
	write_integer(known_cast<const Integer *>(integer));
    }
    
    void
    Writer::write_name(const REF::Attribute * name) {
	write_name(known_cast<const Name *>(name));
    }
    
    void
    Writer::write_boolean(const REF::Attribute * boolean) {
	write_boolean(known_cast<const Boolean *>(boolean));
    }
    
    void
    Writer::write_aggregation_kind(const REF::Attribute * aggregation_kind) {
	write_aggregation_kind(known_cast<const AggregationKind *>(aggregation_kind));
    }
    
    void
    Writer::write_call_concurrency_kind(const REF::Attribute * call_concurrency_kind) {
	write_call_concurrency_kind(known_cast<const CallConcurrencyKind *>(call_concurrency_kind));
    }
    
    void
    Writer::write_changeable_kind(const REF::Attribute * changeable_kind) {
	write_changeable_kind(known_cast<const ChangeableKind *>(changeable_kind));
    }
    
    void
    Writer::write_ordering_kind(const REF::Attribute * ordering_kind) {
	write_ordering_kind(known_cast<const OrderingKind *>(ordering_kind));
    }
    
    void
    Writer::write_parameter_direction_kind(const REF::Attribute * parameter_direction_kind) {
	write_parameter_direction_kind(known_cast<const ParameterDirectionKind *>(parameter_direction_kind));
    }
    
    void
    Writer::write_scope_kind(const REF::Attribute * scope_kind) {
	write_scope_kind(known_cast<const ScopeKind *>(scope_kind));
    }
    
    void
    Writer::write_visibility_kind(const REF::Attribute * visibility_kind) {
	write_visibility_kind(known_cast<const VisibilityKind *>(visibility_kind));
    }
    
    void
    Writer::write_diagram_kind(const REF::Attribute * diagram_kind) {
	write_diagram_kind(known_cast<const DiagramKind *>(diagram_kind));
    }
    
    void
    Writer::write_multiplicity_type(const REF::Attribute * multiplicity_type) {
	write_multiplicity_type(known_cast<const MultiplicityType *>(multiplicity_type));
    }
    
    void
    Writer::write_integer(const Integer * integer) {
	*mStream << integer->get_value();
    }
    
    void
    Writer::write_name(const Name * name) {
	*mStream << name->get_value();
    }
    
    void
    Writer::write_boolean(const Boolean * boolean) {
	*mStream << boolean->get_value();
    }
    
    void
    Writer::write_aggregation_kind(const AggregationKind * aggregation_kind) {
	*mStream << aggregation_kind->get_value();
    }
    
    void
    Writer::write_call_concurrency_kind(const CallConcurrencyKind * call_concurrency_kind) {
	*mStream << call_concurrency_kind->get_value();
    }
    
    void
    Writer::write_changeable_kind(const ChangeableKind * changeable_kind) {
	*mStream << changeable_kind->get_value();
    }
    
    void
    Writer::write_ordering_kind(const OrderingKind * ordering_kind) {
	*mStream << ordering_kind->get_value();
    }
    
    void
    Writer::write_parameter_direction_kind(const ParameterDirectionKind * parameter_direction_kind) {
	*mStream << parameter_direction_kind->get_value();
    }
    
    void
    Writer::write_scope_kind(const ScopeKind * scope_kind) {
	*mStream << scope_kind->get_value();
    }
    
    void
    Writer::write_visibility_kind(const VisibilityKind * visibility_kind) {
	*mStream << visibility_kind->get_value();
    }
    
    void
    Writer::write_diagram_kind(const DiagramKind * diagram_kind) {
	*mStream << diagram_kind->get_value();
    }
    
    void
    Writer::write_multiplicity_type(const MultiplicityType * multiplicity_type) {
    }
    
} // namespace UML
