// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UML_WRITER_H
#define UML_WRITER_H

#include "foundation/object.h"

#include "reflective/class.h"

#include <string>
#include <map>
#include <set>
#include <iosfwd>
#include <typeinfo>
using namespace std;

namespace XML {
    
    class Stream;
    
} // namespace XML

namespace UML {
    
    class GeneralizableElement;
    class Constraint;
    class Classifier;
    class StructuralFeature;
    class BehavioralFeature;
    class Element;
    class Attribute;
    class Operation;
    class Method;
    class ModelElement;
    class Feature;
    class Namespace;
    class Parameter;
    class Interface;
    class DataType;
    class Node;
    class Comment;
    class Relationship;
    class Dependency;
    class Binding;
    class Abstraction;
    class Usage;
    class Permission;
    class Generalization;
    class Class;
    class AssociationClass;
    class Association;
    class AssociationEnd;
    class Stereotype;
    class TaggedValue;
    class TagDefinition;
    class Package;
    class Model;
    class Diagram;
    class GraphElement;
    class PresentationElement;
    class EdgeElement;
    class NodeElement;
    class ClassPresentation;
    class PackagePresentation;
    class CommentPresentation;
    class AssociationPresentation;
    class GeneralizationPresentation;
    class DependencyPresentation;
    
    class Integer;
    class Name;
    class Boolean;
    class AggregationKind;
    class CallConcurrencyKind;
    class ChangeableKind;
    class OrderingKind;
    class ParameterDirectionKind;
    class ScopeKind;
    class VisibilityKind;
    class DiagramKind;
    class MultiplicityType;
    
    class Writer : public Object {
    public:
	Writer(REF::Class * root);
	~Writer();
	
	void write(ostream & ost);
	
    protected:
	void invoke_class_handler(REF::Class * object, bool reference);
	
	void invoke_data_type_handler(const REF::Attribute * object);
	
	void write_constraint(REF::Class * object, bool reference);
	void write_attribute(REF::Class * object, bool reference);
	void write_operation(REF::Class * object, bool reference);
	void write_method(REF::Class * object, bool reference);
	void write_parameter(REF::Class * object, bool reference);
	void write_interface(REF::Class * object, bool reference);
	void write_data_type(REF::Class * object, bool reference);
	void write_node(REF::Class * object, bool reference);
	void write_comment(REF::Class * object, bool reference);
	void write_dependency(REF::Class * object, bool reference);
	void write_binding(REF::Class * object, bool reference);
	void write_abstraction(REF::Class * object, bool reference);
	void write_usage(REF::Class * object, bool reference);
	void write_permission(REF::Class * object, bool reference);
	void write_generalization(REF::Class * object, bool reference);
	void write_class(REF::Class * object, bool reference);
	void write_association_class(REF::Class * object, bool reference);
	void write_association(REF::Class * object, bool reference);
	void write_association_end(REF::Class * object, bool reference);
	void write_stereotype(REF::Class * object, bool reference);
	void write_tagged_value(REF::Class * object, bool reference);
	void write_tag_definition(REF::Class * object, bool reference);
	void write_package(REF::Class * object, bool reference);
	void write_model(REF::Class * object, bool reference);
	void write_diagram(REF::Class * object, bool reference);
	void write_class_presentation(REF::Class * object, bool reference);
	void write_package_presentation(REF::Class * object, bool reference);
	void write_comment_presentation(REF::Class * object, bool reference);
	void write_association_presentation(REF::Class * object, bool reference);
	void write_generalization_presentation(REF::Class * object, bool reference);
	void write_dependency_presentation(REF::Class * object, bool reference);
	
	//
	//
	//
	
	void write_constraint(Constraint * constraint, bool reference);
	void write_attribute(Attribute * attribute, bool reference);
	void write_operation(Operation * operation, bool reference);
	void write_method(Method * method, bool reference);
	void write_parameter(Parameter * parameter, bool reference);
	void write_interface(Interface * interface, bool reference);
	void write_data_type(DataType * data_type, bool reference);
	void write_node(Node * node, bool reference);
	void write_comment(Comment * comment, bool reference);
	void write_dependency(Dependency * dependency, bool reference);
	void write_binding(Binding * binding, bool reference);
	void write_abstraction(Abstraction * abstraction, bool reference);
	void write_usage(Usage * usage, bool reference);
	void write_permission(Permission * permission, bool reference);
	void write_generalization(Generalization * generalization, bool reference);
	void write_class(Class * class_, bool reference);
	void write_association_class(AssociationClass * association_class, bool reference);
	void write_association(Association * association, bool reference);
	void write_association_end(AssociationEnd * association_end, bool reference);
	void write_stereotype(Stereotype * stereotype, bool reference);
	void write_tagged_value(TaggedValue * tagged_value, bool reference);
	void write_tag_definition(TagDefinition * tag_definition, bool reference);
	void write_package(Package * package, bool reference);
	void write_model(Model * model, bool reference);
	void write_diagram(Diagram * diagram, bool reference);
	void write_class_presentation(ClassPresentation * class_presentation, bool reference);
	void write_package_presentation(PackagePresentation * package_presentation, bool reference);
	void write_comment_presentation(CommentPresentation * comment_presentation, bool reference);
	void write_association_presentation(AssociationPresentation * association_presentation, bool reference);
	void write_generalization_presentation(GeneralizationPresentation * generalization_presentation, bool reference);
	void write_dependency_presentation(DependencyPresentation * dependency_presentation, bool reference);
	
	//
	//
	//
	
	void write_generalizable_element(GeneralizableElement * generalizable_element, set<string> & visited);
	void write_constraint(Constraint * constraint, set<string> & visited);
	void write_classifier(Classifier * classifier, set<string> & visited);
	void write_structural_feature(StructuralFeature * structural_feature, set<string> & visited);
	void write_behavioral_feature(BehavioralFeature * behavioral_feature, set<string> & visited);
	void write_element(Element * element, set<string> & visited);
	void write_attribute(Attribute * attribute, set<string> & visited);
	void write_operation(Operation * operation, set<string> & visited);
	void write_method(Method * method, set<string> & visited);
	void write_model_element(ModelElement * model_element, set<string> & visited);
	void write_feature(Feature * feature, set<string> & visited);
	void write_namespace(Namespace * namespace_, set<string> & visited);
	void write_parameter(Parameter * parameter, set<string> & visited);
	void write_interface(Interface * interface, set<string> & visited);
	void write_data_type(DataType * data_type, set<string> & visited);
	void write_node(Node * node, set<string> & visited);
	void write_comment(Comment * comment, set<string> & visited);
	void write_relationship(Relationship * relationship, set<string> & visited);
	void write_dependency(Dependency * dependency, set<string> & visited);
	void write_binding(Binding * binding, set<string> & visited);
	void write_abstraction(Abstraction * abstraction, set<string> & visited);
	void write_usage(Usage * usage, set<string> & visited);
	void write_permission(Permission * permission, set<string> & visited);
	void write_generalization(Generalization * generalization, set<string> & visited);
	void write_class(Class * class_, set<string> & visited);
	void write_association_class(AssociationClass * association_class, set<string> & visited);
	void write_association(Association * association, set<string> & visited);
	void write_association_end(AssociationEnd * association_end, set<string> & visited);
	void write_stereotype(Stereotype * stereotype, set<string> & visited);
	void write_tagged_value(TaggedValue * tagged_value, set<string> & visited);
	void write_tag_definition(TagDefinition * tag_definition, set<string> & visited);
	void write_package(Package * package, set<string> & visited);
	void write_model(Model * model, set<string> & visited);
	void write_diagram(Diagram * diagram, set<string> & visited);
	void write_graph_element(GraphElement * graph_element, set<string> & visited);
	void write_presentation_element(PresentationElement * presentation_element, set<string> & visited);
	void write_edge_element(EdgeElement * edge_element, set<string> & visited);
	void write_node_element(NodeElement * node_element, set<string> & visited);
	void write_class_presentation(ClassPresentation * class_presentation, set<string> & visited);
	void write_package_presentation(PackagePresentation * package_presentation, set<string> & visited);
	void write_comment_presentation(CommentPresentation * comment_presentation, set<string> & visited);
	void write_association_presentation(AssociationPresentation * association_presentation, set<string> & visited);
	void write_generalization_presentation(GeneralizationPresentation * generalization_presentation, set<string> & visited);
	void write_dependency_presentation(DependencyPresentation * dependency_presentation, set<string> & visited);
	
	//
	//
	//
	
	void write_integer(const REF::Attribute * integer);
	void write_name(const REF::Attribute * name);
	void write_boolean(const REF::Attribute * boolean);
	void write_aggregation_kind(const REF::Attribute * aggregation_kind);
	void write_call_concurrency_kind(const REF::Attribute * call_concurrency_kind);
	void write_changeable_kind(const REF::Attribute * changeable_kind);
	void write_ordering_kind(const REF::Attribute * ordering_kind);
	void write_parameter_direction_kind(const REF::Attribute * parameter_direction_kind);
	void write_scope_kind(const REF::Attribute * scope_kind);
	void write_visibility_kind(const REF::Attribute * visibility_kind);
	void write_diagram_kind(const REF::Attribute * diagram_kind);
	void write_multiplicity_type(const REF::Attribute * multiplicity_type);
	
	void write_integer(const Integer * integer);
	void write_name(const Name * name);
	void write_boolean(const Boolean * boolean);
	void write_aggregation_kind(const AggregationKind * aggregation_kind);
	void write_call_concurrency_kind(const CallConcurrencyKind * call_concurrency_kind);
	void write_changeable_kind(const ChangeableKind * changeable_kind);
	void write_ordering_kind(const OrderingKind * ordering_kind);
	void write_parameter_direction_kind(const ParameterDirectionKind * parameter_direction_kind);
	void write_scope_kind(const ScopeKind * scope_kind);
	void write_visibility_kind(const VisibilityKind * visibility_kind);
	void write_diagram_kind(const DiagramKind * diagram_kind);
	void write_multiplicity_type(const MultiplicityType * multiplicity_type);
	
    private:
	REF::Class * mRoot;
	typedef const type_info * TypeInfo;
	typedef void (Writer::*ClassHandler)(REF::Class *, bool);
	typedef void (Writer::*DataTypeHandler)(const REF::Attribute *);
	
	struct Compare { bool operator() (TypeInfo a, TypeInfo b) const { return a->before(*b); } };
	
	map<TypeInfo, ClassHandler, Compare> mClassHandlerMap;
	map<TypeInfo, DataTypeHandler, Compare> mDataTypeHandlerMap;
	
	XML::Stream * mStream;
    };
    
} // namespace UML

#endif // UML_WRITER_H
