// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef XML_SAX_BUILDER_H
#define XML_SAX_BUILDER_H

#include "sax_handler.h"

#include <stack>
#include <string>
using namespace std;

namespace XML {

    class Node;

    class SAXBuilder : public SAXHandler {
    public:
	SAXBuilder();
	~SAXBuilder();

	void warning(SAXParser * parser, const string & msg);
	void error(SAXParser * parser, const string & msg);
	void fatal(SAXParser * parser, const string & msg);

	void comment(SAXParser * parser, const string & comment);
	void start_document(SAXParser * parser);
	void end_document(SAXParser * parser);
	void start_element(SAXParser * parser, const string & name, const Properties & properties);
	void end_element(SAXParser * parser, const string & name);
	void characters(SAXParser * parser, const string & data);
	void reference(SAXParser * parser, const string & name);
	void cdata_block(SAXParser * parser, const string & data);

	Node * get_root() { return mRoot; }

    private:
	stack<Node *> mStack;
	string mCharacters;

	Node * mRoot;
    };

} // namespace XML

#endif // XML_SAX_BUILDER_H
