#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "sax_handler.h"

#include "foundation/macros.h"

namespace XML {

    const string &
    Properties::get_required_property(const string & name) const {
	const_iterator i = find(name);

	ASSERT(i != end());

	return i->second;
    }

    const string &
    Properties::get_implied_property_default(const string & name,
					     const string & default_value) const {
	const_iterator i = find(name);

	if(i == end()) {
	    return default_value;
	}
	else {
	    return i->second;
	}
    }

    bool
    Properties::get_implied_property(const string & name, string & value) const {
	const_iterator i = find(name);

	if(i == end()) {
	    return false;
	}
	else {
	    value = i->second;
	    return true;
	}
    }

    bool
    Properties::has_property(const string & name) const {
	return find(name) != end();
    }

    //
    //
    //

    SAXHandler::SAXHandler() : Object() {
    }

    SAXHandler::~SAXHandler() {
    }

} // namespace XML
