// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "tree.h"

#include "node.h"

#include "foundation/commands.h"
#if 0
#include "foundation/changes.h"
#endif

namespace XML {

    Tree::Tree() : Object() {
    }

    Tree::~Tree() {
	if(mRoot) {
	    mRoot->unref();
	}
    }

    void
    Tree::set_root(Node * root) {
	if(mRoot != root) {
	    begin_transaction();

	    Command * command = command_flip_argument(this, &Tree::set_root, root, mRoot);
#if 0
	    ChangeEvent * change = new ChangeRoleChanged(this, "root", root, mRoot);
#endif

	    // make the changes

	    if(mRoot) {
		mRoot->unref();
	    }

	    mRoot = root;

	    if(mRoot) {
		mRoot->ref();
	    }

	    // changes made

	    log_command(command);
#if 0
	    log_change(change);
#endif

#if 0
	    change->unref();
#endif
	    command->unref();

	    end_transaction();
	}
    }

} // namespace XML
